// * This code is licensed under:
// * JRunMC License, Version 1.0
// * - for license details see http://runmc.sourceforge.net/License.txt
// *
// * Copyright (c) 2005 by S.Chekanov (chekanov@mail.desy.de). 
// * All rights reserved.

package JRunMC.ui;

import JRunMC.util.*;


import java.io.*;
import java.awt.*;
import java.awt.event.*; 
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import javax.swing.filechooser.*;




public class TabTop extends JMenuBar {
  

  public static final long serialVersionUID = 108;
  // for menu 
  public javax.swing.JMenuBar menuBar;
  public javax.swing.JMenu fileMenu;
  public javax.swing.JMenu rmcMenu;
  public javax.swing.JMenu optMenu;
  public javax.swing.JMenu helpMenu;
  public javax.swing.JMenu toolsMenu;
  public javax.swing.JMenuItem About;
  public javax.swing.JMenuItem MChelp;
  public javax.swing.JMenuItem SysInfo; 
  public javax.swing.JMenuItem RUNMChelp;
  public javax.swing.JMenuItem SelfUpdate;
  public javax.swing.JMenuItem RUNMCpaper;
  public javax.swing.JMenuItem contentsMenuItem;
  public javax.swing.JMenuItem exitRunMC;
  public javax.swing.JMenuItem openMC;
  public javax.swing.JMenuItem openRMC;
  public javax.swing.JMenuItem saveMC;
  public javax.swing.JMenuItem saveRMC;
  public javax.swing.JMenuItem viewRMC;
  public javax.swing.JMenuItem editRMCinfo;
  public javax.swing.JMenuItem browserRMC;  
  public javax.swing.JMenuItem LookFeel;

  public javax.swing.JMenuItem Ceditor;
  public javax.swing.JMenuItem Heditor;

  public javax.swing.JRadioButtonMenuItem Sty0; 
  public javax.swing.JRadioButtonMenuItem Sty1;
  public javax.swing.JRadioButtonMenuItem Sty2;
  public javax.swing.JRadioButtonMenuItem Sty3;
  public javax.swing.JRadioButtonMenuItem Sty4; 
  public javax.swing.JRadioButtonMenuItem Sty5; 

//  public ButtonGroup group; 
  
  public TabTop() {
  
  
        fileMenu = new javax.swing.JMenu( ResourceLoader.getCommand("menu.file") );
        helpMenu = new javax.swing.JMenu( ResourceLoader.getCommand("menu.help") );
        rmcMenu = new javax.swing.JMenu( ResourceLoader.getCommand("menu.project") );
        toolsMenu=new javax.swing.JMenu( ResourceLoader.getCommand("menu.tools"));
        optMenu = new javax.swing.JMenu( ResourceLoader.getCommand("menu.option"));
        LookFeel = new javax.swing.JMenu( ResourceLoader.getCommand("menu.option.look"));

        Sty0 = new JRadioButtonMenuItem(SetEnv.defa, true);
        Sty1 = new JRadioButtonMenuItem(SetEnv.metal,false); 
        Sty2 = new JRadioButtonMenuItem(SetEnv.motif,false); 
        Sty3 = new JRadioButtonMenuItem(SetEnv.windows,false); 
        Sty4 = new JRadioButtonMenuItem(SetEnv.liquid,false);
        Sty5 = new JRadioButtonMenuItem("Standard",false);  

        Sty0.setHorizontalTextPosition(JMenuItem.RIGHT);
        Sty1.setHorizontalTextPosition(JMenuItem.RIGHT); 
        Sty2.setHorizontalTextPosition(JMenuItem.RIGHT);
        Sty3.setHorizontalTextPosition(JMenuItem.RIGHT);
        Sty4.setHorizontalTextPosition(JMenuItem.RIGHT);
        Sty5.setHorizontalTextPosition(JMenuItem.RIGHT);

 
      Sty0.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e)
      { SetEnv.Style=0; } });


      Sty1.addActionListener(new java.awt.event.ActionListener() { 
      public void actionPerformed(ActionEvent e)
      { SetEnv.Style=1; } });  
         
      Sty2.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e)
      { SetEnv.Style=2; } });

      Sty3.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e)
      { SetEnv.Style=3; } });

      Sty4.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e)
      { SetEnv.Style=4; } });

      Sty5.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e)
      { SetEnv.Style=5; } });


        ButtonGroup group = new ButtonGroup();
        group.add(Sty0);
        group.add(Sty1);
        group.add(Sty2);
        group.add(Sty3);
        group.add(Sty4); 
        group.add(Sty5); 
        LookFeel.add(Sty0); 
        LookFeel.add(Sty1);
        LookFeel.add(Sty2);
        LookFeel.add(Sty3);
        LookFeel.add(Sty4);
        LookFeel.add(Sty5);  


        openRMC = makeItem("menu.project.open", true );
        rmcMenu.add(openRMC);

        openMC = makeItem("menu.file.openmc", true );
        fileMenu.add(openMC);
       
        saveMC = makeItem("menu.file.savemc", true );
        fileMenu.add(saveMC);

        saveRMC = makeItem( "menu.project.save", true );
        rmcMenu.add(saveRMC);


        viewRMC = makeItem( "menu.project.info", true );
        rmcMenu.add(viewRMC);

        editRMCinfo = makeItem( "menu.project.info.edit", true );
        rmcMenu.add(editRMCinfo);


        browserRMC = makeItem( "menu.project.browser", true );
        rmcMenu.add(browserRMC);
 


        Ceditor = makeItem( "menu.tools.control.card", true );
        Heditor = makeItem( "menu.tools.histogram.editor", true );
        toolsMenu.add(Ceditor); 
        toolsMenu.add(Heditor);


        optMenu.add(LookFeel);          
        
      //  fileMenu.addSeparator();      

        exitRunMC = makeItem( "menu.file.exit", true );
        fileMenu.add(exitRunMC);
        this.add(fileMenu);

 
        MChelp = makeItem( "menu.help.mc", true );
        SysInfo = makeItem( "menu.help.system", true );
        RUNMChelp = makeItem( "menu.help.runmc", true );
        RUNMCpaper  = makeItem( "menu.help.paper", true );
        About  = makeItem( "menu.help.about", true );
        SelfUpdate = makeItem( "menu.help.selfupdate", true );
 

        helpMenu.add(RUNMChelp);
        helpMenu.add(RUNMCpaper);
        helpMenu.add(MChelp); 
        helpMenu.add(SelfUpdate);
        helpMenu.add(SysInfo);
        helpMenu.add(About); 
        
  
        this.add(rmcMenu); 
        this.add(toolsMenu);
        this.add(optMenu);


  //    this.add(new JSeparator());
      this.add(helpMenu); 
        
        
      }


private static JMenuItem makeItem ( String token, boolean enabled )
   {
      JMenuItem   item;

      item = new JMenuItem( ResourceLoader.getCommand( token ) );
      item.setActionCommand( token );
      item.setEnabled( enabled );
      item.addActionListener( Global.mainActionListener );
      return item;
   }


 
}



