// class to unzip RMC 
package JRunMC.util;

import java.awt.*;
import java.io.*;
import java.util.*;
import java.util.zip.*;
import javax.swing.*;

public class Unzipper {
private Unzipper() {}
private static byte[] buffer = new byte[16384];

public static void unzip(File file, Component parentComponent, File outputDir) throws ZipException, IOException {
unzip(new ZipFile(file), parentComponent, outputDir);
}

public static void unzip(File file, int mode, Component parentComponent, File outputDir) throws IOException {
unzip(new ZipFile(file, mode), parentComponent, outputDir);
}

public static void unzip(String name, Component parentComponent, File outputDir) throws IOException {
unzip(new ZipFile(name), parentComponent, outputDir);
}

public static void unzip(ZipFile zip, Component parentComponent, File outputDir) throws IOException {
if ( zip == null) {
throw new NullPointerException("outputDir is null");
}
int size = zip.size();
if (size > 0) {
if (outputDir == null) {
throw new NullPointerException("outputDir is null");
}
if (!outputDir.exists()) {
outputDir.mkdirs();
}
// ProgressMonitor monitor =
// new ProgressMonitor(parentComponent,
// "Unpacking " + zip.getName() + "...", "", 0, size);
// monitor.setMillisToDecideToPopup(0);
// monitor.setMillisToPopup(0);
Enumeration entries = zip.entries();
for ( int i = 0; entries.hasMoreElements(); ) {
ZipEntry entry = (ZipEntry) entries.nextElement();
/*if (entry.getMethod() == ZipEntry.DEFLATED)
System.out.println(" Inflating: "+entry.getName());
else
System.out.println(" Extracting: "+entry.getName());*/

// monitor.setNote(entry.getName());
File File = new File(outputDir, entry.getName());
File.getParentFile().mkdirs();
if (!entry.isDirectory()) {
InputStream in = null;
OutputStream out = null;
try {
in = zip.getInputStream(entry);
out = new FileOutputStream(File);
for (int n = 0; (n = in.read(buffer)) > -1; )
out.write(buffer, 0, n);
// monitor.setProgress(++i);
} finally {
if (out != null) {
try {
out.close();
} catch (IOException e) {
}
}
}
}
}
}
}

/*
public static void main(String[] args) throws ZipException, IOException
{
if (args.length !=2) {
System.err.println("Usage: java Unzipper <zip file> <output dir>");
System.exit(1);
}
long start = -System.currentTimeMillis();
unzip(args[0], null, new File(args[1]));
System.out.println(start+System.currentTimeMillis());

System.exit(0);
}
*/

}
