/* This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/


package com.io;

import javax.swing.JFileChooser;

import java.io.File;
import java.io.FileOutputStream;

import javax.swing.text.Document;
import javax.swing.text.Element;
import javax.swing.text.Segment;
import javax.swing.text.Position;


import java.util.zip.ZipOutputStream;
import java.util.zip.ZipEntry;


import com.utils.*;
import com.jpe.jpe;



public class ZipAs
{

	public ZipAs(jpe win, String g, Document doc2)
	{
		super();
		this.win = win;
		Utils = new Utils(win);

		jChooser.setDialogTitle("Zip Document As..");
		jChooser.setApproveButtonText("Zip it!");

		run(g, doc2);

	}

	public void run(String g, Document doc2)
	{

		String zipFile = new String();
		String newline = new String();

		if((g == null)|| (g == ""))
		{
			Utils.userMessage("Warning", "Please save file", 1);
			return;
		}

		//jChooser.setCurrentDirectory(new File(System.getProperty("user.home")));

		jChooser.rescanCurrentDirectory();

		if (JFileChooser.APPROVE_OPTION == jChooser.showSaveDialog(win))
    {
			zipFile = jChooser.getSelectedFile().getPath();
			win.repaint();
		} else return;



		//this segment ofcode used with permission
		//(C)1999-2000 Romain Guy
    //Released under GPL-2 license (see LICENSE)
    //guy.romain@bigfoot.com
    //www.jext.org
		//*****************************************
		//*****************************************
		try
		{
      win.setWaitCursor();
			//name of the zip folder
      ZipOutputStream out = new ZipOutputStream(new FileOutputStream(zipFile));
      //name of the file in folder(first entry)
      out.putNextEntry(new ZipEntry((new File(g)).getName()));

      newline = System.getProperty("line.separator");
      Element map = doc2.getDefaultRootElement();

      for (int i = 0; i < map.getElementCount() ; i++)
      {
        Element line = map.getElement(i);
        int start = line.getStartOffset();
        byte[] buf = (doc2.getText(start, line.getEndOffset() - start - 1) + newline).getBytes();
        out.write(buf, 0, buf.length);
      }
      out.closeEntry();
      out.close();
      win.setTextCursor();
		}catch(Exception ioe)
    {
      win.setStatus("IOException " + ioe + " occurred");
    }

		//*****************************************
		//*****************************************

	}


	private jpe win;
  private JFileChooser jChooser = new JFileChooser();
	private Utils Utils;



}




