CDECK  ID>, HWH2DD.
*CMZ :-        -27/02/01  17:04:16  by  Peter Richardson
*-- Author :    Peter Richardson
C-----------------------------------------------------------------------
      FUNCTION HWH2DD(ND,I,J,K,L,Z1,Z2)
C-----------------------------------------------------------------------
C     Returns the coefficient D1-10 from Nucl. Phys. B262 (1985) 235-262
C     N.B. THE STRONG COUPLING AND GV+/-GA ARE INCLUDED IN THE CROSS
C     SECTION ROUTINE
C     I-L are the particles (all outgoing)
C     Z1 and Z2 are the decay products of the Z
C-----------------------------------------------------------------------
      INCLUDE 'HERWIG65.INC'
      INTEGER ND,I,J,K,L,Z1,Z2
      DOUBLE COMPLEX HWH2DD,ZI,S,D,F
      PARAMETER(ZI=(0.0D0,1.0D0))
      COMMON/HWHEWS/S(8,8,2),D(8,8)
      COMMON/HWHZBB/F(8,8)
      IF(ND.EQ.1) THEN
        HWH2DD = ZI
      ELSEIF(ND.EQ.2) THEN
        HWH2DD =  ZI/F(J,K)/SQRT(TWO*D(I,K))
      ELSEIF(ND.EQ.3) THEN
        HWH2DD = -ZI/F(I,K)/SQRT(TWO*D(I,K))
      ELSEIF(ND.EQ.4) THEN
        HWH2DD = -ZI/F(K,L)/(F(Z1,I)+F(Z2,I)+F(Z1,Z2))
      ELSEIF(ND.EQ.5) THEN
        HWH2DD =  ZI/F(K,L)/(F(Z1,J)+F(Z2,J)+F(Z1,Z2))
      ELSEIF(ND.EQ.6) THEN
        HWH2DD =  ZI*HALF/F(J,L)/(F(J,L)+F(J,K)+F(K,L))/D(K,L)
      ELSEIF(ND.EQ.7) THEN
        HWH2DD = -ZI*HALF/F(I,K)/F(J,L)/D(K,L)
      ELSEIF(ND.EQ.8) THEN
        HWH2DD =  ZI*HALF/F(I,K)/(F(I,K)+F(I,L)+F(K,L))/D(K,L)
      ELSEIF(ND.EQ.9) THEN
        HWH2DD = -ZI/F(K,L)/(F(J,K)+F(J,L)+F(K,L))
      ELSEIF(ND.EQ.10) THEN
        HWH2DD =  ZI/F(K,L)/(F(I,K)+F(I,L)+F(K,L))
      ENDIF
      END
