CDECK  ID>, HWHS13.
*CMZ :-        -02/10/01  10:17:10  by  Peter Richardson
*-- Author :    Peter Richardson
C-----------------------------------------------------------------------
      SUBROUTINE HWHS13(ID,ME)
C-----------------------------------------------------------------------
C  Subroutine to calculate the helicity amplitudes for the 2-to-2 cross
C  section quark gluon --> fermion antisfermion (s-channel quark)
C  This is diagram 12 from DAMTP-2001-83 with the gauge choice L2=1
C-----------------------------------------------------------------------
      INCLUDE 'HERWIG65.INC'
      INTEGER NDIAHD
      PARAMETER(NDIAHD=10)
      DOUBLE COMPLEX ME(2,2,2,2),S,D,F3(2,2,8),F4(2,2,8),PRE,ZI
     &     ,F3M(2,2,8),F4M(2,2,8),FST(2,2,8),
     &     FTP(2,2,8,8),FTM(2,2,8,8),FUP(2,2,8,8),FUM(2,2,8,8)
      DOUBLE PRECISION A(2,NDIAHD),B(2,NDIAHD),MS(NDIAHD),MWD(NDIAHD),
     &     MA(4),MA2(4),MR(NDIAHD),SH,TH,UH,HWULDO,XMASS,PLAB,PRW,PCM
      INTEGER P1,P2,P3,ID,O(2),IDP(4+NDIAHD),DRTYPE(NDIAHD)
      COMMON/HWSPHC/F3,F4,F3M,F4M,FTP,FTM,FUP,FUM,FST,A,B,MS,MWD,MR,MA,
     &     MA2,SH,TH,UH,IDP,DRTYPE
      PARAMETER(ZI=(0.0D0,1.0D0))
      COMMON/HWHEWS/S(8,8,2),D(8,8)
      COMMON/HWHEWP/XMASS(10),PLAB(5,10),PRW(5,2),PCM(5,10)
      DATA O/2,1/
      EXTERNAL HWULDO
C--compute the propagator factor
      PRE =-SQRT(HWULDO(PCM(1,8),PCM(1,4)))/SQRT(TWO)/
     &      SQRT(HWULDO(PCM(1,1),PCM(1,2)))/(UH-MS(ID))
      DO 10 P1=1,2
      DO 10 P2=1,2
      DO 10 P3=1,2
      ME(P1,P2,P3,1) = PRE*A(O(P1),ID)*(
     &                       FUM(P1,  P2 ,1,1)*F3M(  P2 ,P3, 2)
     &                      +FUM(P1,O(P2),1, 2)*F3M(O(P2),P3,1))
 10   ME(P1,P2,P3,2) = ZERO
      END
