      PROGRAM PHOEX2
C**********************************************************************
C
C     example how to call PHOJET 1.04/1.05 without input cards
C
C**********************************************************************
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      SAVE
C
      PARAMETER (ZERO   =  0.D0,
     &           IZERO  =  0,
     &           ONE    =  1.D0,
     &           TWO    =  2.D0,
     &           OHALF  =  0.5D0,
     &           PI     =  3.14159265359D0,
     &           TWOPI  =  6.28318530718D0,
     &           TINY   =  1.D-10,
     &           DEPS   =  1.D-10)
C
      COMMON /GLOCMS/ ECM,PCM,PMASS(2),PVIRT(2),IFPAP(2),IFPAB(2)
C
C  phojet global process flags
      COMMON /PROCES/ IPROCE,IDNODF,IDIFR1,IDIFR2,IDDPOM,IPRON(15,4)
C
      CHARACTER*8 MDLNA
      COMMON /MODELS/ MDLNA(50),ISWMDL(50),PARMDL(200),IPAMDL(200)
C
      DIMENSION IDPDG(6),ECMTAB(3),PAMTAB(6),P1(4),P2(4)
      DATA IDPDG / 2212, 2212, 22, 2212, 22, 22 /
      DATA ECMTAB / 10.D0, 20.D0, 50.D0 /
      DATA PAMTAB / 0.938D0, 0.938D0, 0.D0, 0.938D0, 2*0.D0 /
C
C  *********** hp compiler settings ******************************
*     ON DOUBLE PRECISION UNDERFLOW IGNORE
*     ON REAL UNDERFLOW IGNORE
C  **************************************************************
C
C
C  general initialization of phojet data structures
      CALL PHOINP(-1,IREJ)
C
C  switch elastic, quasi-elastic and single-diff. processes on
      IPRON(2,1) = 1
      IPRON(3,1) = 1
      IPRON(4,1) = 1
      IPRON(5,1) = 1
      IPRON(6,1) = 1
C  set new pomeron PDF
      CALL SETPDF(45,IDUM,2,0,0,0,-1)
C  set new PDF for the photon (SaS-1D)
*     CALL SETPDF(22,IDUM,1,1,4,0,-1)
C
C  loop over particle and energy combinations
      DO 100 I=1,3
        DO 200 K=1,3
          NEVE = 10000
          ECM = ECMTAB(K)
          IDPDGA = IDPDG(2*I-1)
          IDPDGB = IDPDG(2*I)
          PMASS1 = PAMTAB(2*I-1)
          PMASS2 = PAMTAB(2*I)
C
C  CMS kinematics
          S=ECM**2
          PM1 = PMASS1**2
          PM2 = PMASS2**2
          PCM = SQRT(S**2 - TWO*PM1*S - TWO*PM2*S - TWO*PM1*PM2
     &          + PM1**2 + PM2**2)/(TWO*ECM)
          EE = SQRT( PM1 + PCM**2 )
          P1(1) = ZERO
          P1(2) = ZERO
          P1(3) = PCM
          P1(4) = EE
          P2(1) = ZERO
          P2(2) = ZERO
          P2(3) = -PCM
          P2(4) = ECM-EE
C
C  initialize phojet for given energy, particle combination
          PVIR = 0.D0
          CALL SETPAR(1,IDPDGA,0,PVIR)
          CALL SETPAR(2,IDPDGB,0,PVIR)
          CALL EVENT(-1,P1,P2,SIGMAX,IREJ)
C
C  initialize histograms
          CALL POMINB(-1,ZERO)
C
C  event generation loop
          ITRY = 0
          WRITE(6,'(//1X,A,2I7,I10//)') 
     &      'CALCULATION FOR IDPDGA,IDPDGB,NEVE:',IDPDGA,IDPDGB,NEVE
          DO 50 J=1,NEVE
 55         CONTINUE
            ITRY = ITRY+1
            WGHT = 1.D0
            CALL EVENT(1,P1,P2,SIGCUR,IREJ)
            IF(IREJ.NE.0) GOTO 55
C
C  fill histograms
            CALL LUHEPC(1)
            CALL POMINB(1,ONE)
 50       CONTINUE
C
C  statistics output
          CALL EVENT(-2,P1,P2,SIGMAX,IREJ)
C
C  output of histograms
          CALL POMINB(-2,ONE)
 200    CONTINUE
 100  CONTINUE
C
      END
C
C
      SUBROUTINE POMINB(IMODE,WEIGHT)
C**********************************************************************
C
C     input:  IMODE      -1  initialization
C                        -2  output of results
C                         1  take event statistics
C             WEIGHT     weight of event (if necessary)
C                        for final output: corresponding cross section
C
C**********************************************************************
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      SAVE
C
      PARAMETER (ZERO   =  0.D0,
     &           IZERO  =  0,
     &           ONE    =  1.D0,
     &           TWO    =  2.D0,
     &           OHALF  =  0.5D0,
     &           PI     =  3.14159265359D0,
     &           TWOPI  =  6.28318530718D0,
     &           TINY   =  1.D-10,
     &           DEPS   =  1.D-10)
C
      COMMON /GLOCMS/ ECM,PCM,PMASS(2),PVIRT(2),IFPAP(2),IFPAB(2)
C
C...Note that HEPEVT is in double precision according to LEP 2 standard.
      PARAMETER (NMXHEP=2000)
      COMMON/HEPEVT/NEVHEP,NHEP,ISTHEP(NMXHEP),IDHEP(NMXHEP),
     &JMOHEP(2,NMXHEP),JDAHEP(2,NMXHEP),PHEP(5,NMXHEP),VHEP(4,NMXHEP)
      DOUBLE PRECISION PHEP,VHEP
C
      CHARACTER*72 TITLE
      DIMENSION XLIMB(40)
      DIMENSION ETRANS(4),PCSUM(4)
C
C  extract statistics
C
      IF(IMODE.EQ.1) THEN
C  main particle loop
        ETRANS(1) = ZERO
        ETRANS(2) = ZERO
        ETRANS(3) = ZERO
        ETRANS(4) = ZERO
        PCSUM(1) = ZERO
        PCSUM(2) = ZERO
        PCSUM(3) = ZERO
        PCSUM(4) = ZERO
        I0 = 0
        IPARTC = 0
        IPARTF = 0
        DO 100 I=1,NHEP
C  final particle
          IF(ISTHEP(I).EQ.1) THEN
            IPARTF = IPARTF + 1
C  kinematic variables
            VHEP(1,I) = 0.D0
            VHEP(2,I) = 0.D0
            VHEP(3,I) = -99999.D0
            VHEP(4,I) = -99999.D0
            PT2 = PHEP(1,I)**2+PHEP(2,I)**2
            IF(PT2.LT.1.D-15) THEN
              WRITE(6,'(1X,A,I6,2E15.7)') 'POMINB:WARNING:ZERO-PT',I,
     &          PHEP(1,I),PHEP(2,I)
              I0 = I0+1
              GOTO 99
            ENDIF
            PABS = SQRT(PT2+PHEP(3,I)**2)
            IF(PABS.LT.1.D-8) GOTO 99
            PT = SQRT(PT2)
            IF(ABS(PHEP(3,I)).GE.PABS) GOTO 99
            THETA = ACOS(PHEP(3,I)/PABS)
            IF((THETA.LT.1.D-8)
     &        .OR.(PI-THETA.LT.1.D-8)) GOTO 99
C  pseudorapidity
            ETA = -LOG(TAN(THETA/TWO))
C  transverse energy
            ET = PHEP(4,I)*SIN(THETA)
C  rapidity
            PPLUS  = PHEP(4,I)+PHEP(3,I)
            PMINUS = PHEP(4,I)-PHEP(3,I)
            YY = -99999.D0
            IF((PPLUS*PMINUS).GT.DEPS) YY = OHALF*LOG(PPLUS/PMINUS)
C  save kinematic variables
            VHEP(1,I) = PT
            VHEP(2,I) = ET
            VHEP(3,I) = ETA
            VHEP(4,I) = YY
          ENDIF
 99       CONTINUE
 100    CONTINUE
C
        IACCEP = IACCEP+1
        DO 200 I=1,NHEP
C  final particle
          IF(ISTHEP(I).EQ.1) THEN
C  particle charge
            ICHAR = KLU(I,6)/3
            PT = VHEP(1,I)
            ET = VHEP(2,I)
            ETA = VHEP(3,I)
            YY = VHEP(4,I)
            XF = 2.D0*PHEP(3,I)/ECM
            IF(PT.LT.1.D-8) GOTO 199
C  particle statistics
*           CALL PARSTA(IMPART(I),PHEP(4,I),VHEP(1,I),VHEP(3,I),2)
C  transverse energy distributions
            ETRANS(1) = ETRANS(1)+ET
            IF((ETA.GT.-3.D0).AND.(ETA.LT.3.D0)) THEN
              ETRANS(2) = ETRANS(2)+ET
              IF((ETA.GT.-2.D0).AND.(ETA.LT.2.D0)) THEN
                ETRANS(3) = ETRANS(3)+ET
                IF((ETA.GT.-1.D0).AND.(ETA.LT.1.D0)) THEN
                  ETRANS(4) = ETRANS(4)+ET
                ENDIF
              ENDIF
            ENDIF
C  transverse energy density
            CALL FILHIS(ETA,ET,IEETA)
C  charged particles
            IF(ICHAR.NE.0) THEN
              IPARTC = IPARTC+1
C  pt distribution of all charged hadrons
              CALL FILHIS(PT,WEIGHT/PT,ICPTTO)
C  seagull
              CALL FILHIS(XF,PT,ISEAG1)
              IF(ICHAR.GT.0) CALL FILHIS(XF,PT,ISEAG2)
              IF(ICHAR.LT.0) CALL FILHIS(XF,PT,ISEAG3)
              PT2 = PT*PT
              CALL FILHIS(XF,PT2,ISEAG4)
C  rapidity distribution of all charged hadrons
              CALL FILHIS(YY,WEIGHT,IRAPC)
C  pseudorapidity distribution of all charged hadrons
              CALL FILHIS(ETA,WEIGHT,IPSECL)
            ENDIF
 199        CONTINUE
          ENDIF
 200    CONTINUE
C
C  multiplicity charged particles
        CALL FILHIS(DBLE(IPARTC),ONE,IMULC)
C  transverse energy distribution (LAB)
        CALL FILHIS(ETRANS(1),ONE,IETRA1)
        CALL FILHIS(ETRANS(2),ONE,IETRA2)
        CALL FILHIS(ETRANS(3),ONE,IETRA3)
        CALL FILHIS(ETRANS(4),ONE,IETRA4)
C  event ready, calculate statistical errors
        CALL ADDHIS(IEETA)
        CALL ADDHIS(ICPTTO)
        CALL ADDHIS(ISEAG1)
        CALL ADDHIS(ISEAG2)
        CALL ADDHIS(ISEAG3)
        CALL ADDHIS(ISEAG4)
        CALL ADDHIS(IRAPC)
        CALL ADDHIS(IPSECL)
        CALL ADDHIS(IMULC)
        CALL ADDHIS(IETRA1)
        CALL ADDHIS(IETRA2)
        CALL ADDHIS(IETRA3)
        CALL ADDHIS(IETRA4)
C
C  initialization
C
      ELSE IF(IMODE.EQ.-1) THEN
        IACCEP = 0
*       CALL PARSTA(2,ZERO,ZERO,ZERO,-1)
        XLIM1 = -2.*LOG(ECM)
        XLIM2 = 2.*LOG(ECM)
        CALL NEWHIS(XLIM1,XLIM2,ZERO,XLIMB,48,IEETA)
        CALL NEWHIS(ZERO,5.D0,ZERO,XLIMB,50,ICPTTO)
        XLIM1 = -1.D0
        XLIM2 =  1.D0
        CALL NEWHIS(XLIM1,XLIM2,ZERO,XLIMB,40,ISEAG1)
        CALL NEWHIS(XLIM1,XLIM2,ZERO,XLIMB,40,ISEAG2)
        CALL NEWHIS(XLIM1,XLIM2,ZERO,XLIMB,40,ISEAG3)
        CALL NEWHIS(XLIM1,XLIM2,ZERO,XLIMB,40,ISEAG4)
        XLIM1 = -2.*LOG(ECM)
        XLIM2 = 2.*LOG(ECM)
        CALL NEWHIS(XLIM1,XLIM2,ZERO,XLIMB,48,IRAPC)
        CALL NEWHIS(XLIM1,XLIM2,ZERO,XLIMB,48,IPSECL)
        XLIM1 = 0.D0
        XLIM2 = 50
        CALL NEWHIS(XLIM1,XLIM2,ZERO,XLIMB,50,IMULC)
        CALL NEWHIS(0.D0,25.D0,ZERO,XLIMB,50,IETRA1)
        CALL NEWHIS(0.D0,25.D0,ZERO,XLIMB,50,IETRA2)
        CALL NEWHIS(0.D0,25.D0,ZERO,XLIMB,50,IETRA3)
        CALL NEWHIS(0.D0,25.D0,ZERO,XLIMB,50,IETRA4)
C
C  final output
C
      ELSE IF(IMODE.EQ.-2) THEN
        FACMC = 1.D0
        EVENTS = DBLE(IACCEP)
*       CALL PARSTA(2,EVENTS,ZERO,ZERO,-2)
        TITLE = 'TRANSVERSE ENERGY DET/DETA (GeV)'
        CALL OUTHIS(IEETA,0,TITLE,FACMC,0)
        TITLE = 'PT DIST. CHARGED HADRONS DSIG/PT*DPT (nb/GeV**2)'
        CALL OUTHIS(ICPTTO,1,TITLE,FACMC,0)
        TITLE = 'SEAGULL ALL CHARGED'
        CALL OUTHIS(ISEAG1,0,TITLE,FACMC,2)
        TITLE = 'SEAGULL ALL POSITIVELY CHARGED'
        CALL OUTHIS(ISEAG2,0,TITLE,FACMC,2)
        TITLE = 'SEAGULL ALL NEGATIVELY CHARGED'
        CALL OUTHIS(ISEAG3,0,TITLE,FACMC,2)
        TITLE = ' PT**2 SEAGULL ALL CHARGED'
        CALL OUTHIS(ISEAG4,0,TITLE,FACMC,2)
        TITLE = 'PSEUDO RAPIDITY CHARGED HADRONS DN/DETA (LAB SYSTEM)'
        CALL OUTHIS(IPSECL,0,TITLE,FACMC,0)
        TITLE = 'CHARGED MULTIPLICITY DISTRIBUTION DPN/DN'
        CALL OUTHIS(IMULC,1,TITLE,FACMC,0)
        TITLE = 'TRANSVERSE ENERGY 1/N DN/DET (GeV**-1)'
        CALL OUTHIS(IETRA1,1,TITLE,FACMC,0)
        TITLE = 'TRANSVERSE ENERGY 1/N DN/DET (GeV**-1) ABS(ETA)<3'
        CALL OUTHIS(IETRA2,1,TITLE,FACMC,0)
        TITLE = 'TRANSVERSE ENERGY 1/N DN/DET (GeV**-1) ABS(ETA)<2'
        CALL OUTHIS(IETRA3,1,TITLE,FACMC,0)
        TITLE = 'TRANSVERSE ENERGY 1/N DN/DET (GeV**-1) ABS(ETA)<1'
        CALL OUTHIS(IETRA4,1,TITLE,FACMC,0)
      ENDIF
      END
C******************************************************************
C
C
C  dummy routines to satisfy linker
C
C
      SUBROUTINE POHIST(I,X)
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      END
      SUBROUTINE POLUHI(I,X)
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      END
C******************************************************************
