C
C
      SUBROUTINE ACTPDF(IDPDG,PXMASS,K)
C***************************************************************
C
C     activate PDF for QCD calculations
C
C     input:      IDPDG    PDG particle number
C                 PXMASS   particle mass (photon: virtuality (GeV**2))
C                 K        1  first PDF in COMMON /PARPDF/
C                          2  second PDF in COMMON /PARPDF/
C                         -2  write current settings
C
C     output:     COMMON /PARPDF/
C
C***************************************************************
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      SAVE
C
      PARAMETER (NMAXD=100)
      COMMON /DEBUG/ IDEB(NMAXD),KSPOM,KHPOM,KSREG,KHDIR,KACCEP,
     &  KSTRG,KHTRG,KSLOO,KHLOO,KSDPO,KHDPO,KEVENT,KSOFT,KHARD
C
      CHARACTER*8 PDFNAM
      COMMON /PARPDF/ PDFLAM(2),PDFQ2M(2),PDFNAM(2),IPARID(2),PARVI(2),
     &                IPAVA(2),ITYPE(2),IGRP(2),ISET(2),IEXT(2),NPAOLD
C
      IF(K.GT.0) THEN
        CALL SETPDF(IDPDG,ITYPE(K),IGRP(K),ISET(K),IEXT(K),IPAVA(K),1)
        IPARID(K) = IDPDG
        PARVI(K) = PXMASS
        CALL GETPDF(K,PDFNAM(K),PDFLAM(K),PDFQ2M(K),Q2MA,XMI,XMA)
        IF(IDEB(2).GE.20) THEN
          WRITE(6,'(1X,A)')
     &      'ACTPDF:DEBUG:LAMBDA,Q2MIN,NAME,ITYPE,IPAR,ISET,IEXT,PAR'
          WRITE(6,'(1X,A,I2,2E12.3,2X,A8,4I4,I7,E11.3)') 'SIDE',K,
     &      PDFLAM(K),PDFQ2M(K),PDFNAM(K),ITYPE(K),IGRP(K),ISET(K),
     &      IEXT(K),IPARID(K),PARVI(K)
        ENDIF
        NPAOLD = K
      ELSE IF(K.EQ.-2) THEN
        WRITE(6,'(1X,A)')
     &    'ACTPDF:DEBUG:LAMBDA,Q2MIN,NAME,ITYPE,IPAR,ISET,IEXT,PAR'
        WRITE(6,'(1X,A,2E12.3,2X,A8,4I4,I7,E11.3)') 'SIDE 1:',PDFLAM(1),
     &    PDFQ2M(1),PDFNAM(1),ITYPE(1),IGRP(1),ISET(1),IEXT(1),
     &    IPARID(1),PARVI(1)
        WRITE(6,'(1X,A,2E12.3,2X,A8,4I4,I7,E11.3)') 'SIDE 2:',PDFLAM(2),
     &    PDFQ2M(2),PDFNAM(2),ITYPE(2),IGRP(2),ISET(2),IEXT(2),
     &    IPARID(2),PARVI(2)
      ELSE
        WRITE(6,'(/1X,A,2I4)') 'ACTPDF:ERROR:INVALID ARGUMENTS',
     &    IDPDG,K
        CALL POABRT
      ENDIF
      END
