C
C
      DOUBLE PRECISION FUNCTION CONN1(BETA)
C***********************************************************************
C
C    auxiliary function to determine parameters of soft
C    pt distribution  dNs/dP_t = P_t * AAS * EXP(-BETA*P_t)
C
C    internal factors: FS  number of soft partons in soft Pomeron
C                      FH  number of soft partons in hard Pomeron
C
C***********************************************************************
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      SAVE
      PARAMETER (ZERO =  0.D0,
     &           ONE  =  1.D0,
     &           TWO  =  2.D0)
      COMMON /AVKLMN/ AVERI,AVERK,AVERL,AVERM,AVERN
      COMMON /XSECPT/ SIGS,DSIGHP,SIGH,FS,FH,BETAS(3),AAS,PTCON
C
      XX = BETA*PTCON
      AAS = DSIGHP*EXP(XX)/PTCON
      IF(ABS(XX).LT.1.D-3) THEN
        FF = AAS/TWO*PTCON**2
      ELSE
        FF = FS*SIGS+FH*SIGH
     &       -AAS/BETA**2*(ONE-(ONE+BETA*PTCON)*EXP(-XX))
      ENDIF
      CONN1 = FF
C
*     WRITE(6,'(1X,A,3E12.3)') 'CONN1:BETA,AAS,FF',BETA,AAS,FF
*     WRITE(6,'(1X,A,3E12.3)') 'CONN1:SIGS,SIGH,DSIGH',SIGS,SIGH,DSIGHP
      END
