C
C
      INTEGER FUNCTION ICONV2(ID,NN)
C*********************************************************************
C
C     conversion of quark numbering scheme
C
C     input:   PDG parton numbering
C              for diquarks:  NN number of the constituent quark
C                             (e.g. ID=2301,NN=1 -> ICONV2=1)
C
C     output:  BAMJET particle codes
C              1 u     7 a-u
C              2 d     8 a-d
C              3 s     9 a-s
C              4 c    10 a-c
C
C*********************************************************************
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      SAVE
C
      IDA = ABS(ID)
C  diquarks
      IF(IDA.GT.6) THEN
        IDA = IDA/(10**(4-NN))
        IDA = MOD(IDA,10)
      ENDIF
C  exchange up and dn quarks
      IF(IDA.EQ.1) THEN
        IDA = 2
      ELSE IF(IDA.EQ.2) THEN
        IDA = 1
      ENDIF
C  antiquarks
      IF(ID.LT.0) IDA = IDA+6
      ICONV2 = IDA
      END
