C
C
      SUBROUTINE POFRAG(IREJ)
C********************************************************************
C
C     do all fragmentation of chains
C
C     output:  IREJ    0   successful
C                      1   rejection
C                     50   rejection due to user cutoffs
C
C********************************************************************
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      SAVE
C
      PARAMETER (ZERO   =  0.D0,
     &           ONE    =  1.D0,
     &           TWO    =  2.D0,
     &           OHALF  =  0.5D0,
     &           PI     =  3.14159265359D0,
     &           EPS    =  1.D-30,
     &           TINY   =  1.D-6)
      PARAMETER (NMAXD=100)
      COMMON /DEBUG/ IDEB(NMAXD),KSPOM,KHPOM,KSREG,KHDIR,KACCEP,
     &  KSTRG,KHTRG,KSLOO,KHLOO,KSDPO,KHDPO,KEVENT,KSOFT,KHARD
C
      COMMON /GLOCMS/ ECM,PCM,PMASS(2),PVIRT(2),IFPAP(2),IFPAB(2)
      CHARACTER*8 MDLNA
      COMMON /MODELS/ MDLNA(50),ISWMDL(50),PARMDL(200),IPAMDL(200)
C
      PARAMETER (NMXHEP=2000)
      COMMON/HEPEVS/NEVHEP,NHEP,ISTHEP(NMXHEP),IDHEP(NMXHEP),
     &JMOHEP(2,NMXHEP),JDAHEP(2,NMXHEP),PHEP(5,NMXHEP),VHEP(4,NMXHEP)
      COMMON/HEPEVE/IMPART(NMXHEP),IPHIST(2,NMXHEP),ICOLOR(2,NMXHEP)
C
      PARAMETER (MSTR=100)
      COMMON /STRING/ GAMBET(4,MSTR),NPOS(3,MSTR),NCODE(MSTR),
     &     IPAR1(MSTR),IPAR2(MSTR),IPAR3(MSTR),IPAR4(MSTR),
     &     NNCH(MSTR),IBHAD(MSTR),ISTR
C
C  single precision interface
**sr 29.04. commented to use dp-JETSET
      REAL PLU,RQLUN
C  LUND particle data
**sr 29.04. commented to use dp-JETSET
      REAL PARU,PARJ
      COMMON/LUDAT1/MSTU(200),PARU(200),MSTJ(200),PARJ(200)
**sr 29.04. commented to use dp-JETSET
      REAL P,V
**sr 29.04.  LUJETS array-dimensions increased
      COMMON/LUJETS/N,K(4000,5),P(4000,5),V(4000,5)
C     COMMON/LUJETS/N,K(8000,5),P(8000,5),V(8000,5)
**
C
      DIMENSION IJOIN(100)
C
      IREJ = 0
      IF(ABS(ISWMDL(6)).GT.3) THEN
        WRITE(6,'(/1X,A,I3)') 'POFRAG:ERROR:ISWMDL(6)',ISWMDL(6)
        CALL POABRT
      ELSE
C  jetset fragmentation (involving gluons)
        IP = 0
        DO 300 I=1,ISTR
C  write final particles/resonances to jetset
          IF(NCODE(I).EQ.-99) THEN
            II = NPOS(1,I)
            IP = IP+1
            P(IP,1) = PHEP(1,II)
            P(IP,2) = PHEP(2,II)
            P(IP,3) = PHEP(3,II)
            P(IP,4) = PHEP(4,II)
            P(IP,5) = PHEP(5,II)
            K(IP,1) = 1
            K(IP,2) = IDHEP(II)
            K(IP,3) = 0
            K(IP,4) = 0
            K(IP,5) = 0
            IPHIST(2,II) = IP
C  write partons to jetset
          ELSE IF(NCODE(I).GE.0) THEN
            K1 = JMOHEP(1,NPOS(1,I))
            K2 = MAX(JMOHEP(1,NPOS(1,I)),-JMOHEP(2,NPOS(1,I)))
            IJ = 0
            DO 400 II=K1,K2
              IP = IP+1
              P(IP,1) = PHEP(1,II)
              P(IP,2) = PHEP(2,II)
              P(IP,3) = PHEP(3,II)
              P(IP,4) = PHEP(4,II)
              P(IP,5) = PHEP(5,II)
              K(IP,1) = 1
              K(IP,2) = IDHEP(II)
              K(IP,3) = 0
              K(IP,4) = 0
              K(IP,5) = 0
              IPHIST(2,II) = IP
              IJ = IJ+1
              IJOIN(IJ) = IP
              CALL QUASTA(IDHEP(II),IFPAP(1),7)
 400        CONTINUE
            II = JMOHEP(2,NPOS(1,I))
            IF((II.GT.0).AND.(II.NE.K1)) THEN
              IP = IP+1
              P(IP,1) = PHEP(1,II)
              P(IP,2) = PHEP(2,II)
              P(IP,3) = PHEP(3,II)
              P(IP,4) = PHEP(4,II)
              P(IP,5) = PHEP(5,II)
              K(IP,1) = 1
              K(IP,2) = IDHEP(II)
              K(IP,3) = 0
              K(IP,4) = 0
              K(IP,5) = 0
              IPHIST(2,II) = IP
              IJ = IJ+1
              IJOIN(IJ) = IP
              CALL QUASTA(IDHEP(II),IFPAP(1),7)
            ENDIF
            N = IP
C  connect partons to chains
            CALL LUJOIN(IJ,IJOIN)
          ENDIF
 300    CONTINUE
C  set Lund counter
        N = IP
C
        IF(IDEB(22).GE.25) THEN
          WRITE(6,'(//1X,A)')
     &      'POFRAG:DEBUG:CHAIN SYSTEM BEFORE FRAGMENTATION'
          CALL POPREV(2)
        ENDIF
C  fragment complete parton configuration
        IF(IP.GT.0) THEN
C  final state evolution
          IF((ISWMDL(8).EQ.1).OR.(ISWMDL(8).EQ.3)) THEN
            ISH = 0
            DO 125 I=3,NHEP
              IF((IPHIST(2,I).GT.0)
     &          .AND.(IPHIST(2,I).LE.IP)
     &          .AND.(IPHIST(1,I).LE.-100)) THEN
                ISH = ISH+1
                IJOIN(ISH) = I
              ENDIF
 125        CONTINUE
            IF(ISH.GE.2) THEN
              DO 130 K1=1,ISH
                IF(IJOIN(K1).EQ.0) GOTO 130
                I = IJOIN(K1)
                DO 135 K2=K1+1,ISH
                  IF(IJOIN(K2).EQ.0) GOTO 135
                  II = IJOIN(K2)
                  IF(IPHIST(1,I).EQ.IPHIST(1,II)) THEN
                    PT1 = SQRT(PHEP(1,II)**2+PHEP(2,II)**2)
                    PT2 = SQRT(PHEP(1,I)**2+PHEP(2,I)**2)
                    RQLUN = MIN(PT1,PT2)
                    IF(IDEB(22).GE.10) WRITE(6,'(1X,A,2I5,E12.4)')
     &                'POFRAG:DEBUG:LUSHOW CALLED',I,II,RQLUN
                    CALL LUSHOW(IPHIST(2,I),IPHIST(2,II),RQLUN)
                    IJOIN(K1) = 0
                    IJOIN(K2) = 0
                    GOTO 130
                  ENDIF
 135            CONTINUE
 130          CONTINUE
            ENDIF
          ENDIF
C  hadronization and decay
          IF(ISWMDL(6).NE.0) THEN
            II = MSTU(21)
            MSTU(21) = 1
            CALL LUEXEC
            MSTU(21) = II
C  event accepted?
            IF(MSTU(24).NE.0) THEN
              IF(IDEB(22).GE.2) THEN
                WRITE(6,'(1X,A,I12,I3)') 
     &            'POFRAG:WARNING:REJECTION BY JETSET (EV/IERR)',
     &            KEVENT,MSTU(24)
                CALL POPREV(2)
              ENDIF
              IREJ = 1
              RETURN
            ENDIF
          ENDIF
C
          NEVHEP = NHEP+1
C  copy hadrons back to HEPEVE (sorted by chains)
          NLINES = KLU(0,1)
          DO 155 II=1,ISTR
            IF(NCODE(II).GE.0) THEN
              K1 = IPHIST(2,NPOS(2,II))
              K2 = IPHIST(2,-NPOS(3,II))
            ELSE IF(NCODE(II).EQ.-99) THEN
              K1 = IPHIST(2,NPOS(1,II))
              K2 = K1
            ELSE
              GOTO 149
            ENDIF
            DO 160 J=1,NLINES
              IF(KLU(J,7).EQ.1) THEN
                IPMOTH = KLU(J,15)
                IF((IPMOTH.GE.K1).AND.(IPMOTH.LE.K2)) THEN
                  IBAM = MCIHAD(KLU(J,8))
                  IF(IBAM.EQ.99999) THEN
                    IF(IDEB(22).GE.2) THEN
                      WRITE(6,'(/1X,A)')
     &                  'POFRAG:WARNING:LUND ERROR:REJECTION'
                      CALL POPREV(2)
                    ENDIF
                    IREJ = 1
                    RETURN
                  ENDIF
                  PX = PLU(J,1)
                  PY = PLU(J,2)
                  PZ = PLU(J,3)
                  HE = PLU(J,4)
C  check mass, do fine corrections
                  XMB = PLU(J,5)**2
                  PABS = PX**2+PY**2+PZ**2
                  XMA = HE**2-PABS
                  PABS = SQRT(PABS)
                  DELT = 0.5D0*(XMB-XMA)/(HE+PABS)
                  HE = HE+DELT
                  DELT = (1.D0-DELT/PABS)
                  PX = PX*DELT
                  PY = PY*DELT
                  PZ = PZ*DELT
C
                  IS = 1
                  IF(IBAM.EQ.0) THEN
                    IF(ISWMDL(6).EQ.0) THEN
                      IS = -1
                    ELSE
                      IF(IDEB(22).GE.2) THEN
                        WRITE(6,'(/1X,A)')
     &                    'POFRAG:WARNING:LUND ERROR:REJECTION'
                        CALL POPREV(2)
                      ENDIF
                      IREJ = 1
                      RETURN
                    ENDIF
                  ENDIF
                  CALL REGPAR(IS,KLU(J,8),IBAM,NPOS(1,II),0,PX,PY,PZ,
     &              HE,J,0,0,0,IPOS,1)
                  ISTHEP(IPOS) = 1
                ENDIF
              ENDIF
 160        CONTINUE
 149        CONTINUE
 155      CONTINUE
        ENDIF
      ENDIF
C  debug event status
      IF(IDEB(22).GE.15) THEN
        WRITE(6,'(//1X,A)')
     &    'POFRAG:DEBUG:PARTICLES AFTER FRAGMENTATION'
        CALL POPREV(2)
      ENDIF
      END
