C
C
      SUBROUTINE POHXPT(ECMH,PT,IPRO,DSIGMC)
C**********************************************************************
C
C     differential cross section DSIG/DPT
C
C     input:  ECMH     CMS energy of scattering system
C             PT       parton PT
C             IPRO     1  resolved processes
C                      2  direct processes
C                      3  resolved and direct processes
C
C     output: DSIGMC(0:12) QCD-PM cross sections dsigma/dpt
C
C**********************************************************************
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      SAVE
C
      PARAMETER ( MAXPRO = 16 )
      COMPLEX*16 DSIGMC
      DIMENSION  DSIGMC(0:MAXPRO)
      PARAMETER ( TINY= 1.D-10, ONEP1=1.1, EPS=1.D-25)
      COMMON /HACONS/ PI,PI2,PI4,GEV2MB
      CHARACTER*8 MDLNA
      COMMON /MODELS/ MDLNA(50),ISWMDL(50),PARMDL(200),IPAMDL(200)
C  CM system of Pomeron/Reggeon exchange
      COMMON /POMCMS/ ECMP,PCMP,PMASSP(2),PVIRTP(2),GAMBEP(4),
     &                SIDP,CODP,SIFP,COFP,NPOSP(2),
     &                IDPDG1,IDBAM1,IDPDG2,IDBAM2
      COMMON /HAGAUP/ NGAUP1,NGAUP2,NGAUET,NGAUIN,NGAUSO
      COMMON /HAPARA/ ALPHAS,Q0SQR,ALASQR,BQCD,NPD,NF,NHA,NHB
      COMMON /HADRON/ QMASS(6),BET,PCOUDI,PNORM,VALPRG(2),NFS
      COMPLEX*16 DSIG1
      DIMENSION  DSIG1(0:MAXPRO)
      DIMENSION ABSZ(32),WEIG(32)
**sr 29.04. commented to use dp-JETSET
      REAL ULALEM,SSR
**
C
      DO 10 M=0,MAXPRO
        DSIGMC(M) = CMPLX(0.D0,0.D0)
        DSIG1(M)  = CMPLX(0.D0,0.D0)
 10   CONTINUE
C
C  resolved and direct processes
      AMT = 2.D0*PT/ECMH
      IF ( AMT.GE.1.D0 ) RETURN
      ECU = LOG((SQRT(1.D0-AMT*AMT)+1.D0)/AMT)
      ECL =-ECU
      NPOINT = NGAUET
      CALL GSET(ECL,ECU,NPOINT,ABSZ,WEIG)
      DO 30 I=1,NPOINT
        DSIG1(9)  = CMPLX(0.D0,0.D0)
        DSIG1(15) = CMPLX(0.D0,0.D0)
        IF(IPRO.EQ.1) THEN
          CALL POHXR2(ECMH,PT,ABSZ(I),DSIG1)
        ELSE IF(IPRO.EQ.2) THEN
          CALL POHXD2(ECMH,PT,ABSZ(I),DSIG1)
        ELSE
          CALL POHXR2(ECMH,PT,ABSZ(I),DSIG1)
          CALL POHXD2(ECMH,PT,ABSZ(I),DSIG1)
        ENDIF
        DO 20 M=1,MAXPRO
          DSIGMC(M) = DSIGMC(M)+WEIG(I)*DSIG1(M)
 20     CONTINUE
 30   CONTINUE
C
C  double direct processes
      IF(((IDPDG1.EQ.22).OR.(IDPDG1.EQ.45))
     &   .AND.((IDPDG2.EQ.22).OR.(IDPDG2.EQ.45))) THEN
        FAC = 0.D0
        SS = ECMH*ECMH
        SSR = REAL(SS)
        ALPHAE = DBLE(ULALEM(SSR))
*       ALPHAE = 1.D0/137.D0
        DO 300 I=1,NF
          IF(IDPDG1.EQ.22) THEN
            F1 = (4.D0-3.D0*MOD(I,2))/9.D0*ALPHAE
          ELSE
            F1 = PARMDL(74)
          ENDIF
          IF(IDPDG2.EQ.22) THEN
            F2 = (4.D0-3.D0*MOD(I,2))/9.D0*ALPHAE
          ELSE
            F2 = PARMDL(74)
          ENDIF
          FAC = FAC+F1*F2*3.D0
 300    CONTINUE
C  direct cross sections
        ZZ = SQRT(1.D0-4.D0*PT*PT/SS+TINY)
        T1 = -SS/2.D0*(1.D0+ZZ)
        T2 = -SS/2.D0*(1.D0-ZZ)
        XM = -2.D0*PT/ZZ*((SS+T1)/T1+T1/(SS+T1)+(SS+T2)/T2+T2/(SS+T2))
C  hadronic part
        DSIGMC(14) = GEV2MB*2.D0*PI*FAC/(SS*SS)*XM
C  leptonic part (e, mu, tau)
        DSIGMC(16) = 0.D0
        IF((IDPDG1.EQ.22).AND.(IDPDG2.EQ.22)) THEN
          DSIGMC(16) = DSIGMC(14)/FAC*3.D0*ALPHAE**2
C  simulation of tau together with quarks
          IF(IPAMDL(64).NE.0) DSIGMC(14) = DSIGMC(14)+DSIGMC(16)/3.D0
        ENDIF
      ENDIF
C
      DSIGMC(15) = DSIGMC(15)+DSIGMC(14)
      DSIGMC(0)  = DSIGMC(9)+DSIGMC(15)
      END
