C
C
      SUBROUTINE POMSCA(II,MSPOM,MHPOM,MSREG,IVAL1,IVAL2,MSPAR1,MSPAR2,
     &                  MHPAR1,MHPAR2,IREJ)
C**********************************************************************
C
C     parton orientated formulation of
C               soft and semihard inelastic events
C
C
C     input:    II        particle combiantion (1..4)
C               MSPOM     number of soft pomerons
C               MHPOM     number of semihard pomerons
C               MSREG     number of soft reggeons
C
C     output:   IVAL1,2   0 no valence quark engaged
C                         otherwise:  position of valence quark engaged
C                         neg.number: gluon connected to valence quark
C                                     by color flow
C               MSPAR1,2  number of realized soft partons
C               MHPAR1,2  number of realized hard partons
C               IREJ      1 failure
C                         0 success
C
C**********************************************************************
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      SAVE
C
      PARAMETER (NMAXD=100)
      COMMON /DEBUG/ IDEB(NMAXD),KSPOM,KHPOM,KSREG,KHDIR,KACCEP,
     &  KSTRG,KHTRG,KSLOO,KHLOO,KSDPO,KHDPO,KEVENT,KSOFT,KHARD
      CHARACTER*8 MDLNA
      COMMON /MODELS/ MDLNA(50),ISWMDL(50),PARMDL(200),IPAMDL(200)
C
      COMMON /PROCES/ IPROCE,IDNODF,IDIFR1,IDIFR2,IDDPOM,IPRON(15)
      COMMON /HADVAL/ ECMN,PCMN,SECM,SPCM,XPSUB,XTSUB,
     &                IDEQP(2),IDEQB(2),IHFLD(2,2),IHFLS(2)
C
      PARAMETER ( MAXPRO = 16 , MLINE = 400 , MSCAHD = 50 )
      COMMON /HAPARA/ ALPHAS,Q0SQR,ALASQR,BQCD,NPD,NF,NHA,NHB
C  CM system of Pomeron/Reggeon exchange
      COMMON /POMCMS/ ECMP,PCMP,PMASSP(2),PVIRTP(2),GAMBEP(4),
     &                SIDP,CODP,SIFP,COFP,NPOSP(2),
     &                IDPDG1,IDBAM1,IDPDG2,IDBAM2
      COMMON /CUTOFF/ PTCUT(4),CUTMU(4),FPS(4),FPH(4),PSOMIN,XSOMIN
      COMMON /DGLAPP/ Q2MISR(2),PMISR(2),ZMISR(2),AL2ISR(2),NFSISR
      COMMON /HADRON/ QMASS(6),BET,PCOUDI,PNORM,VALPRG(2),NFS
      COMMON /HAEVNT/ PT1,PT2,NHARD,NTRY,IHARD,ITRY,IREJEV
      COMMON /HASCA / PTWANT,AS,AH,ALNS,ALNH,Z1MAX,Z1DIF,Z2MAX,Z2DIF,
     &                PT,ETAC,ETAD,X1,X2,V,U,QQPD,QQAL,
     &                W,W1,AXX,WEIGHT,MSPR,IREJSC
      COMMON /HAEVTR/ LINE,LIN,LREC1(MLINE),LREC2(MLINE),PREC(4,MLINE)
      COMMON /ABRHRD/ XH1(50),XH2(50),IJHI1(50),IJHI2(50),
     &                IJHF1(50),IJHF2(50),PHARD1(4,50),PHARD2(4,50),IPTM
      COMMON /ABRSOF/ XS1(50),XS2(50),IJSI1(50),IJSI2(50),
     &                PSOFT1(4,50),PSOFT2(4,50)
      INTEGER MXSECT
      PARAMETER ( MAXTAB = 20 )
      COMMON /HAXSEC/ XSECTA(4,-1:MAXPRO,4,MAXTAB),XSECT(6,-1:MAXPRO),
     &                MXSECT(0:4,-1:MAXPRO,4),ECMSH(4,MAXTAB),ISTTAB
      COMMON /HARSLT/ LSCAHD,LSC1HD,
     &                ETAHD(MSCAHD,2) ,PTHD(MSCAHD), Q2SCA(MSCAHD,2),
     &                XHD(MSCAHD,2)   ,VHD(MSCAHD) ,X0HD(MSCAHD,2),
     &                NINHD(MSCAHD,2) ,NOUTHD(MSCAHD,2),
     &                N0INHD(MSCAHD,2),NBRAHD(MSCAHD,2),NPROHD(MSCAHD)
C
      PARAMETER (NMXJ=40)
      CHARACTER*10 REJTIT
      COMMON /REJSTA/ IFAIL(NMXJ),REJTIT(NMXJ)
C
      PARAMETER (ZERO   =  0.D0,
     &           IZERO  =  0,
     &           TINY   =  1.D-30,
     &           ONE    =  1.D0,
     &           TWO    =  2.D0,
     &           FOUR   =  4.D0,
     &           OHALF  =  0.5D0)
      DIMENSION P1(4),P2(4),PD1(-6:6)
      ITYPE(L)      = MOD(LREC1(L),100)-50
C
      IF(IDEB(24).GT.20) THEN
        WRITE(6,'(1X,A,3I5)')
     &    'POMSCA:DEBUG:MSPOM,MHPOM,MSREG',MSPOM,MHPOM,MSREG
      ENDIF
C
      ITRY  = 0
      IREJ  = 0
      INMAX = 10
      MHARD = MHPOM
      PT1 = PTCUT(II)
C  ISR cutoffs
      Q2MISR(1) = MIN(PT1**2,PARMDL(125+II))
      Q2MISR(2) = Q2MISR(1)
C  phase space limitation
      IF(MHPOM.GT.0) THEN
        IF(ECMP.LT.(2.D0*PT1+2.1D0*CUTMU(II))) THEN
          IREJ = 5
          IFAIL(6) = IFAIL(6) + 1
          GOTO 450
        ENDIF
      ENDIF
      AS     = (CUTMU(II)/ECMP)**2
      AH     = (2.D0*PT1/ECMP)**2
C
C  main loop to select hard and soft parton kinematics
C -----------------------------------------------------
 20   CONTINUE
        IREJ  = 0
        IHARD = 0
        LSC1HD = 0
        ITRY  = ITRY+1
        IF(ITRY.GT.1) IFAIL(5) = IFAIL(5)+1
        IF(ITRY.GE.NTRY) THEN
          IREJ = 1
          GOTO 450
        ENDIF
        LINE   = 0
        LSCAHD = 0
        IF((IPAMDL(13).GT.0).AND.(IPROCE.EQ.1)) THEN
          XSS1   = MAX(0.D0,1.D0-XPSUB)
          XSS2   = MAX(0.D0,1.D0-XTSUB)
        ELSE
          XSS1   = ZERO
          XSS2   = ZERO
        ENDIF
        IVAL1  = 0
        IVAL2  = 0
        IF(MSPOM.EQ.0) THEN
          MSPAR1 = 2+2*MHPOM+MSREG
        ELSE
          MSPAR1 = 2*MSPOM+MSREG+2*MHPOM
        ENDIF
        MSPAR2 = MSPAR1
        MHPAR1 = MHPOM
        MHPAR2 = MHPOM
C
        MSCHA = MSPAR1
        MHCHA = 2*MHPOM
        KSOFT = MSCHA
        KHARD = MHCHA
C  check kinematic limitations
        XX = AS*DBLE(4*MSCHA)+AH*DBLE(MHCHA)
        IF(XX.GE.ONE) THEN
          IF(IDEB(24).GE.1) THEN
            WRITE(6,'(1X,A,2I2,3E10.3)')
     &        'POMSCA:WARNING:KIN.REJECTION(MS,MH,AS,AH,XX)',
     &        MSCHA,MHCHA,AS,AH,XX
          ENDIF
          IREJ = 2
          IFAIL(6) = IFAIL(6) + 1
          GOTO 450
        ENDIF
        IF(MSCHA.GT.1) THEN
          AS = ONE/(TWO*(MSCHA-1))*(ONE-SQRT(ONE-FOUR*AS*(MSCHA-1)))
        ENDIF
        AS = MAX(AS,PSOMIN/PCMP)
C
        ALNS  = LOG(AS)
        ALNH  = LOG(AH)
        Z1MAX = LOG(MAX(TINY,ONE-MSCHA*AS-MAX(MHCHA-1,0)*AH))
        Z2MAX = LOG(MAX(TINY,ONE-MSCHA*AS-MAX(MHCHA-1,0)*AH))
        Z1DIF = Z1MAX+Z2MAX-ALNH
        Z2DIF = Z1DIF
        XMAXX = ONE - MSCHA*AS - MAX(MHCHA-1,0)*AH
        PTMAX = 0.D0
        IPTM  = 0
C
C  select hard parton momenta
C ------------------- begin of inner loop -------------------
        DO 10 NN=1,MHARD
C
          INTRY = 0
          IVOLD1 = IVAL1
          IVOLD2 = IVAL2
C
 15       CONTINUE
          IVAL1 = IVOLD1
          IVAL2 = IVOLD2
          INTRY = INTRY+1
          IFAIL(31) = IFAIL(31)+1
C  generate one hard scattering
          CALL POHSCA(2,II)
          XSSS1   = XSS1+X1
          XSSS2   = XSS2+X2
          XH1(NN) = X1
          XH2(NN) = X2
C  debug output
          IF(IDEB(24).GE.10) WRITE(6,'(1X,A,I3,I4,I5,2E12.4)')
     &      'POMSCA:DEBUG:MSPR,IHARD,ITRY,X1,X2',MSPR,NN,ITRY,X1,X2
C
          IF(    (XSSS1.GT.XMAXX)
     &       .OR.(XSSS2.GT.XMAXX)
     &       .OR.((ONE-XSSS1)*(ONE-XSSS2).LT.AS) ) THEN
            IF(INTRY.GT.INMAX) GOTO 20
            LINE = LINE-4
C*****************************
            IF(IHARD.EQ.0) THEN
              IF(ISWMDL(2).NE.1) GOTO 15
              MHPOM = 0
              MSPOM = 1
            ENDIF
            GOTO 199
*           GOTO 15
C*****************************
          ENDIF
C  valence quarks
          DO 116 K=1,2
            IND = 4*(NN-1)+K
            NINHD(NN,K)  = ITYPE(IND)
            NOUTHD(NN,K) = ITYPE(IND+2)
 116      CONTINUE
C  anomalous/resolved contribution
          IF(ISWMDL(27).GT.0) THEN
            IF((IDPDG1.EQ.22).AND.(NINHD(NN,1).NE.0)) THEN
              CALL PDIS(XH1(NN),QQPD,II,PD1)
              WGDIR = ZERO
              CALL POPDFB(NINHD(NN,1),X1,Q2SCA(NN,1),PVIRTP(1),WGDIR)
              XI = RNDM(X1)*PD1(NINHD(NN,1))
              IF(WGDIR.GT.XI) THEN
                NINHD(NN,1) = SIGN(ABS(NINHD(NN,1))+6,NINHD(NN,1))
              ENDIF
            ENDIF
            IF((IDPDG2.EQ.22).AND.(NINHD(NN,2).NE.0)) THEN
              CALL PDIS(XH2(NN),QQPD,II,PD1)
              WGDIR = ZERO
              CALL POPDFB(NINHD(NN,2),X2,Q2SCA(NN,2),PVIRTP(2),WGDIR)
              XI = RNDM(X2)*PD1(NINHD(NN,2))
              IF(WGDIR.GT.XI) THEN
                NINHD(NN,2) = SIGN(ABS(NINHD(NN,2))+6,NINHD(NN,2))
              ENDIF
            ENDIF
          ENDIF
C
          IF((IVAL1.EQ.0).AND.(NINHD(NN,1).NE.0)
     &       .AND.(ABS(NINHD(NN,1)).LE.6)) THEN
            IF((IDPDG1.EQ.22).OR.(IDPDG1.EQ.45)) THEN
              NINHD(NN,1) = SIGN(ABS(NINHD(NN,1))+6,NINHD(NN,1))
            ENDIF
          ENDIF
          IF((IVAL2.EQ.0).AND.(NINHD(NN,2).NE.0)
     &       .AND.(ABS(NINHD(NN,2)).LE.6)) THEN
            IF((IDPDG2.EQ.22).OR.(IDPDG2.EQ.45)) THEN
              NINHD(NN,2) = SIGN(ABS(NINHD(NN,2))+6,NINHD(NN,2))
            ENDIF
          ENDIF
C  particle 1
          IF(ABS(NINHD(NN,1)).GT.6) THEN
            IF(IVAL1.NE.0) THEN
              IF(INTRY.GT.INMAX) GOTO 20
              LINE = LINE-4
              GOTO 15
            ELSE
              IVAL1 = NN
            ENDIF
          ENDIF
C  particle 2
          IND = IND+1
          IF(ABS(NINHD(NN,2)).GT.6) THEN
            IF(IVAL2.NE.0) THEN
              IF(INTRY.GT.INMAX) GOTO 20
              LINE = LINE-4
              GOTO 15
            ELSE
              IVAL2 = NN
            ENDIF
          ENDIF
C
          IHARD = IHARD+1
          XSS1 = XSSS1
          XSS2 = XSSS2
          IFAIL(31) = IFAIL(31)-1
C  fill COMMON HARSLT
          LSCAHD         = IHARD
          XHD(IHARD,1)   = X1
          XHD(IHARD,2)   = X2
          VHD(IHARD)     = V
          ETAHD(IHARD,1) = ETAC
          ETAHD(IHARD,2) = ETAD
          PTHD(IHARD)    = PT
          NPROHD(IHARD)  = MSPR
          Q2SCA(IHARD,1) = QQPD
          Q2SCA(IHARD,2) = QQPD
C
          X0HD(NN,1)      = X1
          X0HD(NN,2)      = X2
          N0INHD(NN,1)    = NINHD(NN,1)
          N0INHD(NN,2)    = NINHD(NN,2)
          NBRAHD(NN,1)    = IDPDG1
          NBRAHD(NN,2)    = IDPDG2
          IF(PT.GT.PTMAX) IPTM = IHARD
C  reweight according to photon virtuality
          IF(IPAMDL(115).EQ.1) THEN
            WGX = 1.D0
            IF(IDPDG1.EQ.22) THEN
              WG1 = LOG(QQPD/(PVIRTP(1)+PARMDL(31)))
     &             /LOG(QQPD/PARMDL(31))
              IF(NINHD(IHARD,1).EQ.0) WG1 = WG1*WG1
              WGX = WG1
            ENDIF
            IF(IDPDG2.EQ.22) THEN
              WG1 = LOG(QQPD/(PVIRTP(2)+PARMDL(31)))
     &             /LOG(QQPD/PARMDL(31))
              IF(NINHD(IHARD,2).EQ.0) WG1 = WG1*WG1
              WGX = WGX*WG1
            ENDIF
            IF(WGX.LT.RNDM(WGX)) THEN
              IREJ = 50
              RETURN
            ENDIF
          ENDIF
C
C  generate ISR
          IF((IHARD.EQ.1).AND.(ISWMDL(8).GE.2)) THEN
            IF(IPAMDL(109).EQ.1) THEN
              Q2H = PARMDL(93)*PT**2
            ELSE
              Q2H = -PARMDL(93)*VHD(IPTM)
     &              *XHD(IPTM,1)*XHD(IPTM,2)*ECMP*ECMP
            ENDIF
            IND = 4*(IPTM-1)+1
            XHMAX1 =  ONE - XSS1 - MSCHA*AS + XHD(IPTM,1)
            XHMAX2 =  ONE - XSS2 - MSCHA*AS + XHD(IPTM,2)
            I3     = 4*IPTM-1
            I4     = 4*IPTM
            DO 42 J=1,4
              P1(J) = PREC(J,I3)
              P2(J) = PREC(J,I4)
 42         CONTINUE
            IF(IDEB(24).GE.10)
     &        WRITE(6,'(1X,A,2I6)') 'POMSCA:ISR FOR IPTM,IND',IPTM,IND
            CALL POHISR(IPTM,P1,P2,NOUTHD(IPTM,1),NOUTHD(IPTM,2),
     &        NINHD(IPTM,1),NINHD(IPTM,2),Q2H,XHD(IPTM,1),XHD(IPTM,2),
     &        XHMAX1,XHMAX2,IFL1,IFL2,XISR1,XISR2,IREJ)
            XSS1 = XSS1+XISR1-XHD(IPTM,1)
            XSS2 = XSS2+XISR2-XHD(IPTM,2)
            NINHD(IPTM,1) = IFL1
            NINHD(IPTM,2) = IFL2
            XHD(IPTM,1) = XISR1
            XHD(IPTM,2) = XISR2
          ENDIF
C
 10     CONTINUE
 199    CONTINUE
        MHPOM =  IHARD
        MHPAR1 = IHARD
        MHPAR2 = IHARD
        IF(MSPOM.EQ.0) THEN
          MSPAR1 = 2+2*MHPOM+MSREG
        ELSE
          MSPAR1 = 2*MSPOM+MSREG+2*MHPOM
        ENDIF
        MSPAR2 = MSPAR1
C**************************
C ------------------- end of inner (hard) loop -------------------
C
C  count quarks involved in hard scattering
        IQUA1 = 0
        IQUA2 = 0
        IVGLU1 = 0
        IVGLU2 = 0
        DO 115 I=1,IHARD
          IF(NINHD(I,1).NE.0) THEN
            IQUA1 = IQUA1+1
          ELSE IF(IVGLU1.EQ.0) THEN
            IVGLU1 = I
          ENDIF
          IF(NINHD(I,2).NE.0) THEN
            IQUA2 = IQUA2+1
          ELSE IF(IVGLU2.EQ.0) THEN
            IVGLU2 = I
          ENDIF
115     CONTINUE
C  gluons emitted by valence quarks
        IF(II.EQ.1) THEN
          VALPRO = VALPRG(1)
        ELSE
          VALPRO = 1.D0
        ENDIF
        IV1 = 1
        IF(IVAL1.EQ.0) THEN
          IF((IVGLU1.NE.0).AND.(RNDM(XSS1).LT.VALPRO)) THEN
            IVAL1 = -IVGLU1
          ELSE
            IV1 = 0
          ENDIF
        ENDIF
        IF(II.EQ.1) THEN
          VALPRO = VALPRG(2)
        ELSE
          VALPRO = 1.D0
        ENDIF
        IV2 = 1
        IF(IVAL2.EQ.0) THEN
          IF((IVGLU2.NE.0).AND.(RNDM(XSS2).LT.VALPRO)) THEN
            IVAL2 = -IVGLU2
          ELSE
            IV2 = 0
          ENDIF
        ENDIF
C  debug output
        IF(IDEB(24).GE.5) THEN
          WRITE(6,'(1X,A,6I4)')
     &      'POMSCA:DEBUG:IVAL1,2  IQUA1,2  IVGLU1,2',
     &      IVAL1,IVAL2,IQUA1,IQUA2,IVGLU1,IVGLU2
        ENDIF
C  correct soft quark numbers
        IF(MSPOM.EQ.0) THEN
          MSPAR1 = MSPAR1-IQUA1-2*IV1
          MSPAR2 = MSPAR2-IQUA2-2*IV2
        ELSE
          MSPAR1 = MSPAR1-IQUA1
          MSPAR2 = MSPAR2-IQUA2
        ENDIF
C
C  select soft X
 25     CONTINUE
        XMAX1  = ONE - MAX(MSPAR1-1,0)*AS - XSS1
        XMAX2  = ONE - MAX(MSPAR2-1,0)*AS - XSS2
        I1 = IV1
        I2 = IV2
        IF(IVAL1.LE.0) I1 = 0
        IF(IVAL2.LE.0) I2 = 0
        IF(IV1*IV2.NE.0) THEN
          MSDIFF = 2*MAX(0,MSPOM)
        ELSE
          MSDIFF = 2*MAX(0,MSPOM-1)
        ENDIF
        MSG1 = MSPAR1
        MSG2 = MSPAR2
        MSM1 = MSPAR1-MSDIFF
        MSM2 = MSPAR2-MSDIFF
        XMAXH1 = MIN(XMAX1,PARMDL(44))
        XMAXH2 = MIN(XMAX2,PARMDL(44))
        CALL SOFTXX(NPOSP(1),NPOSP(2),MSG1,MSG2,I1,I2,MSM1,MSM2,
     &              XSS1,XSS2,XMAXH1,XMAXH2,XS1,XS2,IREJ)
        MSPOM  = MSPOM-(MSPAR1-MSG1)/2
        MSPAR1 = MSG1
        MSPAR2 = MSG2
C  correct for high pt tail
        IF(IREJ.NE.0) THEN
          IREJ = 4
          GOTO 450
        ENDIF
C  ------------ kinematics sampled ---------------
C  debug output
        IF(IDEB(24).GE.10) THEN
          WRITE(6,'(1X,A,I3)') 'POMSCA:DEBUG:SOFT X VALUES,ITRY',ITRY
          DO 104 I=2,MAX(MSPAR1,MSPAR2)
            WRITE(6,'(10X,I3,2E12.3)') I,XS1(I),XS2(I)
 104      CONTINUE
        ENDIF
      IF((ONE-XSS1)*(ONE-XSS2).LT.AS) GOTO 20
C
C  end of loop
      XS1(1) = ONE - XSS1
      XS2(1) = ONE - XSS2
C*****************************
*     IF( IHARD.LT.MHARD .AND. ITRY.GE.NTRY ) THEN
      IF( ITRY.GE.NTRY ) THEN
C*****************************
        IREJ = 6
        GOTO 450
      ENDIF
C
C  select information from event-record
C
C  initial partons
      DO 45 N=1,IHARD
C  flavors
        IF(ABS(NINHD(N,1)).GT.6)
     &    NINHD(N,1)=SIGN(ABS(NINHD(N,1))-6,NINHD(N,1))
        IJHI1(N) = NINHD(N,1)
        IF(ABS(NINHD(N,2)).GT.6)
     &    NINHD(N,2)=SIGN(ABS(NINHD(N,2))-6,NINHD(N,2))
        IJHI2(N) = NINHD(N,2)
 45   CONTINUE
C  final partons
      DO 30 N=1,LSCAHD
        I3     = 4*N-1
        I4     = 4*N
C  flavors
        IJHF1(N) = NOUTHD(N,1)
        IJHF2(N) = NOUTHD(N,2)
C  four momentum
        DO 40 J=1,4
          PHARD1(J,N) = PREC(J,I3)
          PHARD2(J,N) = PREC(J,I4)
40      CONTINUE
C  process counting
        MXSECT(3,NPROHD(N),II) = MXSECT(3,NPROHD(N),II)+1
30    CONTINUE
C
C  soft particle momenta
      DO 50 I=1,MSPAR1
        PSOFT1(1,I) = ZERO
        PSOFT1(2,I) = ZERO
        PSOFT1(3,I) = XS1(I)*ECMP/TWO
        PSOFT1(4,I) = XS1(I)*ECMP/TWO
 50   CONTINUE
      DO 55 I=1,MSPAR2
        PSOFT2(1,I) = ZERO
        PSOFT2(2,I) = ZERO
        PSOFT2(3,I) = -XS2(I)*ECMP/TWO
        PSOFT2(4,I) = XS2(I)*ECMP/TWO
 55   CONTINUE
      KSOFT = MAX(MSPAR1,MSPAR2)
      KHARD = MAX(MHPAR1,MHPAR2)
      KSPOM = MSPOM
      KHPOM = MHPOM
C  debug output
      IF(IDEB(24).GE.10) THEN
        WRITE(6,'(/1X,A,2I3,2I5)')
     &    'POMSCA:DEBUG:(ACCEPTED) IVAL1,IVAL2,ITRY,NTRY',
     &     IVAL1,IVAL2,ITRY,NTRY
        IF(MSPAR1+MSPAR2.GT.0) THEN
          WRITE(6,'(5X,A)') 'SOFT X PARTICLE1   PARTICLE2:'
          XTMP1 = ZERO
          XTMP2 = ZERO
          DO 105 I=1,MAX(MSPAR1,MSPAR2)
            IF(I.LE.MIN(MSPAR1,MSPAR2)) THEN
              WRITE(6,'(10X,I3,2E13.4)') I,XS1(I),XS2(I)
              XTMP1 = XTMP1+XS1(I)
              XTMP2 = XTMP2+XS2(I)
            ELSE IF(I.LE.MSPAR1) THEN
              WRITE(6,'(10X,I3,2E13.4)') I,XS1(I),ZERO
              XTMP1 = XTMP1+XS1(I)
            ELSE IF(I.LE.MSPAR2) THEN
              WRITE(6,'(10X,I3,2E13.4)') I,ZERO,XS2(I)
              XTMP2 = XTMP2+XS2(I)
            ENDIF
 105      CONTINUE
          WRITE(6,'(1X,A,2E13.4)') 'SUM X1/2 (soft):',XTMP1,XTMP2
        ENDIF
        IF(MHPAR1.GT.0) THEN
          WRITE(6,'(5X,A)') 
     &      'NR  MSPR HARD X / HARD X ISR / FLAVOR PARTICLE1,2:'
          DO 107 I=1,MHPAR1
            WRITE(6,'(10X,2I3,4E12.3,2I3)')
     &        I,NPROHD(I),XH1(I),XH2(I),XHD(I,1),XHD(I,2),
     &        IJHI1(I),IJHI2(I)
              XTMP1 = XTMP1+XHD(I,1)
              XTMP2 = XTMP2+XHD(I,2)
 107      CONTINUE
          WRITE(6,'(1X,A,2E13.4)') 'SUM X1/2 (soft+hard):',XTMP1,XTMP2
          WRITE(6,'(5X,A)') 'HARD MOMENTA  PARTICLE1:'
          DO 108 I=1,MHPAR1
            WRITE(6,'(10X,I3,4E12.3,I5)') I,(PHARD1(K,I),K=1,4),
     &        IJHF2(I)
 108      CONTINUE
          WRITE(6,'(5X,A)') 'HARD MOMENTA  PARTICLE2:'
          DO 110 I=1,MHPAR2
            WRITE(6,'(10X,I3,4E12.3,I5)') I,(PHARD2(K,I),K=1,4),
     &        IJHF1(I)
 110      CONTINUE
        ENDIF
      ENDIF
      RETURN
C
 450  CONTINUE
      IFAIL(4) = IFAIL(4)+1
      IF(IDEB(24).GE.2) THEN
        WRITE(6,'(1X,A,/10X,7I5)')
     &  'POMSCA:REJECTION:(MSPOM,MHPOM,IHARD,MHARD,ITRY,NTRY,IREJ)',
     &  MSPOM,MHPOM,IHARD,MHARD,ITRY,NTRY,IREJ
        WRITE(6,'(5X,A,I4,2E12.4)') 'IP,ENERGY,PTCUT:',II,ECMP,PT1
        IF(IDEB(24).GE.5) THEN
          CALL POPREV(0)
        ELSE
          CALL POPREV(-1)
        ENDIF
      ENDIF
      RETURN
      END
