C
C
      DOUBLE PRECISION FUNCTION POPAMA(INDEX,MODE)
C**********************************************************************
C
C     output of average particle mass
C
C     input:  MODE  -1   initialization
C                    0   INDEX gives CPC particle number
C                    1   INDEX gives PDG particle number
C                    2   INDEX gives position of particle in HEPEVS
C
C     output: average particle mass
C
C**********************************************************************
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      SAVE
C
      PARAMETER (NMAXD=100)
      COMMON /DEBUG/ IDEB(NMAXD),KSPOM,KHPOM,KSREG,KHDIR,KACCEP,
     &  KSTRG,KHTRG,KSLOO,KHLOO,KSDPO,KHDPO,KEVENT,KSOFT,KHARD
C
      PARAMETER (ZERO   =  0.D0,
     &           ONE    =  1.D0,
     &           TWO    =  2.D0,
     &           THREE  =  3.D0,
     &           TWOTHR =  TWO/THREE,
     &           OTHR   =  ONE/THREE,
     &           OHALF  =  0.5D0,
     &           DEPS   =  1.D-05)
C
      PARAMETER (NMXHEP=2000)
      COMMON/HEPEVS/NEVHEP,NHEP,ISTHEP(NMXHEP),IDHEP(NMXHEP),
     &JMOHEP(2,NMXHEP),JDAHEP(2,NMXHEP),PHEP(5,NMXHEP),VHEP(4,NMXHEP)
      COMMON/HEPEVE/IMPART(NMXHEP),IPHIST(2,NMXHEP),ICOLOR(2,NMXHEP)
C
      CHARACTER*8 ANAME
      COMMON/POPART/ANAME(187),AM(187),GA(187),TAU(187),ICH(187),
     &              IBAR(187),K1(187),K2(187)
      DIMENSION QUMASS(0:6)
**sr 29.04. commented to use dp-JETSET
      REAL ULMASS
**
C
      POPAMA = ZERO
      IF(MODE.EQ.0) THEN
        POPAMA = AM(INDEX)
      ELSE IF(MODE.EQ.1) THEN
        IF(ABS(INDEX).LE.6) THEN
          POPAMA = QUMASS(ABS(INDEX))
        ELSE
          POPAMA = DBLE(ULMASS(INDEX))
        ENDIF
      ELSE IF(MODE.EQ.2) THEN
        IF(ISTHEP(INDEX).GE.11) RETURN
        IF(IMPART(INDEX).EQ.0) THEN
          POPAMA = DBLE(ULMASS(IDHEP(INDEX)))
        ELSE
          POPAMA = AM(IMPART(INDEX))
        ENDIF
      ELSE IF(MODE.EQ.-1) THEN
        DO 100 I=1,6
          QUMASS(I) = DBLE(ULMASS(I))
 100    CONTINUE
        QUMASS(0) = ZERO
      ELSE
        WRITE(6,'(1X,A,2I5)') 
     &    'POPAMA:ERROR:INVALID ARGUMENTS',INDEX,MODE
        RETURN
      ENDIF
      END
