C
C
      SUBROUTINE POPDFB(IQ,X,SCALE2,PVIRT,FXP)
C***************************************************************
C
C     contribution of the photon PDF due to box graph
C
C     input:      IQ       quark flavour 
C                 SCALE2   scale (GeV**2)
C                 X        parton momentum fraction
C                 PVIRT    photon virtuality (GeV**2, positive)
C                 FXP      x*f(x,Q**2), x times parton denisty
C
C***************************************************************
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      SAVE
C
      PARAMETER (ZERO = 0.D0)
C
      PARAMETER (NMAXD=100)
      COMMON /DEBUG/ IDEB(NMAXD),KSPOM,KHPOM,KSREG,KHDIR,KACCEP,
     &  KSTRG,KHTRG,KSLOO,KHLOO,KSDPO,KHDPO,KEVENT,KSOFT,KHARD
      PARAMETER (NMXJ=40)
      CHARACTER*10 REJTIT
      COMMON /REJSTA/ IFAIL(NMXJ),REJTIT(NMXJ)
      COMMON /HACONS/ PI,PI2,PI4,GEV2MB
C
      DIMENSION QM(6)
      DATA QM / 0.2D0,0.25D0,0.5D0,1.6D0,5.D0,174.D0 /
C
      FXP = 0.D0
      I = ABS(IQ)
      QM2 = QM(I)**2
      BBE = (1.D0-X)*SCALE2
      IF(BBE.LE.ZERO) THEN
        IF(IDEB(27).GE.5) WRITE(6,'(1X,A,4E10.3)')
     &    'POPDFP:WARNING:over mass limit (X,Q2,P2,QM)',X,SCALE2,
     &    PVIRT,QM(I)
        RETURN
      ENDIF
C
      FXP = X*(4.D0-3.D0*MOD(I,2))/9.D0*3.D0/(2.D0*137.D0*PI)
     &  *((X**2+(1.D0-X)**2)*LOG(BBE/(QM2*X))+8.D0*X*(1.D0-X)-1.D0)
C
      IF(IDEB(27).GE.20) WRITE(6,'(1X,A,I3,5E10.3)')
     &  'POPDFP:DEBUG:X,Q2,P2,QM',I,X,SCALE2,PVIRT,QM(I),FXP
      END
