C
C
      SUBROUTINE POXSEC(IP,EE)
C*********************************************************************
C
C     calculation of physical  cross sections
C
C     input:   IP      particle combination
C              EE      cms energy (GeV)
C
C     output:  COMMON /SIGMAS/  input cross sections
C              COMMON /ZIGMAS/  scaled input cross values
C              COMMON /XSECTP/  physical cross sections and slopes
C
C              slopes in GeV**-2, cross sections in mb
C
C*********************************************************************
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      SAVE
C
      COMMON /HACONS/ PI,PI2,PI4,GEV2MB
C
      PARAMETER (NMAXD=100)
      COMMON /DEBUG/ IDEB(NMAXD),KSPOM,KHPOM,KSREG,KHDIR,KACCEP,
     &  KSTRG,KHTRG,KSLOO,KHLOO,KSDPO,KHDPO,KEVENT,KSOFT,KHARD
C
      COMMON /HAGAUP/ NGAUP1,NGAUP2,NGAUET,NGAUIN,NGAUSO
      CHARACTER*8 MDLNA
      COMMON /MODELS/ MDLNA(50),ISWMDL(50),PARMDL(200),IPAMDL(200)
C
      PARAMETER ( MAXPRO = 16 )
      COMPLEX*16      SIGP,SIGR,SIGHD,SIGHR,SIGT1,SIGT2,SIGL,SIGDP,
     &                SIGD1,SIGD2,DSIGH
      COMMON /SIGMAS/ SIGP,SIGR,SIGHD,SIGHR,SIGT1(2),SIGT2(2),SIGL,
     &                SIGDP(4),SIGD1(2),SIGD2(2),DSIGH(0:MAXPRO)
      COMMON /XSECTP/ SIGTOT,SIGELA,SIGVM(0:4,0:4),SIGINE,SIGDIR,
     &                SIGLSD(2),SIGHSD(2),SIGLDD,SIGHDD,SIGCDF,
     &                SIGPOM,SIGREG,SIGHAR,SIGTR1,SIGTR2,SIGLOO,SIGDPO,
     &                SIG1SO,SIG1HA,SLOEL,SLOVM(4,4),SIGGEN(4),
     &                FSUP(2)
      COMMON /GLOCMS/ ECM,PCM,PMASS(2),PVIRT(2),IFPAP(2),IFPAB(2)
C
      PARAMETER(ZERO=0.D0,
     &         OHALF=0.5D0,
     &           ONE=1.D0,
     &          ONEM=-1.D0,
     &           TWO=2.D0,
     &          FOUR=4.D0,
     &         THOUS=1.D3,
     &          DEPS=1.D-20)
C
      CHARACTER*8     PANAME
      COMPLEX*16      AMPEL,AMPVM,AMPSOF,AMPHAR,AMLMSD,AMHMSD,AMLMDD,
     &                AMHMDD,AMPDP,AMPD1,AMPD2
      COMMON /AMPLIT/ AMPEL,AMPVM(4,4),AMPSOF,AMPHAR,AMLMSD(2),
     &                AMHMSD(2),AMLMDD,AMHMDD,AMPDP,AMPD1,AMPD2
C
      DIMENSION XPNT(96),WGHT(96),SLVM1(4,4),SLVM2(4,4)
      CHARACTER*8 VMESA(0:4),VMESB(0:4)
      DATA VMESA / 'VMESON  ','RHO     ','OMEGA0  ','PHI     ',
     &             'PI+PI-  ' /
      DATA VMESB / 'VMESON  ','RHO     ','OMEGA0  ','PHI     ',
     &             'PI+PI-' /
C
      CDABS(AMPEL) = ABS(AMPEL)
C
      ETMP = ECM
      IF(EE.LT.ZERO) GOTO 500
      ECM = EE
C  impact parameter integration
C     BMAX=12.D0*SQRT(MAX(BPOM,BREG))
      BMAX=10.D0
      CALL GSET(ZERO,BMAX,NGAUSO,XPNT,WGHT)
      SIGTOT    = ZERO
      SIGINE    = ZERO
      SIGELA    = ZERO
      SIGLSD(1) = ZERO
      SIGLSD(2) = ZERO
      SIGLDD    = ZERO
      SIGHSD(1) = ZERO
      SIGHSD(2) = ZERO
      SIGHDD    = ZERO
      SIGCDF    = ZERO
      SIG1So    = ZERO
      SIG1HA    = ZERO
      SLEL1 = ZERO
      SLEL2 = ZERO
      DO 50 I=1,4
        DO 55 K=1,4
          SIGVM(I,K) = ZERO
          SLVM1(I,K) = ZERO
          SLVM2(I,K) = ZERO
 55     CONTINUE
 50   CONTINUE
C
      DO 100 I=1,NGAUSO
        B2  = XPNT(I)**2
        WG  = WGHT(I)*XPNT(I)
        WGB = B2*WG
C
C  calculate impact parameter amplitude, results in /AMPLIT/
        CALL EIKON(IP,XPNT(I))
C
        SIGTOT    = SIGTOT + DREAL(AMPEL)*WG
        SIGELA    = SIGELA + CDABS(AMPEL)**2*WG
        SLEL1     = SLEL1  + AMPEL*WGB
        SLEL2     = SLEL2  + AMPEL*WG
C
        DO 110 J=1,4
          DO 120 K=1,4
            SIGVM(J,K) = SIGVM(J,K) + CDABS(AMPVM(J,K))**2*WG
            SLVM1(J,K) = SLVM1(J,K) + AMPVM(J,K)*WGB
            SLVM2(J,K) = SLVM2(J,K) + AMPVM(J,K)*WG
 120      CONTINUE
 110    CONTINUE
C
        SIGLSD(1) = SIGLSD(1) + CDABS(AMLMSD(1))**2*WG
        SIGLSD(2) = SIGLSD(2) + CDABS(AMLMSD(2))**2*WG
        SIGLDD    = SIGLDD    + CDABS(AMLMDD)**2*WG
        SIG1SO    = SIG1SO    + DREAL(AMPSOF)*WG
        SIG1HA    = SIG1HA    + DREAL(AMPHAR)*WG
        SIGHSD(1) = SIGHSD(1) + DREAL(AMHMSD(1))*WG
        SIGHSD(2) = SIGHSD(2) + DREAL(AMHMSD(2))*WG
        SIGHDD    = SIGHDD    + DREAL(AMHMDD)*WG
        SIGCDF    = SIGCDF    + DREAL(AMPDP)*WG
C
 100  CONTINUE
C
      SIGDIR = DREAL(SIGHD)
      FAC    = FOUR*PI2
      SIGTOT = SIGTOT*FAC
      SIGELA = SIGELA*FAC
      FACSL  = OHALF/GEV2MB
      SLOEL  = SLEL1/MAX(DEPS,SLEL2)*FACSL
      DO 130 I=1,4
        DO 140 J=1,4
          SIGVM(I,J) = SIGVM(I,J)*FAC
          SLOVM(I,J) = SLVM1(I,J)/MAX(DEPS,SLVM2(I,J))*FACSL
 140    CONTINUE
 130  CONTINUE
C
      SIGVM(0,0) = ZERO
      DO 150 I=1,4
        SIGVM(0,I) = ZERO
        SIGVM(I,0) = ZERO
        DO 160 J=1,4
          SIGVM(0,I) = SIGVM(0,I) + SIGVM(J,I)
          SIGVM(I,0) = SIGVM(I,0) + SIGVM(I,J)
 160    CONTINUE
        SIGVM(0,0) = SIGVM(0,0) + SIGVM(I,0)
 150  CONTINUE
C
      SIGLSD(1) = SIGLSD(1)*FAC
      SIGLSD(2) = SIGLSD(2)*FAC
      SIGLDD    = SIGLDD   *FAC
      SIGHSD(1) = SIGHSD(1)*FAC
      SIGHSD(2) = SIGHSD(2)*FAC
      SIGHDD    = SIGHDD   *FAC
      SIGCDF    = SIGCDF   *FAC
      SIG1SO    = SIG1SO   *FAC
      SIG1HA    = SIG1HA   *FAC
C
      SIGINE    = SIGTOT - SIGELA
C
 500  CONTINUE
      IF(IFPAP(1).NE.22) THEN
        VMESA(1) = PANAME(IFPAB(1),0)
      ELSE
        VMESA(1) = 'RHO     '
      ENDIF
      IF(IFPAP(2).NE.22) THEN
        VMESB(1) = PANAME(IFPAB(2),0)
      ELSE
        VMESB(1) = 'RHO     '
      ENDIF
C
C  write out physical cross sections
      IF(IDEB(57).GE.5) THEN
        WRITE(6,'(/1X,A,I3,/1X,A)')
     &    'POXSEC:DEBUG: CROSS SECTIONS (mb) FOR COMBINATION:',IP,
     &    '=================================================='
        WRITE(6,'(5X,A,E12.3,2E11.3)')'ENERGY,VIRTUALITIES',ECM,PVIRT
        WRITE(6,'(5X,A,E12.3)') '             TOTAL ',SIGTOT
        WRITE(6,'(5X,A,E12.3)') '    PURELY ELASTIC ',SIGELA
        WRITE(6,'(5X,A,E12.3)') '         INELASTIC ',SIGINE
        WRITE(6,'(5X,A,E12.3)') ' S-DIFF.PARTICLE 1 ',
     &    SIGLSD(1)+SIGHSD(1)
        IF(IDEB(57).GE.5) THEN
          WRITE(6,'(5X,A,E12.3)') '     LOW-MASS PART ',SIGLSD(1)
          WRITE(6,'(5X,A,E12.3)') '    HIGH-MASS PART ',SIGHSD(1)
        ENDIF
        WRITE(6,'(5X,A,E12.3)') ' S-DIFF.PARTICLE 2 ',
     &    SIGLSD(2)+SIGHSD(2)
        IF(IDEB(57).GE.5) THEN
          WRITE(6,'(5X,A,E12.3)') '     LOW-MASS PART ',SIGLSD(2)
          WRITE(6,'(5X,A,E12.3)') '    HIGH-MASS PART ',SIGHSD(2)
        ENDIF
        WRITE(6,'(5X,A,E12.3)') '       DOUBLE DIFF ',SIGLDD+SIGHDD
        WRITE(6,'(5X,A,E12.3)') '     LOW-MASS PART ',SIGLDD
        WRITE(6,'(5X,A,E12.3)') '    HIGH-MASS PART ',SIGHDD
        WRITE(6,'(5X,A,E12.3)') '    DOUBLE POMERON ',SIGCDF
        WRITE(6,'(5X,A,E12.3)') '     ELASTIC SLOPE ',SLOEL
        DO 200 I=1,4
          DO 210 J=1,4
            IF(SIGVM(I,J).GT.DEPS) THEN
              WRITE(6,'(1X,A,A8,A8)') 'Q-ELASTIC PRODUCTION OF ',
     &          VMESA(I),VMESB(J)
              WRITE(6,'(10X,A,E12.3)') 'CROSS SECTION ',SIGVM(I,J)
              IF((I.NE.0).AND.(J.NE.0))
     &          WRITE(6,'(18X,A,E12.3)') 'SLOPE ',SLOVM(I,J)
            ENDIF
 210      CONTINUE
 200    CONTINUE
        WRITE(6,'(5X,A,E12.3)') ' VMESON PRODUCTION ',SIGVM(0,0)
        WRITE(6,'(5X,A,E12.3)') '  ONE-POMERON SOFT ',SIG1SO
        WRITE(6,'(5X,A,E12.3)') '  ONE-POMERON HARD ',SIG1HA
        WRITE(6,'(5X,A,E12.3)') '  POMERON EXCHANGE ',SIGPOM
        WRITE(6,'(5X,A,E12.3)') '  REGGEON EXCHANGE ',SIGREG
        WRITE(6,'(5X,A,E12.3)') ' HARD RESOLVED QCD ',DREAL(DSIGH(9))
        WRITE(6,'(5X,A,E12.3/)')'   HARD DIRECT QCD ',DREAL(DSIGH(15))
      ENDIF
C
      ECM = ETMP
      END
