      SUBROUTINE STDPAR(IJM1,IJM2,MSPOM,MSREG,MHPOM,MHDIR,IREJ)
C**********************************************************************
C
C     select the initial parton x-fractions and flavors and
C     the final parton momenta and flavours
C     for standard Pomeron/Reggeon cuts
C
C     input:   IJM1   index of mother particle 1 in HEPEVS
C              IJM2   index of mother particle 2 in HEPEVS
C              MSPOM  soft cut Pomerons
C              MHPOM  hard or semihard cut Pomerons
C              MSREG  soft cut Reggeons
C              MHDIR  direct hard processes
C
C              IJM1   -1    initialization of statistics
C                     -2    output of statistics
C
C     output:  partons are directly written to HEPEVS,HEPEVE
C
C          structure of COMMON /ABRHRD/
C               XH1(I),XH2(I):     x-values of initial partons
C               IJHI1(I),IJHI2(I): flavor of initial parton
C                                  0            gluon
C                                  1,2,3,4      sea quarks
C                                  7,8,9,10     valence quarks
C                                  negative     anti s or v quarks
C               IJHF1(I),IJHF2(I): flavor of final state partons
C               PHARD1(I,J),PHARD2(I,J): final part. momentum and energy
C                                J=1   PX
C                                 =2   PY
C                                 =3   PZ
C                                 =4   ENERGY
C
C          structure of COMMON /ABRSOF/
C               XS1(I),XS2(I):     x-values of initial partons
C               IJSI1(I),IJSI2(I): flavor of initial parton
C                                  0            gluon
C                                  1,2,3,4      sea quarks
C                                  7,8,9,10     valence quarks
C                                  negative     anti s or v quarks
C               IJSF1(I),IJSF2(I): flavor of final state partons
C               PSOFT1(I,J),PSOFT2(I,J): final part. momentum and energy
C                                J=1   PX
C                                 =2   PY
C                                 =3   PZ
C                                 =4   ENERGY
C
C**********************************************************************
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      SAVE
C
      PARAMETER (NMAXD=100)
      COMMON /DEBUG/ IDEB(NMAXD),KSPOM,KHPOM,KSREG,KHDIR,KACCEP,
     &  KSTRG,KHTRG,KSLOO,KHLOO,KSDPO,KHDPO,KEVENT,KSOFT,KHARD
      CHARACTER*8 MDLNA
      COMMON /MODELS/ MDLNA(50),ISWMDL(50),PARMDL(200),IPAMDL(200)
      COMMON /PROCES/ IPROCE,IDNODF,IDIFR1,IDIFR2,IDDPOM,IPRON(15)
C  global CM system
      COMMON /GLOCMS/ ECM,PCM,PMASS(2),PVIRT(2),IFPAP(2),IFPAB(2)
C  CM system of Pomeron/Reggeon exchange
      COMMON /POMCMS/ ECMP,PCMP,PMASSP(2),PVIRTP(2),GAMBEP(4),
     &                SIDP,CODP,SIFP,COFP,NPOSP(2),
     &                IDPDG1,IDBAM1,IDPDG2,IDBAM2
      COMMON /HADVAL/ ECMN,PCMN,SECM,SPCM,XPSUB,XTSUB,
     &                IDEQP(2),IDEQB(2),IHFLD(2,2),IHFLS(2)
      COMMON /CUTOFF/ PTCUT(4),CUTMU(4),FPS(4),FPH(4),PSOMIN,XSOMIN
      CHARACTER*8 PDFNAM
      COMMON /PARPDF/ PDFLAM(2),PDFQ2M(2),PDFNAM(2),IPARID(2),PARVI(2),
     &                IPAVA(2),ITYPE(2),IGRP(2),ISET(2),IEXT(2),NPAOLD
C
      COMMON /HAPARA/ ALPHAS,Q0SQR,ALASQR,BQCD,NPD,NF,NHA,NHB
      COMMON /ABRHRD/ XH1(50),XH2(50),IJHI1(50),IJHI2(50),
     &                IJHF1(50),IJHF2(50),PHARD1(4,50),PHARD2(4,50),IPTM
      COMMON /ABRISR/ IFLISR(2,150),PHISR(2,4,150),IPOISR(2,2,50)
      COMMON /ABRSOF/ XS1(50),XS2(50),IJSI1(50),IJSI2(50),
     &                PSOFT1(4,50),PSOFT2(4,50)
      COMMON /HAEVNT/ PT1,PT2,NHARD,NTRY,IHARD,ITRY,IREJEV
      PARAMETER ( MAXPRO = 16 )
      PARAMETER ( MLINE = 400 , MSCAHD = 50 )
      COMMON /HAEVTR/ LINE,LIN,LREC1(MLINE),LREC2(MLINE),PREC(4,MLINE)
      COMMON /HARSLT/ LSCAHD,LSC1HD,
     &                ETAHD(MSCAHD,2) ,PTHD(MSCAHD), Q2SCA(MSCAHD,2),
     &                XHD(MSCAHD,2)   ,VHD(MSCAHD) ,X0HD(MSCAHD,2),
     &                NINHD(MSCAHD,2) ,NOUTHD(MSCAHD,2),
     &                N0INHD(MSCAHD,2),NBRAHD(MSCAHD,2),NPROHD(MSCAHD)
C
      PARAMETER (NMXHEP=2000)
      COMMON/HEPEVS/NEVHEP,NHEP,ISTHEP(NMXHEP),IDHEP(NMXHEP),
     &JMOHEP(2,NMXHEP),JDAHEP(2,NMXHEP),PHEP(5,NMXHEP),VHEP(4,NMXHEP)
      COMMON/HEPEVE/IMPART(NMXHEP),IPHIST(2,NMXHEP),ICOLOR(2,NMXHEP)
C
      PARAMETER (NMXJ=40)
      CHARACTER*10 REJTIT
      COMMON /REJSTA/ IFAIL(NMXJ),REJTIT(NMXJ)
C
      COMMON /KINLIM/ ETAMI(2,15),ETAMA(2,15),XXMI(2,15),XXMA(2,15)
C
      PARAMETER (ZERO   =  0.D0,
     &           IZERO  =  0,
     &           ONE    =  1.D0,
     &           TWO    =  2.D0,
     &           OHALF  =  0.5D0,
     &           RHOMAS =  0.766D0,
     &           DEPS   =  1.D-10,
     &           TINY   =  1.D-10)
C
*     CHARACTER*72 TITLE
      DIMENSION PC(4),IFLA(2),ICI(2,2)
*     DATA INIT / 0 /
C
      IF(IJM1.EQ.-1) THEN
        DO 116 I=1,15
          ETAMI(1,I) = 1.D10
          ETAMA(1,I) = -1.D10
          ETAMI(2,I) = 1.D10
          ETAMA(2,I) = -1.D10
          XXMI(1,I) = 1.D0
          XXMA(1,I) = 0.D0
          XXMI(2,I) = 1.D0
          XXMA(2,I) = 0.D0
 116    CONTINUE
        CALL POHSCA(IJM1,1)
        CALL POHCOL(IJM1,ZERO,0,0,0,0,0,0,0,0,0,0,0,0)
*       IF(INIT.EQ.0) THEN
*         CALL NEWHIS(ZERO,ONE,ZERO,PC,30,IHBA1)
*         CALL NEWHIS(ZERO,ONE,ZERO,PC,30,IHBA2)
*         CALL NEWHIS(ZERO,ONE,ZERO,PC,30,IHBB1)
*         CALL NEWHIS(ZERO,ONE,ZERO,PC,30,IHBB2)
*         INIT = 1
*       ENDIF

        RETURN
      ELSE IF(IJM1.EQ.-2) THEN
        IF(IDEB(23).GE.1) THEN
          WRITE(6,'(/1X,A)') 
     &      'KINEMATIC LIMITS PARTICLE C (ETAMIN,ETAMAX,XMIN,XMAX)'
          DO 117 I=1,15
            WRITE(6,'(5X,I3,4E13.5)') 
     &        I,ETAMI(1,I),ETAMA(1,I),XXMI(1,I),XXMA(1,I)
 117      CONTINUE
          WRITE(6,'(1X,A)') 
     &      'KINEMATIC LIMITS PARTICLE D (ETAMIN,ETAMAX,XMIN,XMAX)'
          DO 118 I=1,15
            WRITE(6,'(5X,I3,4E13.5)') 
     &        I,ETAMI(2,I),ETAMA(2,I),XXMI(2,I),XXMA(2,I)
 118      CONTINUE
        ENDIF
        CALL POHSCA(IJM1,1)
        CALL POHCOL(IJM1,ZERO,0,0,0,0,0,0,0,0,0,0,0,0)
*       TITLE = 'X DISTRIBUTION OF PARTON 1 FROM PARTICLE 1'
*       CALL OUTHIS(IHBA1,0,TITLE,ONE,0)
*       TITLE = 'X DISTRIBUTION OF PARTON 2 FROM PARTICLE 1'
*       CALL OUTHIS(IHBA2,0,TITLE,ONE,0)
*       TITLE = 'X DISTRIBUTION OF PARTON 1 FROM PARTICLE 2'
*       CALL OUTHIS(IHBB1,0,TITLE,ONE,0)
*       TITLE = 'X DISTRIBUTION OF PARTON 2 FROM PARTICLE 2'
*       CALL OUTHIS(IHBB2,0,TITLE,ONE,0)
        RETURN
      ENDIF
C  debug output
      IF(IDEB(23).GT.5) WRITE(6,221)
     &  IJM1,IJM2,MSPOM,MHPOM,MSREG,MHDIR
  221 FORMAT (' STDPAR:DEBUG:JM1,JM2,MSPOM,MHPOM,MSREG,MHDIR ',6I5)
C
C  get mother data (exchange if first particle is Pomeron)
      IF(IDHEP(IJM1).EQ.45) THEN
        JM1 = IJM2
        JM2 = IJM1
      ELSE
        JM1 = IJM1
        JM2 = IJM2
      ENDIF
      NPOSP(1) = JM1
      NPOSP(2) = JM2
      IDPDG1 = IDHEP(JM1)
      IDBAM1 = IMPART(JM1)
      IDPDG2 = IDHEP(JM2)
      IDBAM2 = IMPART(JM2)
C  VDM assumption
      DELMAS = ZERO
      IF(IDHEP(JM1).EQ.22) THEN
        PMASSP(1) = RHOMAS+DELMAS
        PVIRTP(1) = PHEP(5,JM1)**2
      ELSE
        PMASSP(1) = POPAMA(IDBAM1,0)+DELMAS
        PVIRTP(1) = ZERO
      ENDIF
      IF(IDHEP(JM2).EQ.22) THEN
        PMASSP(2) = RHOMAS+DELMAS
        PVIRTP(2) = PHEP(5,JM2)**2
      ELSE
        PMASSP(2) = POPAMA(IDBAM2,0)+DELMAS
        PVIRTP(2) = ZERO
      ENDIF
C  get Pomeron/Reggeon CM system
      PC(1) = PHEP(1,JM1)+PHEP(1,JM2)
      PC(2) = PHEP(2,JM1)+PHEP(2,JM2)
      PC(3) = PHEP(3,JM1)+PHEP(3,JM2)
      PC(4) = PHEP(4,JM1)+PHEP(4,JM2)
      SS = PC(4)**2-PC(1)**2-PC(2)**2-PC(3)**2
C
      IF(SS.LT.DEPS) THEN
        CALL POPREV(1)
        IREJ = 5
        GOTO 150
      ENDIF
C
      ECMP = SQRT(SS)
      IF(IDEB(23).GE.5) THEN
        WRITE(6,'(1X,A,2I7,E12.4)')
     &  'STDPAR:DEBUG:PARTICLES,AVAILABLE ENERGY:',
     &  IDHEP(JM1),IDHEP(JM2),ECMP
        IF(IDEB(23).GE.25) CALL POPREV(0)
      ENDIF
      DO 10 I=1,4
        GAMBEP(I) = PC(I)/ECMP
 10   CONTINUE
      CALL ALTRA(GAMBEP(4),-GAMBEP(1),-GAMBEP(2),-GAMBEP(3),
     &           PHEP(1,JM1),PHEP(2,JM1),PHEP(3,JM1),
     &           PHEP(4,JM1),PTOT1,PC(1),PC(2),PC(3),PC(4))
C  rotation angle: particle 1 moves along +z
      CODP= PC(3)/PTOT1
      SIDP= SQRT((ONE-CODP)*(ONE+CODP))
      COFP=ONE
      SIFP=ZERO
      IF(PTOT1*SIDP.GT.DEPS) THEN
        COFP=PC(1)/(SIDP*PTOT1)
        SIFP=PC(2)/(SIDP*PTOT1)
        ANORF=SQRT(COFP*COFP+SIFP*SIFP)
        COFP=COFP/ANORF
        SIFP=SIFP/ANORF
      ENDIF
C  get CM momentum
      XM12 = PMASSP(1)**2
      XM22 = PMASSP(2)**2
      PCMP = XLAMB(SS,XM12,XM22)/(2.D0*ECMP)
      II = 0
C  particle combination
      IF(IDPDG2.EQ.IFPAP(2)) THEN
        IF(IDPDG1.EQ.IFPAP(1)) II = 1
      ELSE IF(IDPDG2.EQ.45) THEN
        IF(IDPDG1.EQ.IFPAP(1)) THEN
          II = 2
        ELSE IF(IDPDG1.EQ.IFPAP(2)) THEN
          II = 3
        ELSE IF(IDPDG1.EQ.45) THEN
          II = 4
        ENDIF
      ENDIF
      IF(II.EQ.0) THEN
        IF(ISWMDL(14).GT.0) THEN
          II = 1
        ELSE
          WRITE(6,'(/1X,A,2I8)')
     & 'STDPAR:ERROR:UNSUPPORTED PARTICLE COMBINATION:',IDPDG1,IDPDG2
          CALL POABRT
        ENDIF
      ENDIF
C  parton distribution functions
      IF((MHPOM+MHDIR).GT.0) THEN
        CALL ACTPDF(IDPDG1,PVIRTP(1),1)
        CALL ACTPDF(IDPDG2,PVIRTP(2),2)
        Q0SQR  = MAX(PDFQ2M(1),PDFQ2M(2))
      ENDIF
      CALL POHINT(II,ECMP,-1,MAXPRO,1,4,MSPOM+MHPOM+MHDIR)
C
      NTRY   = 10
      IREJ   = 0
C  first particle added to /HEPEVE/
      NLOR1 = NHEP+1
C
C  ---------------- direct processes -----------------
C
      IF(MHDIR.EQ.1) THEN
        CALL POHDIR(II,IVAL1,IVAL2,MSPAR1,MSPAR2,MHPAR1,MHPAR2,IREJ)
        IF(IREJ.EQ.50) RETURN
        IF(IREJ.NE.0) GOTO 150
        ICA1  = 0
        ICA2  = 0
        ICB1  = 0
        ICB2  = 0
        IPDF1 = 0
        IPDF2 = 0
C
C  QCD compton scattering
C ------------------------------
        IF(NPROHD(1).EQ.10) THEN
C  register hadron remnant
          CALL POHREM(JM2,JM1,-1,IVAL2,1,ICB1,ICB2,IUSED,IREJ)
          IPDF2 = 1000*IGRP(2)+ISET(2)
        ELSE IF(NPROHD(1).EQ.12) THEN
C  register hadron remnant
          CALL POHREM(JM1,JM2,1,IVAL1,1,ICA1,ICA2,IUSED,IREJ)
          IPDF1 = 1000*IGRP(1)+ISET(1)
C
C  photon gluon fusion
C ---------------------------
        ELSE IF(NPROHD(1).EQ.11) THEN
C  register hadron remnant
          CALL POHREM(JM2,JM1,-1,IVAL2,1,ICB1,ICB2,IUSED,IREJ)
          IPDF2 = 1000*IGRP(2)+ISET(2)
        ELSE IF(NPROHD(1).EQ.13) THEN
C  register hadron remnant
          CALL POHREM(JM1,JM2,1,IVAL1,1,ICA1,ICA2,IUSED,IREJ)
          IPDF1 = 1000*IGRP(1)+ISET(1)
C
C  double direct process (no remnant)
C ----------------------------
        ELSE IF(NPROHD(1).EQ.14) THEN
        ENDIF
C  write comments to HEPEVS
        CALL REGPAR(25,II,NPROHD(1),IDPDG1,IDPDG2,X0HD(1,1),X0HD(1,2),
     &    PTHD(1),VHD(1),N0INHD(1,1),N0INHD(1,2),ICONV1(NOUTHD(1,1)),
     &    ICONV1(NOUTHD(1,2)),IPOS,1)
        CALL REGPAR(20,ICONV1(N0INHD(1,1)),IPDF1,JM1,JM2,PREC(1,1),
     &    PREC(2,1),PREC(3,1),Q2SCA(1,1),100,NBRAHD(1,1),ICA1,ICA2,
     &    IPOS,1)
        CALL REGPAR(20,ICONV1(N0INHD(1,2)),IPDF2,JM1,JM2,PREC(1,2),
     &    PREC(2,2),PREC(3,2),Q2SCA(1,2),100,NBRAHD(1,2),ICA1,ICA2,
     &    IPOS2,1)
C  write final partons to HEPEVS
        IF((ISWMDL(8).GE.2).AND.(NPROHD(1).NE.14)) THEN
          ICI(1,1) = ICA1
          ICI(1,2) = ICA2
          ICI(2,1) = ICB1
          ICI(2,2) = ICB2
          I = 1
          IFLA(1) = IJHI1(I)
          IFLA(2) = IJHI2(I)
C  initial state radiation
          DO 130 K=1,2
            DO 135 IPA=IPOISR(K,2,I),IPOISR(K,1,I)+1,-1
              IFLB = IFLISR(K,IPA)
              IF(IFLA(K).EQ.0) THEN
                IF(IFLB.EQ.0) THEN
                  CALL SELCOL(ICI(K,1),ICI(K,2),IC1,IC2,
     &              ICI(K,1),ICI(K,2),3)
                ELSE IF(IFLB.GT.0) THEN
                  CALL SELCOL(ICI(K,1),ICI(K,2),IC1,IC2,
     &              ICI(K,1),ICI(K,2),4)
                ELSE
                  CALL SELCOL(ICI(K,1),ICI(K,2),ICI(K,1),ICI(K,2),
     &              IC1,IC2,4)
                ENDIF
              ELSE
                IF(IFLB.EQ.0) THEN
                  CALL SELCOL(ICI(K,1),ICI(K,2),ICI(K,1),ICI(K,2),
     &              IC1,IC2,2)
                ELSE
                  CALL SELCOL(ICI(K,1),ICI(K,2),IC1,IC2,
     &              ICI(K,1),ICI(K,2),2)
                ENDIF
              ENDIF
              IIFL = ICONV1(IFLB)
              CALL REGPAR(-1,IIFL,0,JM1,JM2,PHISR(K,1,IPA),
     &          PHISR(K,2,IPA),PHISR(K,3,IPA),PHISR(K,4,IPA),I*100+K,
     &          0,IC1,IC2,IPOS,1)
              CALL QUASTA(IIFL,IDHEP(JM1),5)
              IFLA(K) = IFLA(K)-IFLB
 135        CONTINUE
 130      CONTINUE
          CALL POHCOL(NPROHD(I),VHD(I),IFLA(1),ICI(1,1),ICI(1,2),
     &      IFLA(2),ICI(2,1),ICI(2,2),IJHF1(I),ICI(1,1),ICI(1,2),
     &      IJHF2(I),ICI(2,1),ICI(2,2))
          DO 140 K=1,2
            IPA = IPOISR(K,1,I)
            CALL REGPAR(-1,ICONV1(IFLISR(K,IPA)),0,JM1,JM2,
     &        PHISR(K,1,IPA),PHISR(K,2,IPA),PHISR(K,3,IPA),
     &        PHISR(K,4,IPA),-I*100,0,ICI(K,1),ICI(K,2),IPOS,1)
 140      CONTINUE
        ELSE
          CALL POHCOL(NPROHD(1),VHD(1),IJHI1(1),ICA1,ICA2,IJHI2(1),
     &      ICB1,ICB2,IJHF1(1),ICA1,ICA2,IJHF2(1),ICB1,ICB2)
          I = -1
          IF(ABS(IJHF1(1)).GT.12) I = 1
          CALL REGPAR(I,ICONV1(IJHF1(1)),0,JM1,JM2,PHARD1(1,1),
     &    PHARD1(2,1),PHARD1(3,1),PHARD1(4,1),-100,0,ICA1,ICA2,IPOS,1)
          CALL REGPAR(I,ICONV1(IJHF2(1)),0,JM1,JM2,PHARD2(1,1),
     &    PHARD2(2,1),PHARD2(3,1),PHARD2(4,1),-100,0,ICB1,ICB2,IPOS,1)
        ENDIF
C
        IF(ISWMDL(18).EQ.0) THEN
          IPOS2 = IPOS2-1
          CALL PARTPT(0,NLOR1,IPOS2,PTCUT(II),IREJ)
          IF(IREJ.NE.0) THEN
            IFAIL(26) = IFAIL(26) + 1
            GOTO 150
          ENDIF
        ENDIF
C
C  ----------------- resolved processes -------------------
C
C  single Reggeon exchange
C ----------------------------
      ELSE IF((MSREG.EQ.1).AND.(MHPOM+MSPOM.EQ.0)) THEN
C  flavours
        CALL REGFLA(JM1,JM2,IFL1,IFL2,IREJ)
        IF(IREJ.NE.0) THEN
          IFAIL(24) = IFAIL(24)+1
          GOTO 150
        ENDIF
        CALL QUASTA(IFL1,IDHEP(JM1),2)
        CALL QUASTA(IFL2,IDHEP(JM2),2)
C  cutoff / pt initialization
        CALL POMSCA(II,MSPOM,MHPOM,MSREG,IVAL1,IVAL2,MSPAR1,MSPAR2,
     &              MHPAR1,MHPAR2,IREJ)
C  colors
        CALL SELCOL(0,0,ICA1,ICA2,ICB1,ICB2,1)
        IF(((ABS(IFL1).GT.6).AND.(IFL1.GT.0))
     &     .OR.((ABS(IFL1).LE.6).AND.(IFL1.LT.0))) THEN
          CALL SWAPI(ICA1,ICB1)
        ENDIF
        ECMH = ECMP/TWO
C  registration
	IF(IPAMDL(13).GT.0) THEN
          CALL REGPAR(-1,IFL1,0,JM1,JM2,ZERO,ZERO,ECMH*XPSUB,
     &               ECMH*XPSUB,-1,0,ICA1,0,IPOS1,1)
          CALL REGPAR(-1,IFL2,0,JM1,JM2,ZERO,ZERO,-ECMH*XTSUB,
     &               ECMH*XTSUB,-1,0,ICB1,0,IPOS2,1)
        ELSE
          CALL REGPAR(-1,IFL1,0,JM1,JM2,ZERO,ZERO,ECMH,ECMH,
     &      -1,0,ICA1,1,IPOS1,1)
          CALL REGPAR(-1,IFL2,0,JM1,JM2,ZERO,ZERO,-ECMH,ECMH,
     &      -1,0,ICB1,1,IPOS2,1)
        ENDIF
C  soft pt assignment
        IF(ISWMDL(18).EQ.0) THEN
          CALL PARTPT(0,IPOS1,IPOS2,PTCUT(II),IREJ)
          IF(IREJ.NE.0) THEN
            IFAIL(26) = IFAIL(26) + 1
            GOTO 150
          ENDIF
        ENDIF
C
C  multi Reggeon / Pomeron exchange
C----------------------------------------
      ELSE
C  parton configuration
        CALL POMSCA(II,MSPOM,MHPOM,MSREG,IVAL1,IVAL2,MSPAR1,MSPAR2,
     &              MHPAR1,MHPAR2,IREJ)
        IF(IREJ.EQ.50) RETURN
        IF(IREJ.NE.0) GOTO 150
C
C  register particles
C
C  register soft partons
        IF(IVAL1.NE.0) THEN
          IF(IVAL1.LT.0) THEN
            IND1 = 3
            IVAL1=-IVAL1
          ELSE
            IND1 = 2
          ENDIF
        ELSE IF(MSPOM.EQ.0) THEN
          IND1 = MSPAR1+1-MSREG
        ELSE
          IND1 = 1
        ENDIF
        IF(IVAL2.NE.0) THEN
          IF(IVAL2.LT.0) THEN
            IND2 = 3
            IVAL2=-IVAL2
          ELSE
            IND2 = 2
          ENDIF
        ELSE IF(MSPOM.EQ.0) THEN
          IND2 = MSPAR2+1-MSREG
        ELSE
          IND2 = 1
        ENDIF
C
C  soft Pomeron final states
C -----------------------------------
        K = MSPOM+MHPOM+MSREG
        DO 50 I=1,MSPOM
C
          CALL POSPOM(II,IND1,IND2,K,ISWAP,IREJ)
          IF(IREJ.NE.0) THEN
            IFAIL(26) = IFAIL(26) + 1
            GOTO 150
          ENDIF
C
 50     CONTINUE
C
C  soft Reggeon final states
C -----------------------------------------
        DO 75 I=1,MSREG
C  flavours
          CMASS1 = SQRT(XS1(IND1)*XS2(IND2)*ECMP)
          IF(RNDM(CMASS1).LT.OHALF) THEN
            CALL SEAFLA(JM1,IFLA1,IFLB1,CMASS1)
          ELSE
            CALL SEAFLA(JM2,IFLA1,IFLB1,CMASS1)
          ENDIF
          CALL QUASTA(IFLA1,IDHEP(JM1),2)
          CALL QUASTA(IFLB1,IDHEP(JM2),2)
C  colors
          CALL SELCOL(0,0,ICA1,ICA2,ICB1,ICB2,1)
          IF(((ABS(IFLA1).GT.6).AND.(IFLA1.GT.0))
     &      .OR.((ABS(IFLA1).LE.6).AND.(IFLA1.LT.0)))
     &      CALL SWAPI(ICA1,ICB1)
C  registration
          CALL REGPAR(-1,IFLA1,0,JM1,JM2,PSOFT1(1,IND1),PSOFT1(2,IND1),
     &      PSOFT1(3,IND1),PSOFT1(4,IND1),I,0,ICA1,ICA2,IPOS1,1)
          IND1 = IND1+1
          CALL REGPAR(-1,IFLB1,0,JM2,JM1,PSOFT2(1,IND2),PSOFT2(2,IND2),
     &      PSOFT2(3,IND2),PSOFT2(4,IND2),I,0,ICB1,ICB2,IPOS2,1)
          IND2 = IND2+1
C  soft pt assignment
          IF(ISWMDL(18).EQ.0) THEN
            CALL PARTPT(0,IPOS1,IPOS2,PTCUT(II),IREJ)
            IF(IREJ.NE.0) THEN
              IFAIL(26) = IFAIL(26) + 1
              GOTO 150
            ENDIF
          ENDIF
 75     CONTINUE
C
C  hard Pomeron final states
C ------------------------------------
        IND1 = MSPAR1
        IND2 = MSPAR2
C
        DO 100 I=1,MHPOM
          IF(IVAL1.EQ.I) THEN
            IVQ = 1
            IND = 1
          ELSE IF((MSPOM.EQ.0).AND.(I.EQ.1).AND.(IVAL1.EQ.0)) THEN
            IVQ = 0
            IND = 1
          ELSE
            IVQ = -1
            IND = IND1
          ENDIF
          CALL POHREM(JM1,JM2,I,IVQ,IND,ICA1,ICA2,IUSED,IREJ)
          IF(IVQ.LT.0) IND1 = IND1-IUSED
          IF(IVAL2.EQ.I) THEN
            IVQ = 1
            IND = 1
          ELSE IF((MSPOM.EQ.0).AND.(I.EQ.1).AND.(IVAL2.EQ.0)) THEN
            IVQ = 0
            IND = 1
          ELSE
            IVQ = -1
            IND = IND2
          ENDIF
          CALL POHREM(JM2,JM1,-I,IVQ,IND,ICB1,ICB2,IUSED,IREJ)
          IF(IVQ.LT.0) IND2 = IND2-IUSED
C
C  write comments to HEPEVS
          IFLI1 = ICONV1(N0INHD(I,1))
          IFLI2 = ICONV1(N0INHD(I,2))
          IFLO1 = ICONV1(NOUTHD(I,1))
          IFLO2 = ICONV1(NOUTHD(I,2))
          CALL QUASTA(IFLI1,IDPDG1,4)
          CALL QUASTA(IFLI2,IDPDG2,4)
          CALL QUASTA(IFLO1,0,6)
          CALL QUASTA(IFLO2,0,6)
          CALL REGPAR(25,II,NPROHD(I),IDPDG1,IDPDG2,X0HD(I,1),
     &      X0HD(I,2),PTHD(I),VHD(I),N0INHD(I,1),N0INHD(I,2),
     &      IFLO1,IFLO2,IPOS,1)
          I1 = 4*I-3
          IPDF = 1000*IGRP(1)+ISET(1)
          CALL REGPAR(20,IFLI1,IPDF,JM1,JM2,PREC(1,I1),
     &      PREC(2,I1),PREC(3,I1),Q2SCA(I,1),I*100,NBRAHD(I,1),
     &      ICA1,ICA2,IPOS,1)
          I1 = I1+1
          IPDF = 1000*IGRP(2)+ISET(2)
          CALL REGPAR(20,IFLI2,IPDF,JM2,JM1,PREC(1,I1),
     &      PREC(2,I1),PREC(3,I1),Q2SCA(I,2),I*100,NBRAHD(I,2),
     &      ICB1,ICB2,IPOS,1)
C  register hard scattered partons
          IF((I.EQ.1).AND.(ISWMDL(8).GE.2)) THEN
            ICI(1,1) = ICA1
            ICI(1,2) = ICA2
            ICI(2,1) = ICB1
            ICI(2,2) = ICB2
            IFLA(1) = IJHI1(I)
            IFLA(2) = IJHI2(I)
C  initial state radiation
            DO 230 K=1,2
              DO 235 IPA=IPOISR(K,2,I),IPOISR(K,1,I)+1,-1
                IFLB = IFLISR(K,IPA)
                IF(IFLA(K).EQ.0) THEN
                  IF(IFLB.EQ.0) THEN
                    CALL SELCOL(ICI(K,1),ICI(K,2),IC1,IC2,
     &                ICI(K,1),ICI(K,2),3)
                  ELSE IF(IFLB.GT.0) THEN
                    CALL SELCOL(ICI(K,1),ICI(K,2),IC1,IC2,
     &                ICI(K,1),ICI(K,2),4)
                  ELSE
                    CALL SELCOL(ICI(K,1),ICI(K,2),ICI(K,1),ICI(K,2),
     &                IC1,IC2,4)
                  ENDIF
                ELSE
                  IF(IFLB.EQ.0) THEN
                    CALL SELCOL(ICI(K,1),ICI(K,2),ICI(K,1),ICI(K,2),
     &                IC1,IC2,2)
                  ELSE
                    CALL SELCOL(ICI(K,1),ICI(K,2),IC1,IC2,
     &                ICI(K,1),ICI(K,2),2)
                  ENDIF
                ENDIF
                IIFL = ICONV1(IFLB)
                CALL REGPAR(-1,IIFL,0,JM1,JM2,PHISR(K,1,IPA),
     &            PHISR(K,2,IPA),PHISR(K,3,IPA),PHISR(K,4,IPA),I*100+K,
     &            0,IC1,IC2,IPOS,1)
                CALL QUASTA(IIFL,IDHEP(JM1),5)
                IFLA(K) = IFLA(K)-IFLB
 235          CONTINUE
 230        CONTINUE
            CALL POHCOL(NPROHD(I),VHD(I),IFLA(1),ICI(1,1),ICI(1,2),
     &        IFLA(2),ICI(2,1),ICI(2,2),IJHF1(I),ICI(1,1),ICI(1,2),
     &        IJHF2(I),ICI(2,1),ICI(2,2))
            DO 240 K=1,2
              IPA = IPOISR(K,1,I)
              CALL REGPAR(-1,ICONV1(IFLISR(K,IPA)),0,JM1,JM2,
     &          PHISR(K,1,IPA),PHISR(K,2,IPA),PHISR(K,3,IPA),
     &          PHISR(K,4,IPA),-I*100,0,ICI(K,1),ICI(K,2),IPOS,1)
 240        CONTINUE
          ELSE
            CALL POHCOL(NPROHD(I),VHD(I),IJHI1(I),ICA1,ICA2,IJHI2(I),
     &             ICB1,ICB2,IJHF1(I),ICA1,ICA2,IJHF2(I),ICB1,ICB2)
            CALL REGPAR(-1,ICONV1(IJHF1(I)),0,JM1,JM2,PHARD1(1,I),
     &        PHARD1(2,I),PHARD1(3,I),PHARD1(4,I),-I*100,0,ICA1,ICA2,
     &        IPOS,1)
            CALL REGPAR(-1,ICONV1(IJHF2(I)),0,JM1,JM2,PHARD2(1,I),
     &        PHARD2(2,I),PHARD2(3,I),PHARD2(4,I),-I*100,0,ICB1,ICB2,
     &        IPOS,1)
          ENDIF
 100    CONTINUE
C  end of resolved parton registration
      ENDIF
C
C  assign "soft" pt for soft (spectator) partons in hard Pomerons
      IF((MHDIR+MHPOM.GT.0).AND.(ISWMDL(24).GE.0)) THEN
        CALL PARTPT(1,NLOR1,NHEP,PTCUT(II),IREJ)
        IF(IREJ.NE.0) THEN
          IFAIL(25) = IFAIL(25) + 1
          GOTO 150
        ENDIF
      ENDIF
C
C  assign "soft" pt for partons in soft Pomerons
      IF((MHDIR.EQ.0).AND.(ISWMDL(18).EQ.1)) THEN
        CALL PARTPT(0,NLOR1,NHEP,PTCUT(II),IREJ)
        IF(IREJ.NE.0) THEN
          IFAIL(26) = IFAIL(26) + 1
          GOTO 150
        ENDIF
      ENDIF
C  boost back to lab frame
      CALL LTRHEP(NLOR1,NHEP,CODP,SIDP,COFP,SIFP,GAMBEP(4),GAMBEP(1),
     &            GAMBEP(2),GAMBEP(3))
      RETURN
C
C  rejection treatment
 150  CONTINUE
      IFAIL(3) = IFAIL(3)+1
      IF(IDEB(23).GT.2) WRITE(6,'(/1X,A,4I6)')
     &  'STDPAR:WARNING:REJECTION (MSPOM,MHPOM,MSREG,MHDIR)',
     &  MSPOM,MHPOM,MSREG,MHDIR
      RETURN
      END
