#!/bin/bash
#
# show manual 
CURRENT_DIR=`pwd`
#
# assume linux
VIEWPROGRAM="acroread"


args=$#           # Number of args passed.
if [ $args == 0  ]
then
   echo "did not specify MC type!"
   exit 1;
fi
MCFILE=$1

# RunMC directory 
RUNMCX=$RUNMC


# is this windows or linux ? 
OSYSTEM=`uname -s`
if [ "$OSYSTEM" != "Linux" ]
then
echo "operating system=$OSYSTEM ";
  VIEWPROGRAM="C:\Program Files\Adobe\Acrobat 6.0\Acrobat\Acrobat.exe";
  echo "call to $VIEWPROGRAM";
  echo "if nothing shows up then edit:"
  echo "\"$RUNMC/main/runmc/show_manual_mc.sh\" file!" 
  RUNMCX=$RUNMCwin32
fi


# PYTHIA
if [ "$MCFILE" == "1" ]
then 
FILE=$RUNMCX"/main/mcarlo/pythia-6/doc/pythia6.pdf"
"$VIEWPROGRAM" $FILE &
fi

# HERWIG
if [ "$MCFILE" == "2" ]
then 
FILE=$RUNMCX"/main/mcarlo/herwig-65/doc/herwig.pdf"
"$VIEWPROGRAM" $FILE &
fi

# ARIADNE
if [ "$MCFILE" == "3" ]
then 
FILE=$RUNMCX"/main/mcarlo/ariadne-412/doc/ariadne.pdf"
"$VIEWPROGRAM" $FILE &
fi

# LEPTO
if [ "$MCFILE" == "4" ]
then
FILE=$RUNMCX"/main/mcarlo/lepto-65/doc/lepto-6.5.1.pdf"
"$VIEWPROGRAM" $FILE &
fi

# AROMA 
if [ "$MCFILE" == "5" ]
then
FILE=$RUNMCX"/main/mcarlo/aroma-22/doc/DESY-96-058.pdf"
"$VIEWPROGRAM" $FILE &
fi

# CASCADE
if [ "$MCFILE" == "6" ]
then
FILE=$RUNMCX"/main/mcarlo/cascade-12/doc/manual.pdf"
"$VIEWPROGRAM" $FILE &
fi

# PHOJET 
if [ "$MCFILE" == "7" ]
then
FILE=$RUNMCX"/main/mcarlo/phojet-11/doc/phoman5c.pdf"
"$VIEWPROGRAM" $FILE &
fi


# RAPGAP 
if [ "$MCFILE" == "8" ]
then
FILE=$RUNMCX"/main/mcarlo/rapgap-3/doc/rapgap208.pdf"
"$VIEWPROGRAM" $FILE &
fi

exit 0;
