/* This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/



//jpe.java - the main class of the JPE application
//(C)2000-2003 Mark Beynon
//mark@jpedit.co.uk
//http://www.jpedit.co.uk

//last edited 31 October 2003


package com.jpe;

// BeanShell
import bsh.util.JHEPConsole;
import bsh.*;


import java.awt.AWTEvent;
import java.awt.Insets;
import java.awt.Font;
import java.awt.Color;
import java.awt.FlowLayout;
import java.awt.Dimension;
import java.awt.BorderLayout;
import java.awt.Cursor;
import java.awt.Toolkit;
import java.awt.Container;
import java.awt.DefaultKeyboardFocusManager;

import java.awt.event.WindowStateListener;
import java.awt.event.WindowListener;
import java.awt.event.ActionListener;
import java.awt.event.ComponentListener;
import java.awt.event.ComponentAdapter;
import java.awt.event.ComponentEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseAdapter;
import java.awt.event.FocusListener;
import java.awt.event.WindowEvent;
import java.awt.event.ActionEvent;
import java.awt.event.MouseEvent;
import java.awt.event.FocusEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.KeyListener;
import java.awt.event.KeyEvent;
import java.awt.event.InputEvent;
import javax.swing.event.ChangeListener;
import javax.swing.event.ChangeEvent;

import javax.swing.tree.*;

import javax.swing.text.DefaultEditorKit;

import javax.swing.event.DocumentEvent;
import javax.swing.event.UndoableEditListener;
import javax.swing.event.UndoableEditEvent;
import javax.swing.event.CaretListener;
import javax.swing.event.CaretEvent;

import javax.swing.UIManager;
import javax.swing.JFrame;
import javax.swing.border.EtchedBorder;
import javax.swing.JFileChooser;
import javax.swing.JColorChooser;
import javax.swing.JTabbedPane;
import javax.swing.JTextField;
import javax.swing.JTextArea;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JMenu;
import javax.swing.KeyStroke;
import javax.swing.JTree;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import javax.swing.JToolBar;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JLabel;
import javax.swing.JToggleButton;
import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JOptionPane;
import javax.swing.Action;
import javax.swing.AbstractAction;
import javax.swing.SwingUtilities;
import javax.swing.JMenuItem;
import javax.swing.JCheckBoxMenuItem;
import javax.swing.JRadioButtonMenuItem;
import javax.swing.JPopupMenu;
import javax.swing.ButtonGroup;
import javax.swing.JMenuBar;

import java.util.Properties;
import java.util.Hashtable;
import java.util.Vector;
import java.util.StringTokenizer;
import java.util.Date;
import java.sql.Time;

import java.io.File;
import java.io.IOException;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.RandomAccessFile;

import javax.swing.plaf.metal.MetalLookAndFeel;
import com.sun.java.swing.plaf.motif.MotifLookAndFeel;
import com.sun.java.swing.plaf.windows.WindowsLookAndFeel;

import javax.swing.undo.UndoManager;
import javax.swing.Timer;

import javax.swing.text.BadLocationException;

import java.awt.datatransfer.Transferable;
import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.UnsupportedFlavorException;

import com.filefilters.*;
import com.sr.*;
import com.io.*;
import com.javac.*;
import com.make.*;
import com.misc.*;
import com.utils.*;
import com.actions.*;
import com.jpe.Constants;

import com.syntax.*;
import com.textarea.*;


//the main class
public class jpe extends JFrame implements ActionListener, MouseListener, UndoableEditListener,
                                           ChangeListener, FocusListener, KeyListener, Constants,
                                           WindowStateListener, ComponentListener, WindowListener {


	private mbJTextArea Editors[]      = new mbJTextArea[99];

	private mbJTextArea jta;

	private mbJTree mtree;

        private JHEPConsole BeanShellconsole;

        private Interpreter inBS;

	private long fileModified[]        = new long[99];

	private boolean dirty[]            = new boolean[99];

	private boolean readOnly[]         = new boolean[99];

	private String fileNames[]         = new String[99];

	private String untitledFiles[]     = new String[99];

	private File currFileTypes[]       = new File[99];

	private int currentCursorPos[]     = new int[99];

	private String syntaxType[]        = new String[99];

	protected UndoManager undo[]       = new UndoManager[99];

	private JButton bm1, cl1;
        private JButton projpath; 
        private JButton projrefresh; 
	private Vector bm[]                = new Vector[99];
	private Vector bmToolTip[]         = new Vector[99];
	private Vector cl[]                = new Vector[99];
	private Vector clToolTip[]         = new Vector[99];

        private JPopupMenu jtreemenu;

	private int bmcount = 5;
	private int clcount = 5;
	private int currentbm = 0;

	private Thread javacThread;
	private Thread javaThread;
        private Thread makeThread;

        private LogMessage LogM;

	private String os;
	private String ver;

        private FileInputStream propFile; 

	private int menucount = 0;

	private int menulimit = 4;

	private boolean fullpath = false;

	private boolean lockfile = true;

	private boolean fpath = false;

	private boolean firstTime = true;

	private boolean firstRun = false;

	private boolean lastdoc = false;
	private boolean checkfilemod = false;
	private boolean readonlynotify = false;
	private boolean autosave = false;

	private  int UndoLimit = 50;

	private int EditCount = 0;

	private int untitled = 1;

	private int tabplacement = 1;

	private JTextField jtf;
	private JTabbedPane jtp, jtp2, jtp3, jtp4;
	private JSplitPane jsp, jsp2, jsp3;
	private JScrollPane scroll, scroll3;

	private FileTreeModel model;

	private JToolBar jpButtons;

	private JMenuItem jmiOpen, jmiExit, jmiHelp, jmiAbout, jmiSave, jmiSaveAs, jmiSelectAll, jmiPrint,
		jmiPrintPrev, jmiCopy, jmiPaste, jmiCut, jmiClose, jmiDel, jmiPlainDoc,
		jmiJavaDoc, jmiJavaAppDoc, jmiDate, jmiMake, jmiROOT, jmiPYTHON, jmiPopCopy, jmiPopPaste, jmiPopCut, jmiPopSelectAll,
		jmiPopDel, jmiSystem, jmiSysPaste, jmiSysCopy, jmiL1Copy,jmiSysCut, jmiL1Cut, jmiClearClip, jmiLicense, jmiReadme,
		jmiPageSetupa, jmiPageSetupb, jmiFont, jmiUndo, jmiUndoAll, jmiRedo, jmiRedoAll, jmiPopRedo, jmiPopUndo, jmiRedoDis,
		jmiUndoDis, jmiSearch, jmiSearchNext, jmiReplace, jmiZipAs, jmiJavaCode, jmiSwingCode, jmiWordCount, jmiJdk, jmiInfo,
		jmiWebSite, jmiMenuCount, jmiUndoLimit, jmiBmCount, jmiClCount, jmiClClear, jmiClRecents, jmiLocal1, jmiLockFile;

	private JMenuItem jmiCLStatus, jmiJavacOptions, jmiDelLine, jmiPopSysPaste, jmiPopL1Paste, jmiPopL2Paste,
		jmiPopL3Paste, jmiPopSysCut, jmiPopL1Cut, jmiPopL2Cut, jmiPopL3Cut, jmiPopSysCopy, jmiPopL1Copy,
		jmiPopL2Copy, jmiPopL3Copy, jmiClearClips, jmiSetSelectionColor, jmiSetBracketColor,
		jmiSetCaretColor, jmiSetLineHighlight, jmiGutterWidth, jmiGutterBak, jmiGutterFor,
		jmiGutterHigh, jmiGutterInterval, jmiDefaults, jmiProj, jmiDir, jmiJavaRunOptions, jmiPopClose,
		jmiJavac, jmiJava, jmiSetTools, jmiShowTools, jmiCloseAll, jmiSaveAll, jmiPopDate, jmiPopTime,
		jmiPopHtml, jmiPopJava1, jmiPopJava2, jmiBmAdd, jmiBmRem, jmiBmNext, jmiBmPrev, jmiPopBmAdd, jmiPopBmRem,
		jmiTabs, jmiTimerCount, jmiErrorLog;

	private JMenuItem jmiJavaComment, jmiJavaBlockComment, jmiHTMLComment, jmiToUpperCase, jmiToLowerCase, jmiInvertCase;

	private JCheckBoxMenuItem jmiBlockCaret, jmiEolMarkers, jmiInvalidLines, jmiLine, jmiBracket, jmiCaretBlink,
		jmiGutter, jmiFullPath, jmiTabAtBottom,jmiLastDoc, jmiReadOnlyNotify, jmiStartTimer, jmiCheckFileMod;

	private JButton jbtOpen, jbtSave, jbtSaveAs, jbtNew, jbtClose, jbtPrintPrev,
		jbtCut, jbtCopy, jbtPaste, jbtDel, jbtPrint, jbtRedo, jbtUndo, jbtzip, jbtClipSys, jbtTool, jbtRefresh,
		jbtSaveAll, jbtCloseAll, jbtBmAdd, jbtBmRem, jbtBmNext, jbtBmPrev, jbtSpacer, jbtMakeRMC, jbtROOT, jbtPYTHON, jbtErrorLog;

	private JToggleButton jtbProjWin, jtbLockFile;

	private JFileChooser jFileChooser = new JFileChooser();
	private JFileChooser jChooser = new JFileChooser();
	private JFileChooser dirChooser = new JFileChooser();
	private JColorChooser jcolorChooser = new JColorChooser();
	private JLabel jpeStatusBar, lockedLabel;
	private JLabel lineCount, lineNo;
	private JPanel mainPanel, JToolMain, JtoolBar, textPanel;
	private JPanel statusPanel;

	private static String dir = "";

	private JPopupMenu jpopupmenu = new JPopupMenu();
	private JRadioButtonMenuItem b1, b2, b3, jav, txt, js, xml, cpp, cxx, prog, bibtex, make, php, python, pythonRoot, fortran, shell, xhtml, latex, bat, kumac;
	private JMenu newRecents = new JMenu("Recents");

  private JMenu fileMenu, editMenu, searchMenu, viewMenu, prefsMenu, projectMenu, toolsMenu, jdkMenu, codeMenu, makeMenu;

        // this is absolute defults
        private static Properties  p;

// keep here only those which are different from the default

	private String outString, jdk;

	private Icon savedicon, unsavedicon, savednodoc;

	private String system, Options, RunOptions, classpath;

	private boolean fontChanged, killOpen, isjpeDoc, colorChanged, isfilebrowser;
	private boolean caretChanged, bracketChanged, highlightChanged, blockCaret, eolmarker;
	private boolean invalidlines, lines, brackets, caretblink, gutter, gutterwidth, gutterfor;
	private boolean gutterbak, gutterhigh, gutterinterval, isjdk, isdir;

	private JButton jbtSearch, jbtReplace;

	private JToolBar clButtons = new JToolBar();
	private JToolBar bmButtons = new JToolBar();


	private static Font font = new Font("Comic Sans MS", 0, 12);
	private int gutwidth, tabs;
	private int gutint;
	private File output, prefs, root;

	private ReplaceDialog dlg;
	private SearchDialog sdlg;

	private FontDialog fdlg;

	private ButtonGroup syntax = new ButtonGroup();

	private Color textHighlightColor = new Color(0xccccff);
	private Color caretColor = Color.blue;
	private Color bracketColor = Color.red;
	private Color highlightColor = new Color(0xe0e0e0);
	private Color gutterFor = new Color(170, 170, 170);
	private Color gutterBak = Color.white;
	private Color gutterHigh = new Color(71, 71, 71);

	private JavacDialog3 javacdlg;

	private boolean javacerror = false;

	private int appWidth = 800;
	private int appHeight = 600;

	private int divsize = 125;
	private int divsize2 = 200;

  private Timer saveTimer;
	private int savetime = 60000;

	private Timer modTimer;
	private int modtime = 1000;

	private int toolbarwidth = TOOL_BAR_WIDTH;

	private long lastmodified;
	private boolean ismodified;

	private static Intro intro;

	private PrefsDialog prefsDialog;

	private JPanel jpClosePanel;
	private JButton jbtCloseCross;



	// Main method
	public static void main(String[] args)
	{


                File file=null;
                if (args.length > 0) {
                file = new File (args[0]);
                String sname=file.getAbsolutePath();
                int separ=sname.lastIndexOf(File.separator);
                dir=sname.substring(0,separ); 
                System.out.println("File to open:"+args[0]);
                } else {
                   dir=System.getProperty("user.dir"); 
                }




                // enviromental variables
                SetEnv.init();

                ResourceLoader.init("com/resources/");
		intro = new Intro();

		intro.setProg(5);
		intro.setProgText("Initialising..");

		//instantiate the main class "jpe"
		jpe f = new jpe();

		//center and make visible
		f.addComponentListener(f);
		Utils.centerComponent(f);
		f.setVisible(true);
	//	f.checkJdk();
		f.setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

		if (args.length > 0)
		{
		  for(int i = 0; i < args.length; i++)
		  {
        f.open(args[i]);
	    }
    }

    f.setFont(SYSTEM_FONT);
    f.setCurrentFont(font);

		f.GrabFocus();

	}

	//start of constructor
	public jpe()
	{
		super();
		//add a window listener to "this" frame so we can close the window
		this.addWindowListener(new WindowHandler(this));

    //get the OS name and add it to title bar
		os = System.getProperty("os.name");
		ver = System.getProperty("os.version");
		setTitle("EHEP Version 1.0 ");
		// setIconImage(Toolkit.getDefaultToolkit().getImage("images" + fileSep + "jpe.gif"));

		intro.setProg(10);
		intro.setProgText("Loading GUI");

		Container contentPane = getContentPane();

		//this allows us to change the look and feel
		try
		{
			UIManager.setLookAndFeel(UIManager.getCrossPlatformLookAndFeelClassName());
		} catch (Exception exc)
		{
			System.out.println("Error loading L&F: " + exc);
		}

		intro.setProg(15);

		//set filechooser classes

		// jFileChooser.addChoosableFileFilter(new filterTypeText());
		// jFileChooser.addChoosableFileFilter(new filterTypeJava());
                // jFileChooser.addChoosableFileFilter(new filterTypeFortran());
                // jFileChooser.addChoosableFileFilter(new filterTypeCPP());
 
		intro.setProg(20);
		intro.setProgText("Loading Menu");


		//Create menu bar
		JMenuBar jmb = new JMenuBar();
		setJMenuBar(jmb);

		//Add operations to menu
		fileMenu = MenuFactory.createMenu(ResourceLoader.getCommand("menu.file"), 0, 'F', null, this);
		JMenu helpMenu = MenuFactory.createMenu("About", 0, 0, null, this);
		JMenu copyMenu = MenuFactory.createMenu("Copy to..", 0, 0, ResourceLoader.getImageIcon("copySub"), this);
		JMenu cutMenu = MenuFactory.createMenu("Cut to..", 0, 0, ResourceLoader.getImageIcon("cutSub"), this);
		JMenu pasteMenu = MenuFactory.createMenu("Paste from..", 0, 0, ResourceLoader.getImageIcon("pasteSub"), this);
		JMenu ClipMenu = MenuFactory.createMenu("View Clip Board", 0, 0, null, this);
		JMenu newMenu = MenuFactory.createMenu("New..", 0, 'N', ResourceLoader.getImageIcon("newSub"), this);
		JMenu newStyle = MenuFactory.createMenu("Look and Feel", 0, 0, null, this);
		editMenu = MenuFactory.createMenu("Edit", 0, 'E', null, this);
		searchMenu = MenuFactory.createMenu("Search", 0, 'S', null, this);
		codeMenu = MenuFactory.createMenu("Code", 0, 0, null, this);
		viewMenu = MenuFactory.createMenu("View", 0, 'V', null, this);
		JMenu toolMenu = MenuFactory.createMenu("Tool Bars", 0, 0, null, this);
		prefsMenu = MenuFactory.createMenu("Preferences", 0, 'P', null, this);
		JMenu syntaxMenu = MenuFactory.createMenu("Syntax Color", 0, 0, null, this);
		JMenu editorMenu = MenuFactory.createMenu("Editor Options", 0, 0, null, this);
		JMenu gutterMenu = MenuFactory.createMenu("Gutter Options", 0, 0, null, this);
		projectMenu = MenuFactory.createMenu("Project", 0, 'R', null, this);
		jdkMenu = MenuFactory.createMenu("SDK", 0, 'D', null, this);
                makeMenu = MenuFactory.createMenu("Run", 0, 'D', null, this);
		toolsMenu = MenuFactory.createMenu("Tools", 0, 'T', null, this);

		intro.setProg(21);


		//add menus to toolbar
		jmb.add(fileMenu);
		jmb.add(editMenu);
		jmb.add(viewMenu);
		jmb.add(projectMenu);
		jmb.add(jdkMenu);
                jmb.add(makeMenu);
		jmb.add(searchMenu);
		jmb.add(toolsMenu);
		jmb.add(prefsMenu);
		jmb.add(helpMenu);


		intro.setProg(22);

		projectMenu.add(jmiProj = MenuFactory.createMenuItem("Project Directory", "choose a project directory", null, 0, 0, this));

		//add submenus to toolsMenu
		toolsMenu.add(jmiClRecents = MenuFactory.createMenuItem("Clear Recents", null, null, 0, 0, this));
		//toolsMenu.add(jmiClearClips = MenuFactory.createMenuItem("Clear Clipboards", null, null, 0, 0, this));
		toolsMenu.addSeparator();
		toolsMenu.add(jmiWordCount = MenuFactory.createMenuItem("Word Count", null, null, 0, 0, this));
		toolsMenu.add(jmiCLStatus = MenuFactory.createMenuItem("Clear Status Bar", null, null, 0, 0, this));
		toolsMenu.addSeparator();
		//toolsMenu.add(ClipMenu);
		toolsMenu.add(newStyle);
		toolsMenu.addSeparator();
		toolsMenu.add(jmiErrorLog = MenuFactory.createMenuItem("Error log", "View the application error log", null, 0, 0, this));

		//add to jdk menu
		jdkMenu.add(jmiJavacOptions = MenuFactory.createMenuItem("Java Options", "Set the options for javac and java", null, 0, 0, this));
		jdkMenu.addSeparator();
		jdkMenu.add(jmiJavac = MenuFactory.createMenuItem("javac", "run the Java compiler", javac, 'J', 0, this));
		jdkMenu.add(jmiJava = MenuFactory.createMenuItem("java", "run the Java interpreter", runjava, '|', 0, this));
		jdkMenu.addSeparator();
		jdkMenu.add(jmiJdk = MenuFactory.createMenuItem("SDK Home", "Specify a path to the "+ fileSep +"bin directory of your SDK", null, 0, 0, this));

                makeMenu.add(jmiMake = MenuFactory.createMenuItem("make", "run \"make\" from current directory",runjava, 'M', 0, this));
                 makeMenu.add(jmiROOT = MenuFactory.createMenuItem("root", "run \"root\" on active file",runroot, 'R', 0, this));
                  makeMenu.add(jmiPYTHON = MenuFactory.createMenuItem("python", "run \"python\" on active file",runpython, 'P', 0, this));


		//add to view menu
		//viewMenu.add(toolMenu);
		//viewMenu.addSeparator();
		viewMenu.add(syntaxMenu);

		syntaxMenu.add(jav = ToggleFactory.createJRadButMenuItem("Java", true, this));
		syntax.add(jav);
		syntaxMenu.add(txt = ToggleFactory.createJRadButMenuItem("Plain Text", false, this));
    syntax.add(txt);
		syntaxMenu.add(js = ToggleFactory.createJRadButMenuItem("Javascript", false, this));
    syntax.add(js);
		syntaxMenu.add(bat = ToggleFactory.createJRadButMenuItem("Batch File", false, this));
    syntaxMenu.add(xml = ToggleFactory.createJRadButMenuItem("XML", false, this));
    syntax.add(xml);

    syntaxMenu.add(cpp = ToggleFactory.createJRadButMenuItem("Plain C++", false, this));
    syntax.add(cpp);

    syntaxMenu.add(cxx = ToggleFactory.createJRadButMenuItem("C++/ROOT", false, this));
    syntax.add(cxx);

    syntaxMenu.add(prog = ToggleFactory.createJRadButMenuItem("Progress", false, this));
    syntax.add(prog);

    syntaxMenu.add(python = ToggleFactory.createJRadButMenuItem("Plain Python", false, this));
    syntax.add(python);

    syntaxMenu.add(pythonRoot = ToggleFactory.createJRadButMenuItem("Python/ROOT", false, this));
    syntax.add(pythonRoot);

    syntaxMenu.add(php = ToggleFactory.createJRadButMenuItem("PHP", false, this));
    syntax.add(php);

    syntaxMenu.add(make = ToggleFactory.createJRadButMenuItem("Makefile", false, this));
    syntax.add(make);

    syntaxMenu.add(fortran = ToggleFactory.createJRadButMenuItem("Fortran", false, this));
    syntax.add(fortran);

    syntaxMenu.add(latex = ToggleFactory.createJRadButMenuItem("LaTeX", false, this));
    syntax.add(latex);

    syntaxMenu.add(bibtex = ToggleFactory.createJRadButMenuItem("BiBTeX", false, this));
    syntax.add(bibtex);

    syntaxMenu.add(xhtml = ToggleFactory.createJRadButMenuItem("HTML", false, this));
    syntax.add(xhtml);

    syntaxMenu.add(shell = ToggleFactory.createJRadButMenuItem("Shell", false, this));
    syntax.add(shell);

    syntaxMenu.add(kumac = ToggleFactory.createJRadButMenuItem("Kumac", false, this));
    syntax.add(kumac);

		//add to prefs Menu
		//prefsMenu.add(editorMenu);
		prefsMenu.add(jmiSetSelectionColor = MenuFactory.createMenuItem("Editor Options", "Set editor options", null, 0, 0, this));
		prefsMenu.addSeparator();
		prefsMenu.add(jmiDefaults = MenuFactory.createMenuItem("Default settings", "Restore the Editors default settings", null, 0, 0, this));

		//editorMenu.add(jmiSetSelectionColor = MenuFactory.createMenuItem("Selection Color", "Change the text selection color", null, 0, 0, this));

		jmiLine = ToggleFactory.createJCheckBoxMenuItem("Line Highlight", "Enable line highlighting", this);
		jmiSetLineHighlight = MenuFactory.createMenuItem("Line Highlight Color", "Change the line highlight color", null, 0, 0, this);

		jmiBlockCaret = ToggleFactory.createJCheckBoxMenuItem("Block Caret", "Enable the block caret", this);
		jmiCaretBlink = ToggleFactory.createJCheckBoxMenuItem("Blink Caret", "Enable the caret blink", this);
		jmiSetCaretColor = MenuFactory.createMenuItem("Caret Color", "Change the Caret color", null, 0, 0, this);

		jmiBracket = ToggleFactory.createJCheckBoxMenuItem("Delimeter check", "Enable the delimiter checker", this);
		jmiSetBracketColor = MenuFactory.createMenuItem("Delimeter Color", "Change the delimiter check color", null, 0, 0, this);

		jmiEolMarkers = ToggleFactory.createJCheckBoxMenuItem("EOL Markers", "Enable end of line markers", this);
		jmiInvalidLines = ToggleFactory.createJCheckBoxMenuItem("Invalid Lines", "Enable invalid line markers", this);

		jmiFont = MenuFactory.createMenuItem("Font..", null, null, 0, 0, this);

		jmiFullPath = ToggleFactory.createJCheckBoxMenuItem("Full Tab Path", "Show full file path in Tab", this);
		jmiTabAtBottom = ToggleFactory.createJCheckBoxMenuItem("Tabs on Bottom", "Place the tabs on the bottom of the Document Window", this);

		jmiLastDoc = ToggleFactory.createJCheckBoxMenuItem("Open Last Doc", "Automatically open the last document used in a previous session", this);

		jmiCheckFileMod = ToggleFactory.createJCheckBoxMenuItem("Check for file modification", "Promts the user to refresh if a file has been modified ouside of the editor", this);

		jmiReadOnlyNotify = ToggleFactory.createJCheckBoxMenuItem("Read Only Notify", "Warn if an opened file is read only", this);

		jmiMenuCount = MenuFactory.createMenuItem("Recent Files", "Choose the number of files in the recent document history menu", null, 0, 0, this);
		jmiBmCount = MenuFactory.createMenuItem("Number of Bookmarks", "Choose the number of Bookmarks in the toolbar", null, 0, 0, this);

		jmiStartTimer = ToggleFactory.createJCheckBoxMenuItem("Start/Stop auto save", "Start/Stop theauto save timer", this);
		jmiTimerCount = MenuFactory.createMenuItem("Save Timer", "Set the auto save time", null, 0, 0, this);

		jmiUndoLimit = MenuFactory.createMenuItem("Number of Undo's", "Sets the number of Undo/Redos for the editor (default is 50)", null, 0, 0, this);
		jmiTabs = MenuFactory.createMenuItem("Tab size", "Sets the size of the tabs (default is 2)", null, 0, 0, this);

		//editorMenu.add(gutterMenu);
		jmiGutter = ToggleFactory.createJCheckBoxMenuItem("Show Gutter", "Make the gutter visible", this);
		jmiGutterWidth = MenuFactory.createMenuItem("Gutter Width", "Preset the gutter width", null, 0, 0, this);

		jmiGutterBak = MenuFactory.createMenuItem("Gutter Color", "Preset the gutter background", null, 0, 0, this);
		jmiGutterFor = MenuFactory.createMenuItem("Font Color", "Preset the font Color", null, 0, 0, this);

		jmiGutterHigh = MenuFactory.createMenuItem("Highlight Color", "Adjust line number highlights", null, 0, 0, this);
		jmiGutterInterval = MenuFactory.createMenuItem("Highlight Interval", "Adjust line number highlights intervals", null, 0, 0, this);

		//add submenus to clip
		//ClipMenu.add(jmiLocal1 = MenuFactory.createMenuItem("Clip", null, null, 0, 0, this));
		//ClipMenu.add(jmiLocal2 = MenuFactory.createMenuItem("Clip 2", null, null, 0, 0, this));
		//ClipMenu.add(jmiLocal3 = MenuFactory.createMenuItem("Clip 3", null, null, 0, 0, this));
		//ClipMenu.add(jmiSystem = MenuFactory.createMenuItem("System", null, null, 0, 0, this));

		//add submenus to File
		fileMenu.add(newMenu);
		fileMenu.add(jmiOpen = MenuFactory.createMenuItem("Open..", null, OpeN, 'O', 0, this));
		fileMenu.addSeparator();
		fileMenu.add(jmiSave = MenuFactory.createMenuItem("Save", null, SavE, 'S', 0, this));
		fileMenu.add(jmiSaveAs = MenuFactory.createMenuItem("Save As..", null, SaveaS, 0, 0, this));
		fileMenu.add(jmiSaveAll = MenuFactory.createMenuItem("Save All..", null, saveAllsub, 0, 0, this));
		fileMenu.addSeparator();
		fileMenu.add(jmiZipAs = MenuFactory.createMenuItem(" Zip As..", null, zipas, 0, 0, this));
		fileMenu.addSeparator();
		fileMenu.add(newRecents);
		fileMenu.addSeparator();
		fileMenu.add(jmiPageSetupb = MenuFactory.createMenuItem("Basic Page Setup", null, null, 0, 0, this));
		fileMenu.add(jmiPageSetupa = MenuFactory.createMenuItem("Advanced Page Setup", null, null, 0, 0, this));
		fileMenu.add(jmiPrintPrev = MenuFactory.createMenuItem("Print Preview", null, PrintpreV, 0, 0, this));
		fileMenu.add(jmiPrint = MenuFactory.createMenuItem("Print", null, PrinT, 0, 0, this));
		fileMenu.addSeparator();
		fileMenu.add(jmiClose = MenuFactory.createMenuItem("Close", null, ClosE, 'W', 0, this));
		fileMenu.addSeparator();
		fileMenu.add(jmiCloseAll = MenuFactory.createMenuItem("Close All", null, closeAllsub, 0, 0, this));
		fileMenu.addSeparator();
		fileMenu.add(jmiExit = MenuFactory.createMenuItem("Quit", null, null, 'Q', 0, this));

		intro.setProg(24);

		//set style sub menus checkboxes
		newStyle.add(b1 = ToggleFactory.createJRadButMenuItem("Metal", true, this));
		newStyle.add(b2 = ToggleFactory.createJRadButMenuItem("Motif", false, this));
		newStyle.add(b3 = ToggleFactory.createJRadButMenuItem("Windows", false, this));
		newStyle.setFont(SYSTEM_FONT);

		ButtonGroup g = new ButtonGroup();
		g.add(b1);
		g.add(b2);
		g.add(b3);

		//set new sub menus
		newMenu.add(jmiPlainDoc = MenuFactory.createMenuItem("Text Document", null, null, 'N', 0, this));
		newMenu.add(jmiJavaDoc = MenuFactory.createMenuItem("Java Application", null, null, 0, 0, this));
		newMenu.add(jmiJavaAppDoc = MenuFactory.createMenuItem("Java Applet", null, null, 0, 0, this));

		intro.setProg(25);

		codeMenu.add(jmiJavaComment = MenuFactory.createMenuItem("Java Comment //",null, null, 0, 0, this));
		codeMenu.add(jmiJavaBlockComment = MenuFactory.createMenuItem("Java Comment /* */",null, null, 0, 0, this));
		codeMenu.add(jmiHTMLComment = MenuFactory.createMenuItem("HTML Comment <!- -->",null, null, 0, 0, this));
		codeMenu.addSeparator();
		codeMenu.add(jmiToUpperCase = MenuFactory.createMenuItem("Upper Case",null, null, 0, 0, this));
		codeMenu.add(jmiToLowerCase = MenuFactory.createMenuItem("Lower Case",null, null, 0, 0, this));
		codeMenu.add(jmiInvertCase = MenuFactory.createMenuItem("Invert Case",null, null, 0, 0, this));
		codeMenu.addSeparator();

		//add submenus to edit
		editMenu.add(jmiUndo = MenuFactory.createMenuItem("Undo",null, UndO, 'Z', 0, this));
		editMenu.add(jmiUndoAll = MenuFactory.createMenuItem("Undo All",null, UndoAll, 0, 0, this));
		editMenu.add(jmiRedo = MenuFactory.createMenuItem("Redo",null, RedO, 'Y', 0, this));
		editMenu.add(jmiRedoAll = MenuFactory.createMenuItem("Redo All",null, RedoAll, 0, 0, this));
		editMenu.addSeparator();
		editMenu.add(jmiBmAdd = MenuFactory.createMenuItem("Add Bookmark", null, bmadd, 'a', 0, this));
		editMenu.add(jmiBmRem = MenuFactory.createMenuItem("Delete Bookmarks", null, bmrem, 'd', 0, this));
		//editMenu.add(jmiBmNext = MenuFactory.createMenuItem("Next Bookmark", null, bmnext, 0, 0, this));
		//editMenu.add(jmiBmPrev = MenuFactory.createMenuItem("Previous Bookmark", null, bmprev, 0, 0, this));
		editMenu.addSeparator();
		editMenu.add(jmiSelectAll = MenuFactory.createMenuItem("Select All", null, null, 'A', 0, this));
		editMenu.addSeparator();
		editMenu.add(copyMenu);
		editMenu.add(cutMenu);
		editMenu.add(pasteMenu);
		editMenu.addSeparator();
		editMenu.add(jmiClClear = MenuFactory.createMenuItem("Clear Clipboards", null, null, 0, 0, this));
		editMenu.addSeparator();
		editMenu.add(codeMenu);


		//add items to cut menu
		cutMenu.add(jmiSysCut = MenuFactory.createMenuItem("System Clipboard", null, null, 'X', 0, this));
		cutMenu.add(jmiL1Cut = MenuFactory.createMenuItem("Local Clipboard", null, null, 'x', 0, this));

		//add items to copy menu
		copyMenu.add(jmiSysCopy = MenuFactory.createMenuItem("System Clipboard", null, null,'C', 0, this));
		copyMenu.add(jmiL1Copy = MenuFactory.createMenuItem("Local Clipboard", null, null, 'c', 0, this));


		intro.setProg(27);

		//add items to paste menu
		pasteMenu.add(jmiSysPaste = MenuFactory.createMenuItem("System Clipboard", null, null, 'V', 0, this));


		//add items to edit menu
		editMenu.addSeparator();
		editMenu.add(jmiDel = MenuFactory.createMenuItem("Delete", null, DeL, 0, 0, this));
		editMenu.add(jmiDelLine = MenuFactory.createMenuItem("Delete Line", null, DelLine, 0, 0, this));
		editMenu.addSeparator();
		editMenu.add(jmiDate = MenuFactory.createMenuItem("Date/Time", null, null, 0, 0, this));


		//add items to search menu
		searchMenu.add(jmiSearch = MenuFactory.createMenuItem("Find", null, SearcH, 0, 0, this));
		searchMenu.add(jmiSearchNext = MenuFactory.createMenuItem("Find Next", null, Searcnext, 0, 0, this));
		searchMenu.addSeparator();
		searchMenu.add(jmiReplace = MenuFactory.createMenuItem("Replace", null, ReplacE, 0, 0, this));

		jmiSearch.setAccelerator(KeyStroke.getKeyStroke("F5"));
		jmiSearchNext.setAccelerator(KeyStroke.getKeyStroke("control F5"));

		jmiReplace.setAccelerator(KeyStroke.getKeyStroke("F6"));


		//add submenus to Help
		helpMenu.add(jmiWebSite = MenuFactory.createMenuItem("Web Site", null, null, 0, 0, this));
		helpMenu.add(jmiInfo = MenuFactory.createMenuItem("System Info", null, null, 0, 0, this));
	// 	helpMenu.add(jmiLicense = MenuFactory.createMenuItem("License", null, null, 0, 0, this));
		helpMenu.add(jmiReadme = MenuFactory.createMenuItem("Readme", null, null, 0, 0, this));


		intro.setProg(30);
		intro.setProgText("Loading Popup Menu");


		JMenu popPasteMenu = MenuFactory.createMenu("Paste from..", 0, 0, null, this);
		popPasteMenu.setIcon(PastE);
		popPasteMenu.add(jmiPopSysPaste = MenuFactory.createMenuItem("System Clipboard", null, null, 'V', 0, this));


		intro.setProg(32);

		JMenu popCutMenu = MenuFactory.createMenu("Cut to..", 0, 0, null, this);
		popCutMenu.setIcon(CuT);
		popCutMenu.add(jmiPopSysCut = MenuFactory.createMenuItem("System Clipboard", null, null, 'X', 0, this));
		popCutMenu.add(jmiPopL1Cut = MenuFactory.createMenuItem("Local Clipboard", null, null, 'x', 0, this));


		JMenu popCopyMenu = MenuFactory.createMenu("Copy to..", 0, 0, null, this);
		popCopyMenu.setIcon(CopY);
		popCopyMenu.add(jmiPopSysCopy = MenuFactory.createMenuItem("System Clipboard", null, null, 'C', 0, this));
		popCopyMenu.add(jmiPopL1Copy = MenuFactory.createMenuItem("Local Clipboard", null, null, 'c', 0, this));


		JMenu popCommentMenu = MenuFactory.createMenu("Comment selected..", 0, 0, null, this);

		popCommentMenu.add(jmiPopHtml = MenuFactory.createMenuItem("<!-- -->", null, null, 0, 0, this));
		popCommentMenu.add(jmiPopJava1 = MenuFactory.createMenuItem("/*...*/", null, null, 0, 0, this));
		popCommentMenu.add(jmiPopJava2 = MenuFactory.createMenuItem("//", null, null, 0, 0, this));

		JMenu popInsertMenu = MenuFactory.createMenu("Insert..", 0, 0, null, this);

		popInsertMenu.add(jmiPopTime = MenuFactory.createMenuItem("Date/Time", null, null, 0, 0, this));
		popInsertMenu.addSeparator();
		popInsertMenu.add(popCommentMenu);


		intro.setProg(35);


		//create the right click popup menu
		jpopupmenu.add(jmiPopUndo = MenuFactory.createMenuItem("Undo", null, UndO, 'Z', 0, this));
		jpopupmenu.add(jmiPopRedo = MenuFactory.createMenuItem("Redo", null, RedO, 'Y', 0, this));
		jpopupmenu.addSeparator();
		jpopupmenu.add(jmiPopBmAdd = MenuFactory.createMenuItem("Add Bookmark", null, bmadd, 'a', 0, this));
		jpopupmenu.add(jmiPopBmRem = MenuFactory.createMenuItem("Delete Bookmarks", null, bmrem, 'd', 0, this));
		jpopupmenu.addSeparator();
		jpopupmenu.add(jmiPopSelectAll = MenuFactory.createMenuItem("Select All", null, null, 'A', 0, this));
		jpopupmenu.addSeparator();
		jpopupmenu.add(popCutMenu);
		jpopupmenu.add(popCopyMenu);
		jpopupmenu.add(popPasteMenu);
		jpopupmenu.addSeparator();
		jpopupmenu.add(popInsertMenu);
		jpopupmenu.add(jmiPopDel = MenuFactory.createMenuItem("Delete", null, DeL, 0, 0, this));
		jpopupmenu.addSeparator();
		jpopupmenu.add(jmiPopClose = MenuFactory.createMenuItem("Close", null, null, 'W', 0, this));

    jmiPopClose.setIcon(ClosE);

		intro.setProg(50);
		intro.setProgText("Building tree component");

		//*********************************************************************************************
		//***************** code for file manager and text component instantiation ********************
		//*********************************************************************************************

		root = new File(dir);

		// Create a TreeModel object to represent our tree of files
         model = new FileTreeModel(root);

  	//Change defaults so that all new tree components will have new icons
  	UIManager.put("Tree.leafIcon", leafIcon);
  	UIManager.put("Tree.expandedIcon", expandedIcon);
  	UIManager.put("Tree.collapsedIcon", collapsedIcon);
  	UIManager.put("Tree.openIcon", openIcon);
  	UIManager.put("Tree.closedIcon", closedIcon);


  	// Create a JTree and tell it to display our model
  	mtree = new mbJTree(fpath);
  	mtree.setFont(SYSTEM_FONT);

  	mtree.setModel(model);
  	mtree.setShowsRootHandles(true);
		mtree.putClientProperty("JTree.lineStyle", "Angled");
		mtree.addMouseListener(this);
		mtree.setRootVisible(false);


                intro.setProg(52);
		intro.setProgText("Building text component");

		Editors[EditCount] = new mbJTextArea();

		//place the tree in a scrollpane so it scrolls!
		scroll = new JScrollPane(mtree);

		intro.setProg(53);

		//instantiate the tabbed pane and pass it our text area through the addTab method.
		jtp = new JTabbedPane();
		jtp.setTabLayoutPolicy(1);
		jtp.setTabPlacement(tabplacement);
		jtp.addTab("Untitled 1", saveIcon, Editors[0], "Untitled 1");
		jtp.setSelectedIndex(0);
		jtp.setFont(SYSTEM_FONT);
		jtp.setForegroundAt(0, Color.blue);

		jtp.addMouseListener(this);
		jtp.addChangeListener(this);

		//create another tabbed pane for the project manager
		jtp2 = new JTabbedPane();
		jtp2.setFont(SYSTEM_FONT);

    jtp2.addTab("", blankIcon, scroll);

/*

    File[] roots = File.listRoots();
    Hashtable rootdir = new Hashtable();
    rootdir.put("Local", roots);
*/

/*
  	// Create a JTree and tell it to display our model
  	// JTree tree = new JTree(rootdir);
  	// tree.setFont(SYSTEM_FONT);

  	// Update only one tree instance
  	DefaultTreeCellRenderer renderer2 = new DefaultTreeCellRenderer();

  	renderer2.setLeafIcon(driveIcon);
  	renderer2.setOpenIcon(pcIcon);

  	tree.setCellRenderer(renderer2);


    tree.setShowsRootHandles(false);
		tree.putClientProperty("JTree.lineStyle", "Angled");
		tree.addMouseListener(this);
		tree.setRootVisible(false);
		//tree.makeVisible(new TreePath(tree.getModel()));
		tree.expandRow(0);
*/


    //JScrollPane scroll4 = new JScrollPane(jta = new JTextArea());
    jta = new mbJTextArea();
    jta.getPainter().setFont(SYSTEM_FONT);
    jta.setTokenMarker(null);
    jta.setCaretVisible(false);
    jta.getPainter().setCaretColor(Color.lightGray);
    jta.getPainter().setLineHighlightEnabled(true);
    jta.getPainter().setLineHighlightColor(Color.lightGray);
    jta.getPainter().setSelectionColor(Color.white);
    jta.getPainter().addMouseListener(this);
    jta.setRequestFocusEnabled(true);
    jta.setEditable(false);

		jtp4 = new JTabbedPane();
		jtp4.setFont(SYSTEM_FONT);
                 // error messages 

                /*	
         	jtp4.addTab("Errors",jta);
                // log output
                LogM= new LogMessage();
                jtp4.addTab("Log messages",LogM);
                */
                intro.setProgText("Bean shell components..");
                intro.setProg(55);
                JPanel clearShell = new JPanel();
                BeanShellconsole = new JHEPConsole();
                jtp4.addTab("Shell", BeanShellconsole);
                jtp4.addTab("Clear", clearShell);               
 
                BeanShellconsole.setFont(SYSTEM_FONT); 
                inBS = new Interpreter(BeanShellconsole);
                new Thread ( inBS ).start(); // start


                 // Register a change listener
     jtp4.addChangeListener(new ChangeListener() {
        public void stateChanged(ChangeEvent evt) {
            JTabbedPane pane = (JTabbedPane)evt.getSource();
            // Get current tab
            int sel = pane.getSelectedIndex();
            if (sel == 1)   {

                 String ss="clear();";
                 BeanShellconsole.Execute( ss );
                 BeanShellconsole.ClearText();
                jtp4.setSelectedIndex(0);

            }


        }
    });



		jsp3 = new JSplitPane(JSplitPane.VERTICAL_SPLIT, true, jtp , jtp4);
		jsp3.setOneTouchExpandable(true);
		jsp3.setDividerSize(7);



    // JScrollPane scroll2 = new JScrollPane(tree);
    //jtp2.addTab("", blankIcon, scroll2);

    //create 3rd tabbed pane for file browser directory tree
   
// jtp3 = new JTabbedPane();
	//	jtp3.setFont(SYSTEM_FONT);
//		jtp3.addTab("File Browser", null, scroll2);

		//initialises 2nd split pane
	//	jsp2 = new JSplitPane(JSplitPane.VERTICAL_SPLIT, jtp3, jtp2);
	//	jsp2.setOneTouchExpandable(true);
//		jsp2.setDividerSize(7);
//		jsp2.setDividerLocation(150);



		//create a split pane and pass it the project manager and tabbed pane containing
		//text component
	//	jsp = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT, jsp2 , jsp3);
                jsp = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT, jtp2 , jsp3);
 
          	jsp.setOneTouchExpandable(true);
		jsp.setDividerSize(7);
		jsp.setDividerLocation(0);


		intro.setProg(55);
		intro.setProgText("Loading Keyboard Mappings");


		//set the syntax to java by default
		Editors[0].setTransferHandler(new DropHandler(this));
		Editors[0].setTokenMarker(new JavaTokenMarker());
    Editors[0].setRightClickPopup(jpopupmenu);
    Editors[0].setRequestFocusEnabled(true);
    Editors[0].addCaretListener(new CaretListenerLabel());
		Editors[0].getDocument().addDocumentListener(new jpeDocListener(this));
		Editors[0].getDocument().addUndoableEditListener(this);
		Editors[0].setMagicCaretPosition(0);
		Editors[0].setTabSize(2);
		Editors[0].getInputHandler().addKeyBinding("C+X",  new cutAction(this));
		Editors[0].getInputHandler().addKeyBinding("C+C",  new copyAction(this));
		Editors[0].getInputHandler().addKeyBinding("C+V",  new pasteAction(this));
		Editors[0].getInputHandler().addKeyBinding("C+A",  new selectAllAction(this));
		Editors[0].getInputHandler().addKeyBinding("A+F",  new file());
    Editors[0].getInputHandler().addKeyBinding("A+E",  new edit());
		Editors[0].getInputHandler().addKeyBinding("A+V",  new view());
		Editors[0].getInputHandler().addKeyBinding("A+S",  new search());
		Editors[0].getInputHandler().addKeyBinding("A+P",  new prefs());
		Editors[0].getInputHandler().addKeyBinding("A+D",  new jdk());
		Editors[0].getInputHandler().addKeyBinding("A+T",  new tools());
		Editors[0].getInputHandler().addKeyBinding("A+R",  new proj());
		Editors[0].getInputHandler().addKeyBinding("C+O",  new openAction(this));
		Editors[0].getInputHandler().addKeyBinding("C+N",  new newAction(this));
	  Editors[0].getInputHandler().addKeyBinding("C+S",  new saveAction(this));
    Editors[0].getInputHandler().addKeyBinding("C+W",  new closeAction(this));
	  Editors[0].getInputHandler().addKeyBinding("C+Q",  new quitAction(this));
		Editors[0].getInputHandler().addKeyBinding("CA+C", new clipCopyAction(this));
		Editors[0].getInputHandler().addKeyBinding("CA+X", new clipCutAction(this));
		Editors[0].getInputHandler().addKeyBinding("CS+A", new addBookMarkAction(this));
		Editors[0].getInputHandler().addKeyBinding("CS+D", new deleteBookMarkAction(this));
		Editors[0].getInputHandler().addKeyBinding("C+Z",  new undoAction(this));
		Editors[0].getInputHandler().addKeyBinding("C+Y",  new redoAction(this));
		Editors[0].getInputHandler().addKeyBinding("TAB",  new tabAction(this));
		Editors[0].getInputHandler().addKeyBinding("S+TAB",new backTabAction(this));
		Editors[0].getInputHandler().addKeyBinding("F5",   new searchAction(this));
		Editors[0].getInputHandler().addKeyBinding("F6",   new replaceAction(this));
		Editors[0].getInputHandler().addKeyBinding("C+F5", new searchNextAction(this));
		Editors[0].getInputHandler().addKeyBinding("ENTER",new enterAction(this));
		Editors[0].getInputHandler().addKeyBinding("C+J",  new javacAction(this));
		Editors[0].getInputHandler().addKeyBinding("CA+J", new javaAction(this));


		undo[0]      = new UndoManager();
		bm[0]        = new Vector();
		cl[0]        = new Vector();
		bmToolTip[0] = new Vector();
		clToolTip[0] = new Vector();
		currentCursorPos[0] = 0;



		//*********************************************************************************************
		//*********************************************************************************************

		intro.setProg(60);
		intro.setProgText("Building ToolBar");

		//Create toolbar for icons
		jpButtons = new JToolBar();
		jpButtons.setFloatable(false);


		intro.setProg(62);

		//main panel holds all tool bars
		JToolMain = new JPanel();

		JtoolBar = new JPanel();

		intro.setProg(65);

		//Add buttons to toolbar
		jpButtons.setLayout(new FlowLayout(0, 0, 0));
		jpButtons.add(jbtNew = ButtonFactory.createButton(New, "New", this));
		jpButtons.addSeparator(r);
		jpButtons.add(jbtOpen = ButtonFactory.createButton(Open, "Open", this));
		jpButtons.add(jbtRefresh = ButtonFactory.createButton(Refresh, "Refresh current document", this));
		jpButtons.addSeparator(r);
		jpButtons.add(jbtSave = ButtonFactory.createButton(Save, "Save File", this));
		jpButtons.add(jbtSaveAll = ButtonFactory.createButton(saveAll, "Save All", this));
		jpButtons.add(jbtSaveAs = ButtonFactory.createButton(SaveAs, "Save As", this));
		jpButtons.addSeparator(r);
		jpButtons.add(jbtUndo = ButtonFactory.createButton(Undo, "Undo", this));
		jpButtons.add(jbtRedo = ButtonFactory.createButton(Redo, "Redo", this));
		jpButtons.addSeparator(r);
		jpButtons.add(jbtPrint = ButtonFactory.createButton(Print, "Print", this));
		jpButtons.addSeparator(r);
		jpButtons.add(jbtSearch = ButtonFactory.createButton(Search, "Find", this));
		jpButtons.add(jbtReplace = ButtonFactory.createButton(Replace, "Replace", this));
		jpButtons.addSeparator(r);
		jpButtons.add(jbtCopy = ButtonFactory.createButton(Copy, "Copy", this));
		jpButtons.add(jbtCut = ButtonFactory.createButton(Cut, "Cut", this));
		jpButtons.add(jbtPaste = ButtonFactory.createButton(Paste, "Paste", this));
		jpButtons.addSeparator(r);
		jpButtons.add(jbtDel = ButtonFactory.createButton(Del, "Delete", this));
		jpButtons.addSeparator(r);
		jpButtons.add(jbtMakeRMC = ButtonFactory.createButton(runjava, "Run \"make\" from current directory", this));
                jpButtons.add(jbtROOT = ButtonFactory.createButton(runroot, "Run \"root\" on active file", this));
                jpButtons.add(jbtPYTHON = ButtonFactory.createButton(runpython, "Run \"python\" on active file", this));

    jpButtons.addSeparator(r);


		JPanel JtoolBar2 = new JPanel();
		JtoolBar2.setLayout(new FlowLayout(FlowLayout.LEFT, 5, 0));
		JtoolBar2.add(clButtons);
		JtoolBar2.add(bmButtons);

    intro.setProg(67);

		//***********************************************************************************************************************

		// main toolbar
		JToolMain.setLayout(new BoxLayout(JToolMain, BoxLayout.Y_AXIS));
		JToolMain.add(Box.createVerticalGlue());
		JToolMain.add(JtoolBar);
		JToolMain.add(Box.createVerticalGlue());
		JToolMain.add(JtoolBar2);
		JToolMain.add(Box.createVerticalGlue());


		//***************************************************************************************

		//create a text field for the goto box
		jtf = new JTextField(5);
		jtf.addActionListener(this);

		//create a label to hold goto text
		JLabel Goto = new JLabel("Line# ");
		Goto.setFont(SYSTEM_FONT);


    intro.setProg(70);
		intro.setProgText("Building Status Panel");

    lineCount = new JLabel();
		lineCount.setFont(SYSTEM_FONT);


		//add buttons and other stuff to the toolbar
		JtoolBar.setLayout(new FlowLayout(FlowLayout.LEFT, 5, 0));
		JtoolBar.add(jpButtons);
		JtoolBar.add(Goto);
		JtoolBar.add(jtf);
		JtoolBar.add(lineCount);

    intro.setProg(72);

    savedicon   = ResourceLoader.getImageIcon("saved");
		unsavedicon = ResourceLoader.getImageIcon("unsaved");
//		savednodoc  = ResourceLoader.getImageIcon("savednodoc");

		intro.setProg(75);

		jpeStatusBar = new JLabel();
		jpeStatusBar.setFont(SYSTEM_FONT);
                
		jpeStatusBar.setIcon(clockdis);
		jpeStatusBar.setToolTipText("Auto save disabled");
		jpeStatusBar.setIconTextGap(10);

		lockedLabel = new JLabel();
		lockedLabel.setFont(SYSTEM_FONT);
		lockedLabel.setIcon(funlocked);
		lockedLabel.setToolTipText("un-locked");
		lockedLabel.setIconTextGap(5);

		JPanel statusInfo = new JPanel();
//		statusInfo.setLayout(new FlowLayout(FlowLayout.CENTER, 5, 1));
                statusInfo.setLayout(new BorderLayout() );
//		statusInfo.setBorder(new EtchedBorder(EtchedBorder.LOWERED));
//		statusInfo.add(lockedLabel, BorderLayout.CENTER);
                statusInfo.add(jpeStatusBar, BorderLayout.EAST);


                jpeStatusBar.setPreferredSize(new java.awt.Dimension(250,24));
                jpeStatusBar.setMinimumSize(new java.awt.Dimension(50, 24));



		//code for bottom status panel
		statusPanel = new JPanel();
                statusPanel.setLayout(new BorderLayout() );  
                statusPanel.setPreferredSize(new java.awt.Dimension(250,24));
 
         
                 // project path
                JPanel handlefile= new JPanel();
                handlefile.setLayout(new BorderLayout() ); 

                projrefresh = new JButton(null, Refresh);
                projrefresh.setToolTipText("Refresh File Browser");
                projrefresh.setPreferredSize(new java.awt.Dimension(20, 20));

                projpath = new JButton( dir, driveIcon );
                projpath.setToolTipText("Set new project directory");
                projpath.addActionListener(new java.awt.event.ActionListener() {
                 public void actionPerformed(java.awt.event.ActionEvent evt) {
                       setProjectDir();
                       projpath.setText(dir);

                }  });

                 // refresh 
                projrefresh.addActionListener(new java.awt.event.ActionListener() {
                 public void actionPerformed(java.awt.event.ActionEvent evt) {
                       setProject();
                }  });

                handlefile.add(projrefresh, BorderLayout.WEST );
                handlefile.add(projpath, BorderLayout.CENTER );

                statusPanel.add(handlefile, BorderLayout.WEST );
		statusPanel.add(statusInfo, BorderLayout.CENTER);

                MemoryMonitor memMon = new MemoryMonitor();
                memMon.setPreferredSize(new java.awt.Dimension(65, 20));
                memMon.setMinimumSize(new java.awt.Dimension(30, 20));
                statusPanel.add( memMon, BorderLayout.EAST );

		intro.setProg(77);
		intro.setProgText("Building GUI");


		//********************************************************************************************
		//********************************************************************************************
		// Set FlowLayout for the frame and add components to it
		getContentPane().setLayout(new BorderLayout());
		getContentPane().add(JToolMain, BorderLayout.NORTH);
		getContentPane().add(jsp, BorderLayout.CENTER);
	 	getContentPane().add(statusPanel, BorderLayout.SOUTH);


		//********************************************************************************************
		//********************************************************************************************

		intro.setProg(80);
		intro.setProgText("Initialising Variables");

		//set state of various string and boolean values
		Editors[EditCount].setEditable(true);

                intro.setProg(82);

		system = new String();

		intro.setProg(85);

		isdir = false;
		isfilebrowser = false;
		isjdk = false;
		dirty[EditCount] = false;
		readOnly[EditCount] = false;

		intro.setProg(87);

		killOpen = false;
		isjpeDoc = false;

		intro.setProg(90);
		intro.setProgText("Loading Classes");


		//set undo buttons to disabled
		jbtUndo.setEnabled(false);
		jbtRedo.setEnabled(false);
		jmiUndo.setEnabled(false);
		jmiUndoAll.setEnabled(false);
		jmiRedo.setEnabled(false);
		jmiRedoAll.setEnabled(false);
		jmiPopUndo.setEnabled(false);
		jmiPopRedo.setEnabled(false);

		jmiSearchNext.setEnabled(true);

		intro.setProg(92);

		jbtRedo.setDisabledIcon    (ResourceLoader.getImageIcon("redodis"));
		jbtUndo.setDisabledIcon    (ResourceLoader.getImageIcon("undodis"));
		jmiRedo.setDisabledIcon    (ResourceLoader.getImageIcon("redosubdis"));
		jmiRedoAll.setDisabledIcon (ResourceLoader.getImageIcon("redoalldis"));
		jmiUndo.setDisabledIcon    (ResourceLoader.getImageIcon("undosubdis"));
		jmiUndoAll.setDisabledIcon (ResourceLoader.getImageIcon("undoalldis"));
		jbtSave.setDisabledIcon    (ResourceLoader.getImageIcon("savedis"));
		jbtSaveAll.setDisabledIcon (ResourceLoader.getImageIcon("savealldis"));
		jmiSave.setDisabledIcon    (ResourceLoader.getImageIcon("savedis"));
		jmiSaveAll.setDisabledIcon (ResourceLoader.getImageIcon("savealldis"));
		jmiPopRedo.setDisabledIcon (ResourceLoader.getImageIcon("redosubdis"));
		jmiPopUndo.setDisabledIcon (ResourceLoader.getImageIcon("undosubdis"));

		intro.setProg(95);
		intro.setProgText("Obtaining O.S fonts");


    jmiSave.setEnabled(false);
		jbtSave.setEnabled(false);
		jmiSaveAll.setEnabled(false);
		jbtSaveAll.setEnabled(false);


		jmiBmRem.setEnabled(false);
		jmiPopBmRem.setEnabled(false);

		jmiClClear.setEnabled(false);


		intro.setProg(97);
		intro.setProgText("Preparing to start....");


		sdlg = new SearchDialog(this);
		dlg = new ReplaceDialog(this);

		intro.setProg(100);
		intro.setProgText("Starting EHEP 1.0" + VER_NO);

    javacdlg = new JavacDialog3(this);

		outString = new String("");
		Options = new String("");
		RunOptions = new String("");
		classpath = new String("");

		newRecents.setFont(SYSTEM_FONT);

		setCursor();

		saveTimer = new Timer(savetime, new timerAction());
		modTimer = new Timer(modtime, new modAction());
		modTimer.start();

		boolean xx=setPrefs();
		undo[0].setLimit(UndoLimit);

		if (xx == true) setRecents();
		setProject();
		setUpClipBoards();
		setUpBookMarks();
		setDividerLocation();
		setDividerLocation2(0);

		this.setSize(appWidth, appHeight);

		//==================================================
		//================ T E S T  C O D E ================
		//==================================================

		jpClosePanel = new JPanel();
		jpClosePanel.setLayout(new FlowLayout(FlowLayout.RIGHT, 0, 0));

		int a = this.getWidth();
		int b = toolbarwidth;
		int c = a - b;
		jpClosePanel.setPreferredSize(new Dimension(c, 23));
		jpClosePanel.setMinimumSize(new Dimension(c, 23));

    jbtCloseCross = ButtonFactory.createButton(DelSub, "Close current document", this);
		jbtCloseCross.setFont(SYSTEM_FONT);
		jbtCloseCross.setPreferredSize(new Dimension(20, 20));
		jbtCloseCross.setRolloverEnabled(true);
		jpClosePanel.add(jbtCloseCross);

		JtoolBar.add(jpClosePanel);

      intro.hideSplash();


    Editors[EditCount].setTabSize(tabs);
		Editors[EditCount].requestFocusInWindow();


	}


	 /* Key Listeners */

   public void keyPressed(KeyEvent e)    {}
   public void keyReleased(KeyEvent e)   {}
   public void keyTyped(KeyEvent e)      {}


	 /* Focus Listeners */
	 public void focusLost(FocusEvent e)   {}
   public void focusGained(FocusEvent e) {}

   public void processKeyEvent(KeyEvent e)
	 {
	    super.processKeyEvent(e);
   }


	  public void updateCursorPos()
	  {
		  Editors[selectedTabIndex()].setCaretPosition(currentCursorPos[selectedTabIndex()]);
		  GrabFocus();
	  }



  //**********************************************************************************************************
	//                                          Clipboards
	//**********************************************************************************************************

    //load the contents of the system clipboard
	//when the program starts up any text in the system clipboard is added to the clipboard manager
	private void loadSysClip()
	{
		Transferable t = Toolkit.getDefaultToolkit().getSystemClipboard().getContents(null);
		try {
			if (t != null && t.isDataFlavorSupported(DataFlavor.stringFlavor)) {
				system = (String)t.getTransferData(DataFlavor.stringFlavor);
                         if (system != null) {  		
         		          setSystemClipToolTip(system);
				 jbtClipSys.setEnabled(true); } 
			}
		}
		catch (UnsupportedFlavorException e)
		{
			System.out.println("Error loading clipboard " + e.getMessage());
			Utils.userMessage("Error", SYSTEM_ERROR, 1);
	    Utils.writeErrorLog("Error loading clipboard " + e.getMessage());
		}
		catch (IOException e)
		{

		}
	}




	public void setClipBoards()
  {
     for (int i = 0; i < clcount; i++)
     {
				clButtons.getComponentAtIndex(i).setEnabled(false);
				jmiL1Cut.setEnabled(false);
				jmiL1Copy.setEnabled(false);

				jmiPopL1Cut.setEnabled(false);
				jmiPopL1Copy.setEnabled(false);

				JButton bt = (JButton)clButtons.getComponentAtIndex(i);

				bt.setToolTipText("Clipboard " + (i + 1));
     }


    	  if (cl[selectedTabIndex()].size() > 0)
    	  {
					for (int i = 0; i < cl[selectedTabIndex()].size() ; ++i)
					{
						 if ((cl[selectedTabIndex()].elementAt(i) == null) || (cl[selectedTabIndex()].elementAt(i) == ""))
						 {
								clButtons.getComponentAtIndex(i).setEnabled(false);

						 }

						 else
						 {
								clButtons.getComponentAtIndex(i).setEnabled(true);

								JButton bt = (JButton)clButtons.getComponentAtIndex(i);

								bt.setToolTipText("Clipboard " + i + ": " + clToolTip[selectedTabIndex()].elementAt(i).toString());

						 }
					}

    	  	Editors[selectedTabIndex()].grabFocus();

    	  	jmiClClear.setEnabled(true);

    	  	jmiL1Cut.setEnabled(true);
	        jmiL1Copy.setEnabled(true);

	        jmiPopL1Cut.setEnabled(true);
	        jmiPopL1Copy.setEnabled(true);

    	  }

    	  else
    	  {

	        jmiClClear.setEnabled(false);

	        jmiL1Cut.setEnabled(true);
	        jmiL1Copy.setEnabled(true);

	        jmiPopL1Cut.setEnabled(true);
	        jmiPopL1Copy.setEnabled(true);
    	  }


    	  if (cl[selectedTabIndex()].size() == clcount)
    	  {
    	  	jmiClClear.setEnabled(true);

    	  	jmiL1Cut.setEnabled(false);
	        jmiL1Copy.setEnabled(false);

	        jmiPopL1Cut.setEnabled(false);
	        jmiPopL1Copy.setEnabled(false);
    	  }


    	  	Editors[selectedTabIndex()].grabFocus();

    }


  public void setSystemClipToolTip(String s)
  {
  	int x = s.length();

		String t;

			if(x > 75)
				t = s.substring(0, 75);
			else
			  t = s.substring(0, x);

		jbtClipSys.setToolTipText(t);

  }

  public void setUpClipBoards()
  {
  	Dimension r = new Dimension(8, 0);

		clButtons.setFloatable(false);

		clButtons.setLayout(new FlowLayout(FlowLayout.LEFT, 0, 0));

		for (int i = 0; i < clcount; i++)
		{
			clButtons.add(cl1 = ButtonFactory.createButton(clip, "Clipboard " + (i + 1), "D", this));
		}

		clButtons.addSeparator(r);
		clButtons.add(jbtSpacer = ButtonFactory.createButton(spacer, 3, 16, this));
		clButtons.addSeparator(r);

		clButtons.add(jbtClipSys = ButtonFactory.createButton(clipsys, "System Clipboard", this));
		jbtClipSys.setDisabledIcon(new ImageIcon("images" + fileSep + "clipsysdis.gif"));
		jbtClipSys.setEnabled(false);

		// loadSysClip();

		clButtons.addSeparator(r);
		clButtons.add(jbtSpacer = ButtonFactory.createButton(spacer, 3, 16, this));
		clButtons.addSeparator(r);

  }


  public void addSystemClipBoard(String p)
  {
  	system = Editors[selectedTabIndex()].getSelectedText();
  	setSystemClipToolTip(system);

    if (p.equals("Cut"))
		{
			Editors[selectedTabIndex()].cut();
		}

		else
		{
			Editors[selectedTabIndex()].copy();
		}
			jbtClipSys.setEnabled(true);
  }


  public void addClipBoard(String p)
  {
    String s = Editors[selectedTabIndex()].getSelectedText();

    if(s != null)
    {
			cl[selectedTabIndex()].addElement(s);


			if(cl[selectedTabIndex()].size() <= clcount)
			{

			clButtons.getComponentAtIndex(cl[selectedTabIndex()].size() - 1).setEnabled(true);

			int x = s.length();

			String t;

				if(x > 75)
					t = s.substring(0, 75);
				else
					t = s.substring(0, x);

			JButton bt = (JButton)clButtons.getComponentAtIndex(cl[selectedTabIndex()].size() - 1);

			clToolTip[selectedTabIndex()].addElement(t);

			bt.setToolTipText("Clipboard " + cl[selectedTabIndex()].size() + ": " + t);

			if (p.equals("Cut"))
			{
				Editors[selectedTabIndex()].setSelectedText("");
			}


				if (cl[selectedTabIndex()].size() == clcount)
				{
					jmiClClear.setEnabled(true);
					jmiL1Cut.setEnabled(false);
					jmiL1Copy.setEnabled(false);

					jmiPopL1Cut.setEnabled(false);
					jmiPopL1Copy.setEnabled(false);
				}

				jmiClClear.setEnabled(true);

			}

				Editors[selectedTabIndex()].grabFocus();
	  }
  }


  public void getNextClipBoard(int i)
  {

  	String s = null;

       
       if (cl[selectedTabIndex()].size()>i) {
   
        s=cl[selectedTabIndex()].elementAt(i).toString();
        Clip1 clipdlg = new Clip1(this, s, "ClipBoard " + new String(Integer.toString(i)));
		Utils.centerComponent(clipdlg);
		clipdlg.setVisible(true);
        }

  }


  public void removeClipBoards()
	{
		cl[selectedTabIndex()].clear();
		clToolTip[selectedTabIndex()].clear();

		for (int i = 0; i < clcount; i++)
  	{
  	  clButtons.getComponentAtIndex(i).setEnabled(false);

  	  JButton bt = (JButton)clButtons.getComponentAtIndex(i);

		  bt.setToolTipText("Clipboard " + (i + 1));
  	}

    	jmiClClear.setEnabled(false);

    	jmiL1Cut.setEnabled(true);
	    jmiL1Copy.setEnabled(true);

	    jmiPopL1Cut.setEnabled(true);
	    jmiPopL1Copy.setEnabled(true);

		Editors[selectedTabIndex()].grabFocus();
	}


  //**********************************************************************************************************
	//************************************************** B O O K M A R K S *************************************
	//**********************************************************************************************************


	public void setBookMarks()
  {
  	for (int i = 0; i < bmcount; i++)
  	{
	  	bmButtons.getComponentAtIndex(i).setEnabled(false);
	  	jmiPopBmRem.setEnabled(false);
      jmiBmRem.setEnabled(false);

      jmiPopBmAdd.setEnabled(false);
      jmiBmAdd.setEnabled(false);

      JButton bt = (JButton)bmButtons.getComponentAtIndex(i);

	    bt.setToolTipText("Bookmark " + i);
  	}


    	  if (bm[selectedTabIndex()].size() > 0)
    	  {
					for (int i = 0; i < bm[selectedTabIndex()].size() ; ++i)
					{
						 if ((bm[selectedTabIndex()].elementAt(i) == null) || (bm[selectedTabIndex()].elementAt(i) == ""))
						 {
								bmButtons.getComponentAtIndex(i).setEnabled(false);
						 }

						 else
						 {
								bmButtons.getComponentAtIndex(i).setEnabled(true);

								JButton bt = (JButton)bmButtons.getComponentAtIndex(i);

							bt.setToolTipText("Goto Bookmark " + i + ": " + bmToolTip[selectedTabIndex()].elementAt(i).toString());

						 }
					}

    	  	Editors[selectedTabIndex()].grabFocus();

    	  	jmiPopBmRem.setEnabled(true);
	        jmiBmRem.setEnabled(true);
	        jmiPopBmAdd.setEnabled(true);
	        jmiBmAdd.setEnabled(true);

    	  }

    	  else
    	  {
    	  	jmiPopBmRem.setEnabled(false);
	        jmiBmRem.setEnabled(false);

	        jmiPopBmAdd.setEnabled(true);
	        jmiBmAdd.setEnabled(true);
    	  }

    	  if (bm[selectedTabIndex()].size() == bmcount)
    	  {
    	  	jmiPopBmRem.setEnabled(true);
	        jmiBmRem.setEnabled(true);

	        jmiPopBmAdd.setEnabled(false);
	        jmiBmAdd.setEnabled(false);
    	  }

    	  	Editors[selectedTabIndex()].grabFocus();

    }


  public void setUpBookMarks()
  {
    bmButtons.setFloatable(false);

		bmButtons.setLayout(new FlowLayout(FlowLayout.LEFT, 0, 0));

		for (int i = 0; i < bmcount; i++)
		{
			bmButtons.add(bm1 = ButtonFactory.createButton(bmadd, "Bookmark " + (i + 1), "D", this));
		}

  }



	public void addBookMark()
	{
		int a = Editors[selectedTabIndex()].getCaretPosition();
		int b = Editors[selectedTabIndex()].getLineOfOffset(a);

		bm[selectedTabIndex()].addElement(new String(Integer.toString(b)));

		if(bm[selectedTabIndex()].size() <= bmcount)
		{


			bmButtons.getComponentAtIndex(bm[selectedTabIndex()].size() - 1).setEnabled(true);

			String str = Editors[selectedTabIndex()].getLineText(b) ;

			int x = str.length();
			String s = new String();

				if(x > 75)
					s = str.substring(0, 75);
				else
				    s = str.substring(0, x);

			JButton bt = (JButton)bmButtons.getComponentAtIndex(bm[selectedTabIndex()].size() - 1);

			bmToolTip[selectedTabIndex()].addElement(s);

			bt.setToolTipText("Goto Bookmark " + bm[selectedTabIndex()].size() + ": " + s);

			jmiPopBmRem.setEnabled(true);
		  jmiBmRem.setEnabled(true);


	    if (bm[selectedTabIndex()].size() == bmcount)
      {
      	jmiBmAdd.setEnabled(false);
        jmiPopBmAdd.setEnabled(false);
      }

			Editors[selectedTabIndex()].grabFocus();

	   }


	}


	public void getNextBookMark(int i)
	{

	  Editors[selectedTabIndex()].setCaretPosition(Editors[selectedTabIndex()].getLineStartOffset(new Integer(bm[selectedTabIndex()].elementAt(i).toString()).intValue()));

		Editors[selectedTabIndex()].grabFocus();

	}



	public void removeBookMarks()
	{
		bm[selectedTabIndex()].clear();

		for (int i = 0; i < bmcount; i++)
  	{
			bmButtons.getComponentAtIndex(i).setEnabled(false);

			JButton bt = (JButton)bmButtons.getComponentAtIndex(i);

			bt.setToolTipText("Bookmark " + (i + 1));


  	}

  	jmiBmAdd.setEnabled(true);
  	jmiPopBmAdd.setEnabled(true);

  	jmiBmRem.setEnabled(false);
  	jmiPopBmRem.setEnabled(false);

		Editors[selectedTabIndex()].grabFocus();
	}






	//**********************************************************************************************************
	//************************************* S A V E  A L L - C L O S E  A L L **********************************
	//**********************************************************************************************************

	public boolean saveAll()
	{
		int a = selectedTabIndex();

	  for(int i = 0; i < tabCount(); i++)
		{
			if ((dirty[i]) && (fileNames[i] != null || fileNames[i] != ""))
			{
				selectedTabIndex(i);
				save();
			}
		}

		selectedTabIndex(a);

		return true;

	}



	public void closeAll()
	{
		boolean savefile = false;

		for(int i = 0; i < tabCount(); i++)
		{
			if (dirty[i])
			{
				savefile = true;
			}
	  }

	  if (savefile)
	  {
			int value =  JOptionPane.showConfirmDialog(this, "Save Unsaved Files?", "Save Unsaved Files?", JOptionPane.YES_NO_CANCEL_OPTION) ;

				switch (value)
				{
					case JOptionPane.YES_OPTION:
						saveAll();
						closeAllTabs();

					case JOptionPane.NO_OPTION:
					    closeAllTabs();

					case JOptionPane.CANCEL_OPTION:
					default:

					return;
				}


		}
		else
		{
			closeAllTabs();
		}

  }


   public void closeAllTabs()
	 {
		 int a = tabCount();

		 for(int i = 0; i < a; i++)
		 {
			 close("All");
		 }
	 }

// load log message 
     public void LoadLogMessages( String sfile ) {

      String ss=sfile; 
      LogM.SetText( ss );

     }

//  clear log message
     public void ClearLogMessages() {
      LogM.ClearText();
     }



	//**********************************************************************************************************
	//******************************************* T A B  U T I L S *********************************************
	//**********************************************************************************************************

	public int selectedTabIndex()
	{
		return jtp.getSelectedIndex();
	}

	public void selectedTabIndex(int i)
	{
		jtp.setSelectedIndex(i);
	}

	public int tabCount()
	{
		return jtp.getTabCount();
	}


	public void addTab(String Title)
	{

	 firstTime = false;

	 EditCount = EditCount + 1;

   Editors[EditCount] = new mbJTextArea();
   Editors[EditCount].setTransferHandler(new DropHandler(this));
	 Editors[EditCount].setTokenMarker(new JavaTokenMarker());
	 Editors[EditCount].setRightClickPopup(jpopupmenu);
	 Editors[EditCount].addCaretListener(new CaretListenerLabel());
	 Editors[EditCount].getDocument().addDocumentListener(new jpeDocListener(this));
	 Editors[EditCount].getDocument().addUndoableEditListener(this);
	 Editors[EditCount].setMagicCaretPosition(0);
	 Editors[EditCount].getInputHandler().addKeyBinding("C+X",  new cutAction(this));
	 Editors[EditCount].getInputHandler().addKeyBinding("C+C",  new copyAction(this));
	 Editors[EditCount].getInputHandler().addKeyBinding("C+V",  new pasteAction(this));
	 Editors[EditCount].getInputHandler().addKeyBinding("C+A",  new selectAllAction(this));
	 Editors[EditCount].getInputHandler().addKeyBinding("A+F",  new file());
	 Editors[EditCount].getInputHandler().addKeyBinding("A+E",  new edit());
	 Editors[EditCount].getInputHandler().addKeyBinding("A+V",  new view());
	 Editors[EditCount].getInputHandler().addKeyBinding("A+S",  new search());
	 Editors[EditCount].getInputHandler().addKeyBinding("A+P",  new prefs());
	 Editors[EditCount].getInputHandler().addKeyBinding("A+D",  new jdk());
	 Editors[EditCount].getInputHandler().addKeyBinding("A+T",  new tools());
	 Editors[EditCount].getInputHandler().addKeyBinding("A+R",  new proj());
	 Editors[EditCount].getInputHandler().addKeyBinding("C+O",  new openAction(this));
	 Editors[EditCount].getInputHandler().addKeyBinding("C+N",  new newAction(this));
	 Editors[EditCount].getInputHandler().addKeyBinding("C+S",  new saveAction(this));
   Editors[EditCount].getInputHandler().addKeyBinding("C+W",  new closeAction(this));
	 Editors[EditCount].getInputHandler().addKeyBinding("C+Q",  new quitAction(this));
	 Editors[EditCount].getInputHandler().addKeyBinding("CA+C", new clipCopyAction(this));
	 Editors[EditCount].getInputHandler().addKeyBinding("CA+X", new clipCutAction(this));
	 Editors[EditCount].getInputHandler().addKeyBinding("CS+A", new addBookMarkAction(this));
	 Editors[EditCount].getInputHandler().addKeyBinding("CS+D", new deleteBookMarkAction(this));
	 Editors[EditCount].getInputHandler().addKeyBinding("C+Z",  new undoAction(this));
	 Editors[EditCount].getInputHandler().addKeyBinding("C+Y",  new redoAction(this));
	 Editors[EditCount].getInputHandler().addKeyBinding("TAB",  new tabAction(this));
	 Editors[EditCount].getInputHandler().addKeyBinding("S+TAB",new backTabAction(this));
	 Editors[EditCount].getInputHandler().addKeyBinding("F5",   new searchAction(this));
	 Editors[EditCount].getInputHandler().addKeyBinding("F6",   new replaceAction(this));
	 Editors[EditCount].getInputHandler().addKeyBinding("C+F5", new searchNextAction(this));
	 Editors[EditCount].getInputHandler().addKeyBinding("ENTER",new enterAction(this));
	 Editors[EditCount].getInputHandler().addKeyBinding("C+J",  new javacAction(this));
	 Editors[EditCount].getInputHandler().addKeyBinding("CA+J", new javaAction(this));


	 undo[EditCount]      = new UndoManager();
	 bm[EditCount]        = new Vector();
	 cl[EditCount]        = new Vector();
	 bmToolTip[EditCount] = new Vector();
	 clToolTip[EditCount] = new Vector();
	 currentCursorPos[EditCount] = 0;

	 undo[EditCount].setLimit(UndoLimit);
   Editors[EditCount].setTabSize(tabs);

	 Editors[EditCount].setEditable(true);

	 if (Title.equals("Untitled"))
	 {
		 untitled = ++untitled;

		 String count = new String(Integer.toString(untitled));

		 jtp.addTab(Title + " " + count, saveIcon, Editors[EditCount], Title + new String(Integer.toString(untitled)));

	 }

	 else
	 {
		 jtp.addTab(Title, saveIcon, Editors[EditCount], Title);

	 }


     jtp.setSelectedIndex(EditCount);
     dirty[EditCount] = false;
     readOnly[EditCount] = false;

		 copyPrefs();
		 Editors[EditCount].setRequestFocusEnabled(true);
		 jtp.requestFocusInWindow();
		 Editors[EditCount].requestFocusInWindow();
		 Editors[EditCount].setCaretPosition(a);
		 jtp.setForegroundAt(EditCount, Color.blue);


	}




	public void removeTab()
	{
	  if (tabCount() > 0)
	  {
		  jtp.remove(selectedTabIndex());
		  System.gc();
	    EditCount = EditCount - 1;
	    Editors[selectedTabIndex()].grabFocus();
	  }

	}



	//**********************************************************************************************************

	//check that JDK path is not null
	//this modal dialog pops up when the program is first run as "jdk" is set to null by default
	//and asks the user to specify a path to their JDK
	private void checkJdk()
	{
		if(jdk == null)
		{
			String rt = root.getParent().toString();

			Utils.userMessage("Please specify full path to your SDK", "eg. C:"+ fileSep +"JDK1.3"+fileSep+"bin", 2);

		  setJavaHome();

		 }
	}


	//**********************************************************************************************************

	//this method sets the distance of the project manager divider for the split window
	private void setDividerLocation()
	{
		if(divsize > 5)
		{
			jsp.setDividerLocation(divsize);
			//jtbProjWin.setSelected(true);
		}
		else
		{
			jsp.setDividerLocation(0);
			//jtbProjWin.setSelected(false);
		}
	}


  private void setDividerLocation2(int a)
	{
	  if (a == 0)
	  {
			if(divsize2 > 5)
			{
				jsp3.setDividerLocation(divsize2);
				//jtbProjWin.setSelected(true);
			}
			else
			{
				jsp3.setDividerLocation(0);
				//jtbProjWin.setSelected(false);
			}
    }
    else
    {
	  	jsp3.setDividerLocation(a);
	  }
	}


	//**********************************************************************************************************
	//***************************************** P R O J E C T  U T I L S ***************************************
	//**********************************************************************************************************

	//this method sets up the project directory using the tree class
	//see also FileTreeModel in misc folder
	private void setProject()
	{
		Icon fileIcon = new ImageIcon("images" + fileSep + "tree-open.gif");

    //int[] rows = tree.getSelectionRows();
		mtree.removeMouseListener(this);
		root = new File(dir);

		// Create a TreeModel object to represent our tree of files
    model = new FileTreeModel(root);

    // Create a JTree and tell it to display our model
    mtree = new mbJTree(fpath);
    mtree.setModel(model);
		mtree.putClientProperty("JTree.lineStyle", "Angled");
		mtree.addMouseListener(this);
		mtree.setRootVisible(false);
		mtree.setShowsRootHandles(true);

   mtree.getSelectionModel().setSelectionMode(
        TreeSelectionModel.SINGLE_TREE_SELECTION);

       mtree.setBackground(new java.awt.Color(255,255,255));
       mtree.setForeground(Color.blue);



// pop-up menu for Jtree
    jtreemenu = new JPopupMenu();
    JMenuItem icut = new JMenuItem("Delete");
    JMenuItem inew = new JMenuItem("New file");
    JMenuItem irefresh = new JMenuItem("Refresh");
    jtreemenu.add(inew);
    jtreemenu.add(icut);
    jtreemenu.add(irefresh);
   // Set the component to show the popup menu
    mtree.addMouseListener(new MouseAdapter() {
        public void mousePressed(MouseEvent evt) {
            if (evt.isPopupTrigger()) {
                jtreemenu.show(evt.getComponent(), evt.getX(), evt.getY());
            }
        }
        public void mouseReleased(MouseEvent evt) {
            if (evt.isPopupTrigger()) {
                jtreemenu.show(evt.getComponent(), evt.getX(), evt.getY());
            }
        }
    });


// remove 
    icut.addActionListener(new java.awt.event.ActionListener() {
    public void actionPerformed(java.awt.event.ActionEvent evt) {
                // Get text inside selection
              // Get paths of all selected nodes
              TreePath npath[] = mtree.getSelectionPaths();
              if (npath != null) {

              // remove 
              Object oopath=npath[0].getLastPathComponent(); 
              File ff= new File(oopath.toString());
              String mess="delete?"; 
              if (ff.isDirectory())  mess="Delete directory \n"+oopath.toString()+ " ?"; 
              if (!ff.isDirectory()) mess="Delete file \n"+oopath.toString()+ " ?";

            JOptionPane dialog1 = new JOptionPane();
            int ask=dialog1.showConfirmDialog(dialog1,
            mess, "Question", JOptionPane.YES_NO_OPTION, 
            JOptionPane.QUESTION_MESSAGE, null );
              if (ask == JOptionPane.YES_OPTION) {
              boolean succ=Util.deleteDir(ff);  
              if (succ) setProject();
              }
             }
 
    }  });


// remove
    inew.addActionListener(new java.awt.event.ActionListener() {
    public void actionPerformed(java.awt.event.ActionEvent evt) {
         newDoc(); 
    }  });




// refresh 
    irefresh.addActionListener(new java.awt.event.ActionListener() {
    public void actionPerformed(java.awt.event.ActionEvent evt) {
           setProject();
     }  });









		scroll = new JScrollPane(mtree);

		jtp2.removeTabAt(0);
  //  jtp2.addTab(dir, fileIcon, scroll);
      jtp2.addTab("Files", fileIcon, scroll);

// show bottom 
      projpath.setText(dir);

	}


	//***********************************************************************************************************************
	//************************************************ T E X T  U T I L S ***************************************************
	//***********************************************************************************************************************

	//sets the status message to nothing
  private void ClearStatus()
	{
		setStatus("");
	}

	//calls the word and character count class
	private void WordCount()
	{
		WordCount wc = new WordCount(this, Editors[selectedTabIndex()].getDocument());
	}

  public SyntaxDocument getDocument()
  {
		return Editors[selectedTabIndex()].getDocument();
	}

	//called from the caret listener label
	//updates the line number tracker in the top tool bar
	private void updateLineCount()
	{
		//int a = Editors[selectedTabIndex()].getLineCount();
		//lineCount.setText("of " + a + " ");
	}

	//deletes the current line of text
	private void DelLine()
	{
		int b = Editors[selectedTabIndex()].getCaretPosition();
		try
		{
			int a = Editors[selectedTabIndex()].getLineOfOffset(b);

			int start = Editors[selectedTabIndex()].getLineStartOffset(a);
			int end = Editors[selectedTabIndex()].getLineEndOffset(a);

			Editors[selectedTabIndex()].select(start, end);
			Editors[selectedTabIndex()].setSelectedText("");

		}
		catch (Exception ex)
		{
			System.out.println("Error deleting line " + ex.getMessage());
			Utils.userMessage("Error", SYSTEM_ERROR, 1);
	    Utils.writeErrorLog("Error deleting line " + ex.getMessage());
		}
	}

	//***********************************************************************************************************************

	//needed for when user manually changes syntax highlighting
	private void sweepDoc()
	{
		int line = Editors[selectedTabIndex()].getLineCount();
		try
		{
			Editors[selectedTabIndex()].grabFocus();
			Editors[selectedTabIndex()].setCaretPosition(Editors[selectedTabIndex()].getLineStartOffset(line - 1));
		}
		catch (Exception ex)
		{
			System.out.println("Error sweeping document " + ex.getMessage());
			Utils.userMessage("Error", SYSTEM_ERROR, 1);
	    Utils.writeErrorLog("Error sweeping document " + ex.getMessage());
		}
	}




	//***********************************************************************************************************************

	//public method for setting status bar text
	public void setCoStatus(String s)
	{
		jpeStatusBar.setText(s);
	}

  //public method for setting status bar text
	public void setStatus(String s)
	{

	}
	//*******************************************************************************************

	//public method for outside class to insert text into textarea
	public void insertString(String outString, int position)
	{
		this.outString = outString;

		if (position == 0)
		{
			int a = Editors[selectedTabIndex()].getCaretPosition();
			Editors[selectedTabIndex()].insert(outString, a);

		}
		else
		{
			int a = Editors[selectedTabIndex()].getCaretPosition();
			Editors[selectedTabIndex()].insert(outString, position);
		}

		Editors[selectedTabIndex()].grabFocus();

	}

	//*******************************************************************************************

	//sets the timer cursor on the glass pane
	private void setCursor()
	{
		getGlassPane().addMouseListener( new MouseAdapter() {});
		getGlassPane().setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
		getGlassPane().setVisible(false);
	}

	public void setWaitCursor()
	{
		getGlassPane().setVisible(true);
	}

	public void setTextCursor()
	{
		getGlassPane().setVisible(false);
	}

	//changes the saved status bar icon as needed + saved icon
	//this method is called by the document listener and changes the saved icon to red when a
	//change has been made to the document. When the document is saved the icon turns to green.
	//If the document is untitled the Tab diplays "Untitled" else the file name (currFileName)
	//is displayed
	private void updateCaption()
	{
		String caption;

		if (fileNames[selectedTabIndex()] == null) {
			caption = "Untitled " + Integer.toString(untitled);
			jtp.setToolTipTextAt(selectedTabIndex(), caption);
		}
		else
		{
			if (fullpath)
			{
				caption = fileNames[selectedTabIndex()];
				jtp.setToolTipTextAt(selectedTabIndex(), caption);
			}
			else
			{
				caption = new String(currFileTypes[selectedTabIndex()].getName());
				jtp.setToolTipTextAt(selectedTabIndex(), fileNames[selectedTabIndex()]);
			}

    }

		 jtp.setTitleAt(selectedTabIndex(), caption);
     this.setTitle("Curent file: " + caption);


  }


  private void updateAllCaptions()
	{
		String caption;

		for(int i = 0; i < tabCount(); i++)
		{

			if (!(jtp.getTitleAt(i).startsWith("Untitled", 0)))
			{
				if (fullpath)
				{
					caption = fileNames[i];
					jtp.setTitleAt(i, caption);
					jtp.setToolTipTextAt(i, caption);
				}
				else
				{
					caption = new String(currFileTypes[i].getName());
					jtp.setTitleAt(i, caption);
					jtp.setToolTipTextAt(i, fileNames[i]);
				}

			}
		}
  }


  private void changeTabIcon()
  {
		if (dirty[selectedTabIndex()] && (!readOnly[selectedTabIndex()]))
		{
			//jpeStatusBar.setIcon(unsavedicon);
			jtp.setIconAt(selectedTabIndex(), dirtyIcon);
			jmiSave.setEnabled(true);
			jbtSave.setEnabled(true);
			jmiSaveAll.setEnabled(true);
			jbtSaveAll.setEnabled(true);
			jmiBmAdd.setEnabled(true);
			jmiPopBmAdd.setEnabled(true);
		}
		else
		{
			//jpeStatusBar.setIcon(savedicon);
			jtp.setIconAt(selectedTabIndex(), saveIcon);
			jmiSave.setEnabled(false);
			jbtSave.setEnabled(false);
			jmiSaveAll.setEnabled(false);
			jbtSaveAll.setEnabled(false);
			jmiBmAdd.setEnabled(true);
			jmiPopBmAdd.setEnabled(true);
		}
	}


	private void updateSyntaxType()
	{

	  if (syntaxType[selectedTabIndex()] == null)
	  {
	  	jav.setSelected (true);
	  }

	  else
	  {
	  	String s = syntaxType[selectedTabIndex()];

			if (s.equalsIgnoreCase ("jav"))
				jav.setSelected (true);
			else if (s.equalsIgnoreCase ("js"))
				js.setSelected (true);
			else if (s.equalsIgnoreCase ("bat"))
				bat.setSelected (true);
			else if (s.equalsIgnoreCase ("txt"))
				txt.setSelected (true);
			else if (s.equalsIgnoreCase ("xml"))
				xml.setSelected (true);
			else if (s.equalsIgnoreCase ("xml"))
				xml.setSelected (true);
                        else if (s.equalsIgnoreCase ("cpp"))
                                cpp.setSelected (true);
                         else if (s.equalsIgnoreCase ("cxx"))
                                cxx.setSelected (true);
                        else if (s.equalsIgnoreCase ("prog"))
                                prog.setSelected (true);
                        else if (s.equalsIgnoreCase ("xhtml"))
                                xhtml.setSelected (true);
                        else if (s.equalsIgnoreCase ("python"))
                                python.setSelected (true);
                        else if (s.equalsIgnoreCase ("pythonRoot"))
                                pythonRoot.setSelected (true);
                       else if (s.equalsIgnoreCase ("make"))
                                make.setSelected (true);
                       else if (s.equalsIgnoreCase ("fortran"))
                                fortran.setSelected (true);
                        else if (s.equalsIgnoreCase ("latex"))
                                latex.setSelected (true);
                        else if (s.equalsIgnoreCase ("shell"))
                                shell.setSelected (true);
                        else if (s.equalsIgnoreCase ("kumac"))
                                kumac.setSelected (true);
                        else if (s.equalsIgnoreCase ("bibtex"))
                                bibtex.setSelected (true);
                        else if (s.equalsIgnoreCase ("php"))
                                php.setSelected (true);
			else
			{
				txt.setSelected (true);
			}
	  }
  }


	//***********************************************************************************************

	private void copyPrefs()
	{
	  Editors[selectedTabIndex()].getPainter().setSelectionColor(Editors[0].getPainter().getSelectionColor());
	  Editors[selectedTabIndex()].setTabSize(Editors[0].getTabSize());
	  Editors[selectedTabIndex()].getPainter().setCaretColor(Editors[0].getPainter().getCaretColor());
	  Editors[selectedTabIndex()].getPainter().setBracketHighlightColor(Editors[0].getPainter().getBracketHighlightColor());
	  Editors[selectedTabIndex()].getPainter().setLineHighlightColor(Editors[0].getPainter().getLineHighlightColor());
	  Editors[selectedTabIndex()].getPainter().setBlockCaretEnabled(Editors[0].getPainter().isBlockCaretEnabled());
	  Editors[selectedTabIndex()].getPainter().setInvalidLinesPainted(Editors[0].getPainter().getInvalidLinesPainted());
	  Editors[selectedTabIndex()].getPainter().setEOLMarkersPainted(Editors[0].getPainter().getEOLMarkersPainted());
	  Editors[selectedTabIndex()].getPainter().setLineHighlightEnabled(Editors[0].getPainter().isLineHighlightEnabled());
	  Editors[selectedTabIndex()].getPainter().setBracketHighlightEnabled(Editors[0].getPainter().isBracketHighlightEnabled());
	  Editors[selectedTabIndex()].setCaretBlinkEnabled(Editors[0].isCaretBlinkEnabled());
	  Editors[selectedTabIndex()].getGutter().setCollapsed(Editors[0].getGutter().isCollapsed());
	  Editors[selectedTabIndex()].getGutter().setGutterWidth(Editors[0].getGutter().getGutterWidth());
	  Editors[selectedTabIndex()].getGutter().setForeground(Editors[0].getGutter().getForeground());
	  Editors[selectedTabIndex()].getGutter().setBackground(Editors[0].getGutter().getBackground());
    Editors[selectedTabIndex()].getGutter().setHighlightedForeground(Editors[0].getGutter().getHighlightedForeground());
    Editors[selectedTabIndex()].getGutter().setHighlightInterval(Editors[0].getGutter().getHighlightInterval());
    Editors[selectedTabIndex()].getPainter().setFont(Editors[0].getPainter().getFont());
    Editors[selectedTabIndex()].getGutter().setFont(new Font("Monospaced", Font.BOLD , 11));
	  Editors[selectedTabIndex()].updateScrollBars();

	}

	//***********************************************************************************************


	private void updatePrefs()
	{
	  for(int i = 0; i < tabCount(); i++)
	  {

		  Editors[i].getPainter().setSelectionColor(Editors[selectedTabIndex()].getPainter().getSelectionColor());
		  Editors[i].setTabSize(Editors[selectedTabIndex()].getTabSize());
		  Editors[i].getPainter().setCaretColor(Editors[selectedTabIndex()].getPainter().getCaretColor());
		  Editors[i].getPainter().setBracketHighlightColor(Editors[selectedTabIndex()].getPainter().getBracketHighlightColor());
		  Editors[i].getPainter().setLineHighlightColor(Editors[selectedTabIndex()].getPainter().getLineHighlightColor());
		  Editors[i].getPainter().setBlockCaretEnabled(Editors[selectedTabIndex()].getPainter().isBlockCaretEnabled());
		  Editors[i].getPainter().setInvalidLinesPainted(Editors[selectedTabIndex()].getPainter().getInvalidLinesPainted());
		  Editors[i].getPainter().setEOLMarkersPainted(Editors[selectedTabIndex()].getPainter().getEOLMarkersPainted());
		  Editors[i].getPainter().setLineHighlightEnabled(Editors[selectedTabIndex()].getPainter().isLineHighlightEnabled());
		  Editors[i].getPainter().setBracketHighlightEnabled(Editors[selectedTabIndex()].getPainter().isBracketHighlightEnabled());
		  Editors[i].setCaretBlinkEnabled(Editors[selectedTabIndex()].isCaretBlinkEnabled());
		  Editors[i].getGutter().setCollapsed(Editors[selectedTabIndex()].getGutter().isCollapsed());
		  Editors[i].getGutter().setGutterWidth(Editors[selectedTabIndex()].getGutter().getGutterWidth());
		  Editors[i].getGutter().setForeground(Editors[selectedTabIndex()].getGutter().getForeground());
		  Editors[i].getGutter().setBackground(Editors[selectedTabIndex()].getGutter().getBackground());
		  Editors[i].getGutter().setHighlightedForeground(Editors[selectedTabIndex()].getGutter().getHighlightedForeground());
		  Editors[i].getGutter().setHighlightInterval(Editors[selectedTabIndex()].getGutter().getHighlightInterval());
		  Editors[i].getPainter().setFont(Editors[selectedTabIndex()].getPainter().getFont());
		  Editors[i].getGutter().setFont(new Font("Monospaced", Font.BOLD , 11));
		  Editors[i].updateScrollBars();

    }
	}

	//***********************************************************************************************


	//loads the user prefs
	//this long method reads all the user prefs from a properties file and converts
	//the text to program usable objects i.e. Colors, Strings, Boolean values

        // returns false if no ini file detected 
	private boolean setPrefs() { 


           p = new Properties(System.getProperties());
	  if (!(new File(SetEnv.INIFILE).exists()))
	  {
                System.out.println("Debug: property file not found:"+SetEnv.INIFILE);
	  	System.out.println("Debug: -> using defaults ");
	  	Utils.writeErrorLog("Error reading Properties files:"+SetEnv.INIFILE+" - using defaults ");
		boolean nn=restoreDefaults();
                return false;
	  }
	  else
	  {

     try
     {
                 propFile = new FileInputStream(SetEnv.INIFILE);		
           	 p.load(propFile);
			 System.setProperties(p);
	   }

	   catch  (IOException ex)
	   {
		   System.out.println("Error reading properties " + ex.getMessage());
			 Utils.userMessage("Error", SYSTEM_ERROR, 1);
	     Utils.writeErrorLog("Error reading properties " + ex.getMessage());
		   boolean nn=restoreDefaults();
	  } 


		tabplacement = Integer.parseInt(System.getProperty("jpe.tabpos", "1"));

		jtp.setTabPlacement(tabplacement);

		if (tabplacement == 3)
			 jmiTabAtBottom.setSelected(true);
		else
			 jmiTabAtBottom.setSelected(false);


		textHighlightColor = new Color(new Integer(System.getProperty("jpe.texthighlight", "-3355393")).intValue());
		Editors[selectedTabIndex()].getPainter().setSelectionColor(textHighlightColor);


		caretColor = new Color(new Integer(System.getProperty("jpe.caretcolour", "-16776961")).intValue());
		Editors[selectedTabIndex()].getPainter().setCaretColor(caretColor);


		bracketColor = new Color(new Integer(System.getProperty("jpe.bracketcolour", "-65536")).intValue());
		Editors[selectedTabIndex()].getPainter().setBracketHighlightColor(bracketColor);


		highlightColor = new Color(new Integer(System.getProperty("jpe.highlightcolour", "-2039584")).intValue());
	  Editors[selectedTabIndex()].getPainter().setLineHighlightColor(highlightColor);


		if (System.getProperty("jpe.blockcaret", "no").equals("yes"))
		{
			Editors[selectedTabIndex()].getPainter().setBlockCaretEnabled(true);
			jmiBlockCaret.setSelected(true);
		}


		if (System.getProperty("jpe.invalidlines", "no").equals("yes"))
		{
			Editors[selectedTabIndex()].getPainter().setInvalidLinesPainted(true);
			jmiInvalidLines.setSelected(true);
		}

		if (System.getProperty("jpe.javac.classpath", "no").equals("no"))
		{
			classpath = "";
		}

		else
		{
			classpath = System.getProperty("jpe.javac.classpath");
		}

		if (System.getProperty("jpe.javac.options", "no").equals("no"))
		{
		  Options = "";
		}

		else
		{
			Options = System.getProperty("jpe.javac.options");
		}

		if (System.getProperty("jpe.java.options", "no").equals("no"))
		{
		  RunOptions = "";
		}

		else
		{
			RunOptions = System.getProperty("jpe.java.options");
		}


		if (System.getProperty("jpe.eolmarker", "no").equals("yes"))
		{
			Editors[selectedTabIndex()].getPainter().setEOLMarkersPainted(true);
			jmiEolMarkers.setSelected(true);
		}


		if (System.getProperty("jpe.linehighlight", "yes").equals("yes"))
		{
			Editors[selectedTabIndex()].getPainter().setLineHighlightEnabled(true);
			jmiLine.setSelected(true);
		}


		if (System.getProperty("jpe.brackethighlight", "yes").equals("yes"))
		{
			Editors[selectedTabIndex()].getPainter().setBracketHighlightEnabled(true);
			jmiBracket.setSelected(true);
		}


		if (System.getProperty("jpe.caretblink", "no").equals("yes"))
		{
			Editors[selectedTabIndex()].setCaretBlinkEnabled(true);
			jmiCaretBlink.setSelected(true);
		}


		if (System.getProperty("jpe.gutter", "no").equals("yes"))
		{
			Editors[selectedTabIndex()].getGutter().setCollapsed(false);
			jmiGutter.setSelected(true);
		}


		if (System.getProperty("jpe.readonlynotify", "no").equals("yes"))
		{
			readonlynotify = true;
			jmiReadOnlyNotify.setSelected(true);
		}

		savetime = Integer.parseInt(System.getProperty("jpe.savetime", "60000"));

		if (System.getProperty("jpe.autosave", "no").equals("yes"))
		{
			autosave = true;
			jmiStartTimer.setSelected(true);
			saveTimer.setDelay(savetime);
			saveTimer.start();
			jpeStatusBar.setIcon(clock);
			jpeStatusBar.setToolTipText("Auto save enabled[" + (savetime/1000)/60 + "] min");
		}

    menulimit = Integer.parseInt(System.getProperty("jpe.menulimit", "12"));

		UndoLimit = Integer.parseInt(System.getProperty("jpe.undolimit", "50"));

    bmcount = Integer.parseInt(System.getProperty("jpe.bmcount", "5"));

    clcount = Integer.parseInt(System.getProperty("jpe.clcount", "5"));

    tabs = Integer.parseInt(System.getProperty("jpe.tabs", "2"));

		gutwidth = Integer.parseInt(System.getProperty("jpe.gutterwidth", "30"));
		Editors[selectedTabIndex()].getGutter().setGutterWidth(gutwidth);


		gutterFor = new Color(new Integer(System.getProperty("jpe.gutterfore", "-5592406")).intValue());
		Editors[selectedTabIndex()].getGutter().setForeground(gutterFor);


		gutterBak = new Color(new Integer(System.getProperty("jpe.gutterback", "-1")).intValue());
		Editors[selectedTabIndex()].getGutter().setBackground(gutterBak);


		gutterHigh = new Color(new Integer(System.getProperty("jpe.gutterhighlight", "-12105913")).intValue());
		Editors[selectedTabIndex()].getGutter().setHighlightedForeground(gutterHigh);


	  Editors[selectedTabIndex()].getGutter().setHighlightInterval(Integer.parseInt(System.getProperty("jpe.gutterint", "10")));
		gutint = Integer.parseInt(System.getProperty("jpe.gutterint", "10"));



		if (System.getProperty("jpe.jdkhome", "no").equals("no"))
		{
			jdk = null;
			isjdk = false;
		}
		else
		{
			jdk = System.getProperty("jpe.jdkhome", "yes");
			isjdk = true;
		}


    if (System.getProperty("jpe.dir", "no").equals("no"))
		{
			isdir = false;
		}
		else
		{
                        if (dir.length()<2) { 
			dir = System.getProperty("jpe.dir");
			isdir = true;
                        }
		}


		divsize = Integer.parseInt(System.getProperty("jpe.divsize", "143"));
		divsize2 = Integer.parseInt(System.getProperty("jpe.divsize2", "428"));

    appWidth = Integer.parseInt(System.getProperty("jpe.width", "800"));

    appHeight = Integer.parseInt(System.getProperty("jpe.height", "600"));


    if (System.getProperty("jpe.fullpath", "no").equals("yes"))
    {
			fullpath = true;
			updateAllCaptions();
			jmiFullPath.setSelected(true);

		}
		else
		{
			fullpath = false;
			updateAllCaptions();
			jmiFullPath.setSelected(false);
    }


    if (System.getProperty("jpe.openlastdoc", "no").equals("yes"))
    {
			lastdoc = true;
			jmiLastDoc.setSelected(true);

		}
		else
		{
			lastdoc = false;
			jmiLastDoc.setSelected(false);
    }

    if (System.getProperty("jpe.checkfilemod", "no").equals("yes"))
		{
			checkfilemod = true;
			jmiCheckFileMod.setSelected(true);

		}
		else
		{
			checkfilemod = false;
			jmiCheckFileMod.setSelected(false);
    }


		if (System.getProperty("jpe.lastdoc", "no").equals("no"))
		{

		}
		else
		{
			String s = System.getProperty("jpe.lastdoc");

			if((new File(s).exists()) && (lastdoc))
			{
				 firstRun = true;
							 open(s);
			}
		}


		 font = Utils.tokenisefont(System.getProperty("jpe.font", "Arial:12:0"));

	 }

        return true;

	}




//*********************************************************************************************
//**************************** R E C E N T  D O C S  U T I L S ********************************
//*********************************************************************************************

	public void setRecents()
	{
		String str;
		int j = 0;


    for(int i = 0; i < menulimit; i++)
	{
      if (System.getProperty(getprops[i]) != null) {

      File f = new File(System.getProperty(getprops[i]));

			if ((System.getProperty(getprops[i]) != "blank") && (f.isFile()))
			{
				if ((f.exists()) && (f.canRead())  && (f.isFile()))
				{
					str = ((f.canWrite()) ? "" : " *");

					newRecents.add(new JMenuItem(nums[j] + ". " + f.getName().toString() + str), j);

					newRecents.getItem(j).setToolTipText(System.getProperty(getprops[i]));
					p.setProperty(getprops[j], p.getProperty(getprops[i]));
					newRecents.getItem(j).addActionListener(this);
					newRecents.getItem(j).setFont(SYSTEM_FONT);

					newRecents.getItem(j).setEnabled(true);
					menucount++;
					j++;

			  }
		  }
		}
          } // end if  
	}




	private void saveRecents(String s)
	{
	  boolean swap = false;

     for(int i = 0; i < menucount; i++)
	   {

		   if (s.equals(System.getProperty(getprops[i])))
		   {
			   swap = true;
	     }

     }

     if (swap)
     {
		   swapRecents(s);
	   }
	   else
	   {
		   addRecents(s);
	   }

	}


	private void swapRecents(String s)
	{
    String str;

	  int j = 1;

	  String tempMenu[] = new String[14];
	  String tempPath[] = new String[14];

	  tempMenu[0] = s;
	  tempPath[0] = s;

		for (int i = 0; i < menucount; i++)
		{
			if (s.equals(p.getProperty(getprops[i])))
			{

			}
			else
			{
			tempMenu[j]  = p.getProperty(getprops[i]);

			tempPath[j]  = p.getProperty(getprops[i]);

				j++ ;
			}
		}

		str = (new File(s).canWrite() ? "" : " *");
		newRecents.getItem(0).setText(nums[0] + ". " + new File(s).getName().toString() + str);
		newRecents.getItem(0).setToolTipText(s);
		newRecents.getItem(0).setFont(new Font("Arial", Font.BOLD , 11));
		p.setProperty(getprops[0], s);



		for (int i = 1; i < menucount; i++)
		{
			str = (new File(tempPath[i]).canWrite() ? "" : " *");
			newRecents.getItem(i).setText(nums[i] + ". " + new File(tempMenu[i]).getName().toString() + str);
			newRecents.getItem(i).setToolTipText(tempPath[i]);
			newRecents.getItem(i).setFont(SYSTEM_FONT);
			p.setProperty(getprops[i], tempPath[i]);

		}
	}



	private void addRecents(String s)
	{
		 String str;

		 if (menucount == 0)
		 {
			 str = (new File(s).canWrite() ? "" : " *");
			 newRecents.add(new JMenuItem(nums[menucount] + ". " + new File(s).getName().toString() + str));
			 newRecents.getItem(menucount).setToolTipText(s);
			 newRecents.getItem(menucount).addActionListener(this);
			 newRecents.getItem(menucount).setEnabled(true);
			 newRecents.getItem(menucount).setFont(new Font("Arial", Font.BOLD , 11));
			 p.setProperty(getprops[menucount], s);

			 ++menucount;
		 }
		 else
		 {
			 str = (new File(s).canWrite() ? "" : " *");
			 newRecents.insert(new JMenuItem(nums[0] + ". " + new File(s).getName().toString() + str), 0);
			 newRecents.getItem(0).setToolTipText(s);
			 newRecents.getItem(0).addActionListener(this);
			 newRecents.getItem(0).setFont(new Font("Arial", Font.BOLD , 11));
			 newRecents.getItem(0).setEnabled(true);


			 for(int i = menucount; i > 0; i--)
			 {

				 p.setProperty(getprops[i], p.getProperty(getprops[i - 1]));
				 newRecents.getItem(i).removeActionListener(this);
				 newRecents.remove(newRecents.getItem(i));
				 str = ((new File(System.getProperty(getprops[i])).canWrite()) ? "" : " *");
				 newRecents.insert(nums[i] + ". " + new File(p.getProperty(getprops[i])).getName().toString() + str, i);
				 newRecents.getItem(i).setToolTipText(p.getProperty(getprops[i]));
				 newRecents.getItem(i).setFont(SYSTEM_FONT);
				 newRecents.getItem(i).addActionListener(this);

			 }

			 p.setProperty(getprops[0], s);

			 if (menucount == menulimit)
			 {

				 newRecents.getItem(menucount).removeActionListener(this);
				 newRecents.remove(newRecents.getItem(menucount));
				 p.setProperty(getprops[menucount], "blank");

			 }
			 else
			 {
				 ++menucount;
			 }
     }
  }


	private void clearRecents()
	{
    int value =  JOptionPane.showConfirmDialog(this, "Clear recent files history?", "Clear recent files history?", JOptionPane.YES_NO_OPTION) ;

		switch (value)
		{
			case JOptionPane.YES_OPTION:
				delRecents();

			case JOptionPane.NO_OPTION:
				return;
    }
	}


	private void delRecents()
	{
    for(int i = 15 - 1; i >= 0; --i)
		{
			System.setProperty(getprops[i], "blank");
		}

		newRecents.removeAll();

		menucount = 0;
	}


	//******************************************************************************************
	//****************************** W I N D O W   E V E N T S *********************************
	//******************************************************************************************

	public void windowStateChanged(WindowEvent e) {}
  public void windowOpened(WindowEvent e)       {}
	public void windowClosing(WindowEvent e)      {}
  public void windowClosed(WindowEvent e)       {}
  public void windowIconified(WindowEvent e)    {}
  public void windowDeiconified(WindowEvent e)  {}
  public void windowActivated(WindowEvent e)    {}
  public void windowDeactivated(WindowEvent e)  {}

  public void componentHidden(ComponentEvent e) {}
  public void componentMoved(ComponentEvent e)  {}
  public void componentShown(ComponentEvent e)  {}


	public void componentResized(ComponentEvent e)
	{
		int a = this.getWidth();
		int b = toolbarwidth;
		int c = a - b;
		jpClosePanel.setPreferredSize(new Dimension(c, 23));
		jpClosePanel.setMinimumSize(new Dimension(c, 23));
		jpClosePanel.setMaximumSize(new Dimension(c, 23));
		jpClosePanel.revalidate();
		jpClosePanel.repaint();
	}



  public void stateChanged(ChangeEvent e)
  {
	  setBookMarks();
	  setClipBoards();
		updateLineCount();
		setUndoRedo();
		updateCursorPos();
		updateSyntaxType();
		changeTabIcon();
		updateCaption();
		Editors[selectedTabIndex()].grabFocus();

		checkReadOnly();

		for(int i = 0; i < tabCount(); i++)
		{
		   jtp.setForegroundAt(i, Color.BLACK);
		}

		jtp.setForegroundAt(selectedTabIndex(), Color.blue);

  }

  public void runGenericTextWindow(String text, String title)
  {
		String s = Utils.getDocs(text);
		readme docsdlg = new readme(this, s, title);
		Utils.centerComponent(docsdlg);
		docsdlg.setVisible(true);
	}

	public void checkReadOnly()
	{
		if(readOnly[selectedTabIndex()])
		{
			Editors[selectedTabIndex()].setEditable(false);
			Editors[selectedTabIndex()].getPainter().setBackgroundColor(new Color(192,192,192));
		}
		else
		{
			Editors[selectedTabIndex()].setEditable(true);
			Editors[selectedTabIndex()].getPainter().setBackgroundColor(Color.white);
		}
	}


	//mouse event - listens for a double click in the project manager tree
	//this public method allows the user to click on a file in the project manager
	//and if it is a text file it opens in the window - if it is an image file it
	//opens in the image viewer.
	//the problem is converting the mouse clicked tree node to a string that the program
	//can read and pass to the open method - hence all the string class methods to chop and
	//change the converted tree node string
	public void mousePressed (MouseEvent e)
	{
		if(((e.getModifiers() & InputEvent.BUTTON3_MASK) == InputEvent.BUTTON3_MASK) && (e.getSource() instanceof mbJTextArea))
		{
			jpopupmenu.show(Editors[selectedTabIndex()], e.getX(), e.getY());
		}


    for(int i = 0; i < bmcount; i++)
    {
			if (e.getSource() == bmButtons.getComponentAtIndex(i))
	    {
	      getNextBookMark(i);
	      return;
			}
		}


		for(int i = 0; i < clcount; i++)
    {
			if (e.getSource() == clButtons.getComponentAtIndex(i))
	    {
        getNextClipBoard(i);
        return;
			}
		 }


		if(e.getSource() instanceof JTree)
		{
			if(e.getSource() == mtree)
			{
				if (e.getClickCount() == 2)
				{
					JTree jtree = (JTree)e.getSource();

					int clickedrow = jtree.getRowForLocation(e.getX(), e.getY());

					if(clickedrow != -1)
					{
						TreePath treepath = jtree.getPathForRow(clickedrow);

				    //TreeNode treenode = (TreeNode)treepath.getLastPathComponent();

						String str = new String(treepath.toString());

						int a = str.length();
						int c = str.lastIndexOf(",", a);
						//gives us the file name
						String s = str.substring(c+1, str.length()-1);

						StringBuffer StrBuff = new StringBuffer(s);
						StrBuff.deleteCharAt(0);

						String w = new String(StrBuff);

						File file = new File(w);

						//test if the file is a dir	etc...
						if((file.exists())&&(!file.isDirectory())&&(file.canRead()))
						{
							open(w);
            }
				  }
				}
		  }



		 else
		 {
        if (e.getClickCount() == 1)
        {

					JTree jtree = (JTree)e.getSource();

					int clickedrow = jtree.getRowForLocation(e.getX(), e.getY());

					if(clickedrow != -1)
					{
					  TreePath treepath = jtree.getPathForRow(clickedrow);

						String str = new String(treepath.toString());

						int a = str.length();
						int c = str.lastIndexOf(",", a);

						//gives us the file name
						String s = str.substring(c+1, str.length()-1);

						StringBuffer StrBuff = new StringBuffer(s);
						StrBuff.deleteCharAt(0);

						String w = new String(StrBuff);

						File file = new File(w);

						String tempdir = w.toString();

								//test if the file is a dir	etc...
						if((file.exists())&&(file.canRead()))
						{
							 dir = tempdir;
							 setProject();

						}
						else
						{
							Utils.userMessage("Sorry", "Drive " + tempdir +  " is not accessible", 2);
						}
		      }
    	  }
		  }
	  }
  }



	public void mouseClicked(MouseEvent e)
	{
		//if (e.getSource() == jta)
		//{
	 	  int a = jta.getLineOfOffset(jta.getCaretPosition());

	    String s = jta.getLineText(a);

	 		if (s.indexOf("java:", 0) == -1)
	 		{
	 			//Utils.userMessage("Error!", "No 'java:' found", 2);
	 			return;
	 		}
	 		else
	 		{
	 			StringTokenizer str = new StringTokenizer(s, ":");

	 			while (str.hasMoreTokens())
	 			{
	 				String token = str.nextToken();

	 				try
	        {
				  	int line = Integer.parseInt(token);
				  	Editors[selectedTabIndex()].setCaretPosition(Editors[selectedTabIndex()].getLineStartOffset(line - 1));
				  }
				  catch (NumberFormatException nfe)
				  {
				  	//System.out.println ("Number format exception" + nfe.getMessage ());
}

			 	}
      }
    //}
	}

	public void mouseReleased(MouseEvent e){}

	public void mouseEntered(MouseEvent e)
	{
	  if (e.getSource() instanceof JButton)
	  {
      JButton jbt = (JButton)e.getSource();

      if (jbt.isEnabled())
       jbt.setBorderPainted(true);
    }

    if (e.getSource() instanceof JToggleButton)
		{
			JToggleButton jtb = (JToggleButton)e.getSource();

			if (jtb.isEnabled())
			 jtb.setBorderPainted(true);
    }
  }


	public void mouseExited(MouseEvent e)
	{
	  if (e.getSource() instanceof JButton)
	  {
      JButton jbt = (JButton)e.getSource();

       if (jbt.isEnabled())
        jbt.setBorderPainted(false);
    }

    if (e.getSource() instanceof JToggleButton)
		{
			JToggleButton jtb = (JToggleButton)e.getSource();

			if (jtb.isEnabled())
			 jtb.setBorderPainted(false);
    }
  }

//======================================================================
//==================== P R E F S  C A L L S ============================
//======================================================================

  public boolean getAutoSave()
  {
		return jmiStartTimer.isSelected();
	}

	public void selectAutoSave()
	{
    jmiStartTimer.doClick(1);
	}



  public boolean getBlockCaret()
  {
		return jmiBlockCaret.isSelected();
	}

	public void selectBlockCaret()
	{
    jmiBlockCaret.doClick(1);
	}



  public boolean getEOLMarkers()
  {
    return jmiEolMarkers.isSelected();
	}

	public void selectEOLMarkers()
	{
    jmiEolMarkers.doClick(1);
	}


  public boolean getInvalidLines()
  {
		return jmiInvalidLines.isSelected();
	}

	public void selectInvalidLines()
	{
    jmiInvalidLines.doClick(1);
	}



  public boolean getLineHighlight()
  {
		return jmiLine.isSelected();
	}

	public void selectLineHighlight()
	{
    jmiLine.doClick(1);
	}



  public boolean getBracketHighlight()
  {
		return jmiBracket.isSelected();
	}

	public void selectBracketHighlight()
	{
    jmiBracket.doClick(1);
  }



	public boolean getCaretBlink()
	{
		return jmiCaretBlink.isSelected();
	}

  public void selectCaretBlink()
	{
    jmiCaretBlink.doClick(1);
	}



	public boolean getFullPathInTabs()
	{
		return jmiFullPath.isSelected();
	}

	public void selectFullPathInTabs()
	{
    jmiFullPath.doClick(1);
  }


  public boolean getLockFile()
	{
		return lockfile;
	}

	public void selectFileLock(boolean b)
	{
		if (b)
		{
			lockfile = true;
			p.setProperty("jpe.lockfiles", "yes");
			lockedLabel.setIcon(flocked);
			//lockAllFiles();
		}
		else
		{
			p.setProperty("jpe.lockfiles", "no");
			lockfile = false;
			lockedLabel.setIcon(funlocked);
			//unLockAllFiles();
		}
  }


  public boolean getTabsOnBottom()
	{
		return jmiTabAtBottom.isSelected();
	}

  public void selectTabsOnBottom()
	{
    jmiTabAtBottom.doClick();
	}


  public boolean getLastDoc()
	{
		return jmiLastDoc.isSelected();
	}

	public void selectLastDoc()
	{
    jmiLastDoc.doClick(1);
  }


  public boolean getCheckFileMod()
	{
		return jmiCheckFileMod.isSelected();
	}

	public void selectCheckFileMod()
	{
	   jmiCheckFileMod.doClick(1);
  }


  public boolean getGutter()
	{
		return jmiGutter.isSelected();
	}

  public void selectGutter()
  {
    jmiGutter.doClick();
  }



  public boolean getReadOnlyNotify()
	{
		return jmiReadOnlyNotify.isSelected();
	}

	public void selectReadOnlyNotify()
	{
    jmiReadOnlyNotify.doClick(1);
  }





	// ActionEvent handler
	//this public method is where all the actions are generated from the button clicks.
	//this is done in two different ways but both achieve the same ends.

//======================================================================
//==================== P R E F S  A C T I O N S ========================
//======================================================================


	public void actionPerformed(ActionEvent e)
	{
		if (e.getSource() instanceof JCheckBoxMenuItem)
		{
			if (jmiBlockCaret.getState())
			{
				Editors[selectedTabIndex()].getPainter().setBlockCaretEnabled(true);
				p.setProperty("jpe.blockcaret", "yes");
				updatePrefs();
			}

			else if (!jmiBlockCaret.getState())
			{
				Editors[selectedTabIndex()].getPainter().setBlockCaretEnabled(false);
				p.setProperty("jpe.blockcaret", "no");
				updatePrefs();
			}

			if (jmiEolMarkers.getState())
			{
				Editors[selectedTabIndex()].getPainter().setEOLMarkersPainted(true);
				p.setProperty("jpe.eolmarker", "yes");
				updatePrefs();
			}

			else if (!jmiEolMarkers.getState())
			{
				Editors[selectedTabIndex()].getPainter().setEOLMarkersPainted(false);
				p.setProperty("jpe.eolmarker", "no");
				updatePrefs();
			}

			if (jmiInvalidLines.getState())
			{
				Editors[selectedTabIndex()].getPainter().setInvalidLinesPainted(true);
				p.setProperty("jpe.invalidlines", "yes");
				updatePrefs();
			}

			else if (!jmiInvalidLines.getState())
			{
				Editors[selectedTabIndex()].getPainter().setInvalidLinesPainted(false);
				p.setProperty("jpe.invalidlines", "no");
				updatePrefs();
			}

			if (jmiLine.getState())
			{
				Editors[selectedTabIndex()].getPainter().setLineHighlightEnabled(true);
				p.setProperty("jpe.linehighlight", "yes");
				updatePrefs();
			}

			else if (!jmiLine.getState())
			{
				Editors[selectedTabIndex()].getPainter().setLineHighlightEnabled(false);
				p.setProperty("jpe.linehighlight", "no");
				updatePrefs();
			}

			if (jmiBracket.getState())
			{
				Editors[selectedTabIndex()].getPainter().setBracketHighlightEnabled(true);
				p.setProperty("jpe.brackethighlight", "yes");
				updatePrefs();
			}

			else if (!jmiBracket.getState())
			{
				Editors[selectedTabIndex()].getPainter().setBracketHighlightEnabled(false);
				p.setProperty("jpe.brackethighlight", "no");
				updatePrefs();
			}

			if (jmiCaretBlink.getState())
			{
				Editors[selectedTabIndex()].setCaretBlinkEnabled(true);
				p.setProperty("jpe.caretblink", "yes");
				updatePrefs();
			}

			else if (!jmiCaretBlink.getState())
			{
				Editors[selectedTabIndex()].setCaretBlinkEnabled(false);
				p.setProperty("jpe.caretblink", "no");
				updatePrefs();
			}

			if (jmiFullPath.getState())
			{
				p.setProperty("jpe.fullpath", "yes");
				fullpath = true;
				updateAllCaptions();
			}

			else if (!jmiFullPath.getState())
			{
				p.setProperty("jpe.fullpath", "no");
				fullpath = false;
				updateAllCaptions();
			}

			if (jmiTabAtBottom.getState())
			{
				tabplacement = 3;
				jtp.setTabPlacement(tabplacement);
				p.setProperty("jpe.tabpos", new String(Integer.toString(tabplacement)));
			}

			else if (!jmiTabAtBottom.getState())
			{
				tabplacement = 1;
				jtp.setTabPlacement(tabplacement);
				p.setProperty("jpe.tabpos", new String(Integer.toString(tabplacement)));
			}

      if (jmiLastDoc.getState())
			{
				lastdoc = true;
				p.setProperty("jpe.openlastdoc", "yes");
			}

			else if (!jmiLastDoc.getState())
			{
				lastdoc = false;
				p.setProperty("jpe.openlastdoc", "no");
			}

			if (jmiCheckFileMod.getState())
			{
				checkfilemod = true;
				p.setProperty("jpe.checkfilemod", "yes");
			}

			else if (!jmiCheckFileMod.getState())
			{
				checkfilemod = false;
				p.setProperty("jpe.checkfilemod", "no");
			}


			if (jmiGutter.getState())
			{
				Editors[selectedTabIndex()].getGutter().setCollapsed(false);
				p.setProperty("jpe.gutter", "yes");
				updatePrefs();
			}

			else if (!jmiGutter.getState())
			{
				Editors[selectedTabIndex()].getGutter().setCollapsed(true);
				p.setProperty("jpe.gutter", "no");
				updatePrefs();
			}


			if (jmiReadOnlyNotify.getState())
			{
				p.setProperty("jpe.readonlynotify", "yes");
				readonlynotify = true;
			}

			else if (!jmiReadOnlyNotify.getState())
			{
				p.setProperty("jpe.readonlynotify", "no");
				readonlynotify = false;
			}

			if (jmiStartTimer.getState())
			{
				p.setProperty("jpe.autosave", "yes");
				autosave = true;
				saveTimer.start();
				 jpeStatusBar.setIcon(clock);
				jpeStatusBar.setToolTipText("Auto save enabled[" + (savetime/1000)/60 + "] min");
			}

			else if (!jmiStartTimer.getState())
			{
				p.setProperty("jpe.autosave", "no");
				autosave = false;
				saveTimer.stop();
				jpeStatusBar.setIcon(clockdis);
				jpeStatusBar.setToolTipText("Auto save disabled");
			}

		}


		if (e.getSource() instanceof JTextField)
		{
			if(e.getSource() == jtf)
			{
				int line = 0;
				String response = jtf.getText();
				if (response != null)
				{
					line = Integer.parseInt(response);
				}
				int a = Editors[selectedTabIndex()].getLineCount();

				if (line > a)
				{
					Utils.userMessage("Oops!", "Number greater than line count!", 1);
					return;
				}

				try{
					Editors[selectedTabIndex()].grabFocus();
					Editors[selectedTabIndex()].setCaretPosition(Editors[selectedTabIndex()].getLineStartOffset(line - 1));
				}
				catch (Exception e1)
				{
					System.out.println("Error finding line " + e1.getMessage());
					Utils.userMessage("Error", SYSTEM_ERROR, 1);
			    Utils.writeErrorLog("Error finding line " + e1.getMessage());
				}
				jtf.setText("");
			}
		}

		//these need to be moved!
		else if (e.getSource() == jmiGutterWidth)
		{
			setGutterWidth();
		}

		else if (e.getSource() == jmiGutterInterval)
		{
      setGutterInterval();
		}


		else if (e.getSource() == jmiMenuCount)
		{
			setNumberOfRecents();
		}


		else if (e.getSource() == jmiUndoLimit)
		{
			setUndoLimit();
		}

		else if (e.getSource() == jmiBmCount)
		{
			setNumberOfBookMarks();
		}

		else if (e.getSource() == jmiClCount)
		{
			setNumberOfClipBoards();
		}

    else if (e.getSource() == jmiTimerCount)
		{
      setTimer();
		}

		else if (e.getSource() == jmiTabs)
		{
      setTabSize();
		}


		else if (e.getSource() == jmiDefaults)
		{
			Utils.setDefaults();
		}

    //code for templates
		else if (e.getSource() == jmiJavaDoc)
		{
			App();
		}

		else if (e.getSource() == jmiJavaAppDoc)
		{
			Applet();
		}



		//code for readme
		else if (e.getSource() == jmiReadme)
		{
			// runGenericTextWindow(Readme, "Readme");
                        new AboutDialog( this );   
		}

                 /*
		//code for license
		 if (e.getSource() == jmiLicense)
		{
			runGenericTextWindow(License, "License");
                        // System.out.println(  License );
		}
                */

		//code for license
		if (e.getSource() == jmiErrorLog)
		{
			runGenericTextWindow(ErrorLog, "Error log");
		}


		//code for clipboards
		else if ((e.getSource() == jmiSystem)||(e.getSource() == jbtClipSys))
		{

			Clip1 clipdlg = new Clip1(this, system, "System ClipBoard");
			Utils.centerComponent(clipdlg);
			clipdlg.setVisible(true);
		}


    else if ((e.getSource() == jmiL1Cut) || (e.getSource() == jmiPopL1Cut))
		{
			addClipBoard("Cut");
		}

		else if ((e.getSource() == jmiL1Copy) || (e.getSource() == jmiPopL1Copy))
		{
			addClipBoard("Copy");
		}


		else if ((e.getSource() == jmiSysCut) || (e.getSource() == jmiPopSysCut))
		{
			addSystemClipBoard("Cut");
		}

		else if ((e.getSource() == jmiSysCopy) || (e.getSource() == jmiPopSysCopy))
		{
			addSystemClipBoard("Copy");
		}

		else if (e.getSource() == jmiClClear)
		{
			removeClipBoards();
		}

		else if (e.getSource() == jmiCloseAll)
		{
			closeAll();
		}

		else if (e.getSource() == jmiSaveAll)
		{
		    saveAll();
		}


		else if ((e.getSource() == b1) || (e.getSource() == b2) || (e.getSource() == b3))
		{
			try {
				if(e.getSource() == b1)
					UIManager.setLookAndFeel(
						"javax.swing.plaf.metal.MetalLookAndFeel");
				else if(e.getSource() == b2)
					UIManager.setLookAndFeel(
						"com.sun.java.swing.plaf.motif.MotifLookAndFeel");
				else if(e.getSource() == b3)
					UIManager.setLookAndFeel(
						"com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
			}
			catch(Exception ex)
			{
				System.out.println("Error setting look and feel " + ex.getMessage());
			  Utils.userMessage("Error", SYSTEM_ERROR, 1);
	      Utils.writeErrorLog("Error setting look and feel " + ex.getMessage());
			}

			SwingUtilities.updateComponentTreeUI(getContentPane());
		}



		//code for setting the syntax
		else if (e.getSource() == jav)
		{
			int a = Editors[selectedTabIndex()].getCaretPosition();
			sweepDoc();
			Editors[selectedTabIndex()].setTokenMarker(new JavaTokenMarker());
			syntaxType[selectedTabIndex()] = "jav";
			Editors[selectedTabIndex()].setCaretPosition(a);
		}


		else if (e.getSource() == txt)
		{
			int a = Editors[selectedTabIndex()].getCaretPosition();
			sweepDoc();
			Editors[selectedTabIndex()].setTokenMarker(null);
			syntaxType[selectedTabIndex()] = "txt";
			Editors[selectedTabIndex()].setCaretPosition(a);
		}

		else if (e.getSource() == js)
		{
			int a = Editors[selectedTabIndex()].getCaretPosition();
			sweepDoc();
			Editors[selectedTabIndex()].setTokenMarker(new JavaScriptTokenMarker());
			syntaxType[selectedTabIndex()] = "js";
			Editors[selectedTabIndex()].setCaretPosition(a);
		}

		else if (e.getSource() == bat)
		{
			int a = Editors[selectedTabIndex()].getCaretPosition();
			sweepDoc();
			Editors[selectedTabIndex()].setTokenMarker(new BatchFileTokenMarker());
			syntaxType[selectedTabIndex()] = "bat";
			Editors[selectedTabIndex()].setCaretPosition(a);
		}


		else if (e.getSource() == xml)
		{
			int a = Editors[selectedTabIndex()].getCaretPosition();
			sweepDoc();
			Editors[selectedTabIndex()].setTokenMarker(new XMLTokenMarker());
			syntaxType[selectedTabIndex()] = "xml";
			Editors[selectedTabIndex()].setCaretPosition(a);
		}

                  else if (e.getSource() == cpp)
                {
                        int a = Editors[selectedTabIndex()].getCaretPosition();
                        sweepDoc();
                        Editors[selectedTabIndex()].setTokenMarker(new CPPTokenMarker());
                        syntaxType[selectedTabIndex()] = "cpp";
                        Editors[selectedTabIndex()].setCaretPosition(a);
                }

                 else if (e.getSource() == cxx)
                {
                        int a = Editors[selectedTabIndex()].getCaretPosition();
                        sweepDoc();
                        Editors[selectedTabIndex()].setTokenMarker(new CXXTokenMarker());
                        syntaxType[selectedTabIndex()] = "cxx";
                        Editors[selectedTabIndex()].setCaretPosition(a);
                }

                  else if (e.getSource() == prog)
                {
                        int a = Editors[selectedTabIndex()].getCaretPosition();
                        sweepDoc();
                        Editors[selectedTabIndex()].setTokenMarker(new ProgressTokenMarker());
                        syntaxType[selectedTabIndex()] = "prog";
                        Editors[selectedTabIndex()].setCaretPosition(a);
                }


                  else if (e.getSource() == xhtml)
                {
                        int a = Editors[selectedTabIndex()].getCaretPosition();
                        sweepDoc();
                        Editors[selectedTabIndex()].setTokenMarker(new HTMLTokenMarker());
                        syntaxType[selectedTabIndex()] = "xhtml";
                        Editors[selectedTabIndex()].setCaretPosition(a);
                }

                 else if (e.getSource() == python)
                {
                        int a = Editors[selectedTabIndex()].getCaretPosition();
                        sweepDoc();
                        Editors[selectedTabIndex()].setTokenMarker(new PythonTokenMarker());
                        syntaxType[selectedTabIndex()] = "Py";
                        Editors[selectedTabIndex()].setCaretPosition(a);
                }


                 else if (e.getSource() == pythonRoot)
                {
                        int a = Editors[selectedTabIndex()].getCaretPosition();
                        sweepDoc();
                        Editors[selectedTabIndex()].setTokenMarker(new PythonRootTokenMarker());
                        syntaxType[selectedTabIndex()] = "py";
                        Editors[selectedTabIndex()].setCaretPosition(a);
                }


                 else if (e.getSource() == php)
                {
                        int a = Editors[selectedTabIndex()].getCaretPosition();
                        sweepDoc();
                        Editors[selectedTabIndex()].setTokenMarker(new PHPTokenMarker());
                        syntaxType[selectedTabIndex()] = "php";
                        Editors[selectedTabIndex()].setCaretPosition(a);
                }


                 else if (e.getSource() == make)
                {
                        int a = Editors[selectedTabIndex()].getCaretPosition();
                        sweepDoc();
                        Editors[selectedTabIndex()].setTokenMarker(new MakefileTokenMarker());
                        syntaxType[selectedTabIndex()] = "make";
                        Editors[selectedTabIndex()].setCaretPosition(a);
                }
                else if (e.getSource() == fortran)
                {
                        int a = Editors[selectedTabIndex()].getCaretPosition();
                        sweepDoc();
                        Editors[selectedTabIndex()].setTokenMarker(new FortranTokenMarker());
                        syntaxType[selectedTabIndex()] = "fortran";
                        Editors[selectedTabIndex()].setCaretPosition(a);
                }

               else if (e.getSource() == bibtex)
                {
                        int a = Editors[selectedTabIndex()].getCaretPosition();
                        sweepDoc();
                        Editors[selectedTabIndex()].setTokenMarker(new BiBTokenMarker());
                        syntaxType[selectedTabIndex()] = "bibtex";
                        Editors[selectedTabIndex()].setCaretPosition(a);
                }

               else if (e.getSource() == shell)
                {
                        int a = Editors[selectedTabIndex()].getCaretPosition();
                        sweepDoc();
                        Editors[selectedTabIndex()].setTokenMarker(new ShellScriptTokenMarker());
                        syntaxType[selectedTabIndex()] = "shell";
                        Editors[selectedTabIndex()].setCaretPosition(a);
                }


                else if (e.getSource() == latex)
                {
                        int a = Editors[selectedTabIndex()].getCaretPosition();
                        sweepDoc();
                        Editors[selectedTabIndex()].setTokenMarker(new TeXTokenMarker());
                        syntaxType[selectedTabIndex()] = "latex";
                        Editors[selectedTabIndex()].setCaretPosition(a);
                }


                else if (e.getSource() == kumac)
                {
                        int a = Editors[selectedTabIndex()].getCaretPosition();
                        sweepDoc();
                        Editors[selectedTabIndex()].setTokenMarker(new KumacTokenMarker());
                        syntaxType[selectedTabIndex()] = "kumac";
                        Editors[selectedTabIndex()].setCaretPosition(a);
                }

		else if ((e.getSource() == jbtBmAdd)||(e.getSource() == jmiBmAdd)||(e.getSource() == jmiPopBmAdd))
		{
		  addBookMark();
		}

		else if ((e.getSource() == jbtBmRem)||(e.getSource() == jmiBmRem)||(e.getSource() == jmiPopBmRem))
		{
			removeBookMarks();
		}


		else if ((e.getSource() == jbtOpen)||(e.getSource() == jmiOpen))
		{
			open();
		}

		else if ((e.getSource() == jbtRefresh))
		{
			refreshCurrentDoc(new File(fileNames[selectedTabIndex()]));
		}

		else if ((e.getSource() == jbtSave)||(e.getSource() == jmiSave))
		{
			save();
		}

		else if ((e.getSource() == jbtSaveAs)||(e.getSource() == jmiSaveAs))
		{
			saveAsFile();
		}

		else if (e.getSource() == jbtSaveAll)
		{
			saveAll();
		}

		else if (e.getSource() == jbtMakeRMC)
		{
			makeAllRMC();
		}


                else if (e.getSource() == jbtROOT)
                {
                        makeROOT();
                }

               else if (e.getSource() == jbtPYTHON)
                {
                        makePYTHON();
                }


		else if (e.getSource() == jbtCloseAll)
		{
			closeAll();
		}

		else if ((e.getSource() == jbtzip)||(e.getSource() == jmiZipAs))
		{
			saveZipFile();
		}

		else if (e.getSource() == jbtNew)
		{
			newDoc();
		}

		else if ((e.getSource() == jbtUndo)||(e.getSource() == jmiUndo)||(e.getSource() == jmiPopUndo))
		{
			Undo();
		}


		else if (e.getSource() == jmiJavaComment)
		{
      Utils.setJavaComment1();
		}

		else if (e.getSource() == jmiJavaBlockComment)
		{
      Utils.setJavaComment2();
		}

		else if (e.getSource() == jmiHTMLComment)
		{
      Utils.setHtmlComment();
		}

		else if (e.getSource() == jmiToUpperCase)
		{
      Utils.ChangeCase("Upper");
		}

		else if (e.getSource() == jmiToLowerCase)
		{
      Utils.ChangeCase("Lower");
		}

		else if (e.getSource() == jmiInvertCase)
		{
      Utils.ChangeCase("Invert");
		}

		else if (e.getSource() == jmiUndoAll)
		{
			UndoAll();
		}

		else if (e.getSource() == jmiRedoAll)
		{
			RedoAll();
		}

		else if ((e.getSource() == jbtRedo)||(e.getSource() == jmiRedo)||(e.getSource() == jmiPopRedo))
		{
			Redo();
		}

		else if ((e.getSource() == jbtPrint)||(e.getSource() == jmiPrint))
		{
			Utils.Print(Editors[selectedTabIndex()].getText());this.repaint();
		}

		else if ((e.getSource() == jbtSearch)||(e.getSource() == jmiSearch))
		{
			SearchMain();
		}

		else if (e.getSource() == jmiSearchNext)
		{
			FindNext();
		}

		else if ((e.getSource() == jbtReplace)||(e.getSource() == jmiReplace))
		{
			ReplaceMain();
		}

		else if (e.getSource() == jmiFont)
		{
			FontChooser();
		 //updatePrefs();
		}

		else if ((e.getSource() == jbtCut)||(e.getSource() == jmiCut)||(e.getSource() == jmiPopCut))
		{
			Editors[selectedTabIndex()].cut();
		}

		else if ((e.getSource() == jbtCopy)||(e.getSource() == jmiCopy)||(e.getSource() == jmiPopCopy))
		{
			Editors[selectedTabIndex()].copy();
		}

		else if ((e.getSource() == jbtPaste)||(e.getSource() == jmiPaste)||(e.getSource() == jmiPopSysPaste)||(e.getSource() == jmiSysPaste))
		{
			Paste();
		}

		else if ((e.getSource() == jbtDel)||(e.getSource() == jmiDel)||(e.getSource() == jmiPopDel))
		{
			String s = new String("");
			Editors[selectedTabIndex()].setSelectedText(s);
		}

		else if ((e.getSource() == jbtPrintPrev)||(e.getSource() == jmiPrintPrev))
		{
			Utils.PrintPreview(Editors[selectedTabIndex()].getText());
			this.repaint();
		}

		else if ((e.getSource() == jbtClose)||(e.getSource() == jmiClose)||(e.getSource() == jmiPopClose)||(e.getSource() == jbtCloseCross))
		{
			close("");
		}


		else if (e.getSource() == jmiSetSelectionColor)
		{
			//setSelectionColor();
		  prefsDialog = new PrefsDialog(this, true);
		  Utils.centerComponent(prefsDialog);
		  prefsDialog.setVisible(true);
		  updatePrefs();
		}

		else if (e.getSource() == jmiSetCaretColor)
		{
			setCaretColor();
		  updatePrefs();
		}

		else if (e.getSource() == jmiSetBracketColor)
		{
			setBracketColor();
		  updatePrefs();
		}

		else if (e.getSource() == jmiSetLineHighlight)
		{
			setLineHighlightColor();
		  updatePrefs();
		}

		else if (e.getSource() == jmiGutterFor)
		{
			setGutterFor();
		  updatePrefs();
		}

		else if (e.getSource() == jmiGutterBak)
		{
			setGutterBak();
		  updatePrefs();
		}

		else if (e.getSource() == jmiGutterHigh)
		{
			setGutterHigh();
		  updatePrefs();
		}

		else if (e.getSource() == jmiPopHtml)
		{
			Utils.setHtmlComment();
		}

		else if (e.getSource() == jmiPopJava1)
		{
			Utils.setJavaComment1();
		}

		else if (e.getSource() == jmiPopJava2)
		{
			Utils.setJavaComment2();
		}

		else if (e.getSource() == jmiPopDate)
		{
			Utils.getDate();
		}

		else if (e.getSource() == jmiPopTime)
		{
			Utils.getTime();
		}

		/*else if (e.getSource() instanceof JToggleButton)
		{
			if (e.getSource() == jtbLockFile)
			{
				setLockedFile();
			}
			else
			 setDivider();
		} */

		else if (e.getSource() == jmiProj)
		{
			setProjectDir();
		}



		//****************************************************************************************************

		//or check menu items

		//check actions for menu items
		else if (e.getSource() instanceof JMenuItem)
		{
			String actionCommand = e.getActionCommand();

			if ("Text File".equals(actionCommand))
			{
				newDoc();Editors[selectedTabIndex()].setTokenMarker(null);
			}

			else if ("Basic Page Setup".equals(actionCommand))
			{
				Utils.PageSetupb();this.repaint();
			}

			else if ("Advanced Page Setup".equals(actionCommand))
			{
				Utils.PageSetupa();this.repaint();
			}
                       /*
			else if ("About..".equals(actionCommand))
			{
				About();
			}
                       */ 
			else if ("System Info".equals(actionCommand))
			{
				Info();
			}

			else if ("Help Topics".equals(actionCommand))
			{
				Help();
			}

			else if ("Web Site".equals(actionCommand))
			{
				WebSite();
			}

			else if ("Quit".equals(actionCommand))
			{
				Quit();
			}

			else if ("Select All".equals(actionCommand))
			{
				Editors[selectedTabIndex()].selectAll();
			}

			else if ("Delete Line".equals(actionCommand))
			{
				DelLine();
			}

			else if ("Word Count".equals(actionCommand))
			{
				WordCount();
			}

			else if ("Clear Status Bar".equals(actionCommand))
			{
				ClearStatus();
			}

			else if ("Clear Clipboards".equals(actionCommand))
			{
				//ClearClips();
			}

			else if ("Java Options".equals(actionCommand))
			{
				JavacOptions();
			}

			else if ("into Document".equals(actionCommand))
			{
				Editors[selectedTabIndex()].paste();
			}

			else if ("Date/Time".equals(actionCommand))
			{
				Utils.getDate();
			}

			else if ("SDK Home".equals(actionCommand))
			{
				setJavaHome();
			}

			else if ("javac".equals(actionCommand))
			{
				Javac();
			}

                         else if ("make".equals(actionCommand))
                        {
                          makeAllRMC();
                        }


                         else if ("root".equals(actionCommand))
                        {
                          makeROOT();
                        }
                        else if ("python".equals(actionCommand))
                        {
                          makePYTHON();
                        }


			else if ("java".equals(actionCommand))
			{
				runJava();
			}


			else if ("Clear Recents".equals(actionCommand))
			{
				clearRecents();
			}

      else
      {
			  for(int i = 0; i < newRecents.getItemCount(); i++)
	      {
				  if (e.getSource() == newRecents.getMenuComponent(i))
		      {
		        if (p.getProperty(getprops[i]) != "blank")
					  open(p.getProperty(getprops[i]));
				  }
			  }
      }
		} //end of jmenuitem event
	} //end of ActionPerformed event


	public void setGutterInterval()
	{
		int j = Editors[selectedTabIndex()].getGutter().getHighlightInterval();
		String str = new String(Integer.toString(j));

		String s = null;
		String[] ints = {"5", "10", "15", "20", "25"};

		s = Utils.comboDialog("Gutter Highlight Interval", "Enter interval - [Currently " + str + "]", ints);

		if(s == null) {
			return; }
		else
		{
			gutint  = Integer.parseInt(s);
			Editors[selectedTabIndex()].getGutter().setHighlightInterval(gutint);
			gutterinterval = true;
		}
			p.setProperty("jpe.gutterint", new String(Integer.toString(gutint)));
			updatePrefs();
	}


	public void setGutterWidth()
	{
		int j = Editors[selectedTabIndex()].getGutter().getGutterWidth();
		String str = new String(Integer.toString(j));
		String s = null;
		String[] ints = {"5", "10", "15", "20", "25", "30", "35", "40", "45", "50", "55", "60"};

		s = Utils.comboDialog("Gutter Width", "Enter width - [Currently " + str + "]", ints);
		if(s == null) {
			return; }
		else
		{
			gutwidth  = Integer.parseInt(s);
			Editors[selectedTabIndex()].getGutter().setGutterWidth(gutwidth);
			gutterwidth = true;
		}
			p.setProperty("jpe.gutterwidth", new String(Integer.toString(gutwidth)));
			updatePrefs();
	}


	public void setNumberOfRecents()
	{
		int j = menulimit;
		String str = new String(Integer.toString(j));

		String s = null;
		String[] ints = {"4", "6", "8", "10", "12", "14"};

		s = Utils.comboDialog("Number of recent files (requires re-start)", "Enter number - [Currently " + str + "]", ints);

		if(s == null) {
			return; }
		else
		{
			menulimit  = Integer.parseInt(s);
		}
				p.setProperty("jpe.menulimit", new String(Integer.toString(menulimit)));
	}



	public void setNumberOfBookMarks()
	{
		int j = bmcount;
		String str = new String(Integer.toString(j));

		String s = null;
		String[] ints = {"5", "10", "15", "20", "25", "30"};

		s = Utils.comboDialog("Number of Bookmarks (requires re-start)", "Enter number - [Currently " + str + "]", ints);

		if(s == null) {
			return; }
		else
		{
			bmcount  = Integer.parseInt(s);
		}

		p.setProperty("jpe.bmcount", new String(Integer.toString(bmcount)));
	}

	public int getNumberOfBookMarks()
	{
		return Integer.parseInt(System.getProperty("jpe.bmcount", "5"));
	}

	public int getGutterWidth()
	{
		return Integer.parseInt(System.getProperty("jpe.gutterwidth", "5"));
	}

	public int getGutterInterval()
	{
		return Integer.parseInt(System.getProperty("jpe.gutterint", "5"));
	}

	public int getNumRecents()
	{
		return Integer.parseInt(System.getProperty("jpe.menulimit", "5"));
	}


	public void setNumberOfClipBoards()
	{
		int j = clcount;
		String str = new String(Integer.toString(j));

		String s = null;
		String[] ints = {"5", "10", "15"};

		s = Utils.comboDialog("Number of Clipboards (requires re-start)", "Enter number - [Currently " + str + "]", ints);

		if(s == null) {
			return; }
		else
		{
			clcount  = Integer.parseInt(s);
		}

		p.setProperty("jpe.clcount", new String(Integer.toString(clcount)));
	}

	public int getNumberOfClipBoards()
	{
		return Integer.parseInt(System.getProperty("jpe.clcount", "5"));
	}

	public void setTimer()
	{
		int j = (savetime / 1000) / 60;
		String str = new String(Integer.toString(j));

		String s = null;
		String[] ints = {"1", "2", "3", "4", "5", "10", "20", "30", "60"};

		s = Utils.comboDialog("Save time in minutes", "Enter number - [Currently " + str + " min]", ints);

		if(s == null) {
			return; }
		else
		{
			savetime  = ((Integer.parseInt(s) * 60) * 1000);
		}

		p.setProperty("jpe.savetime", new String(Integer.toString(savetime)));

		if (saveTimer.isRunning())
		{
			saveTimer.stop();
			saveTimer.setDelay(savetime);
			saveTimer.start();
		}
		else
		{
			saveTimer.setDelay(savetime);
		}
	}

	public int getTimer()
	{
		return ((Integer.parseInt(System.getProperty("jpe.savetime", "60000"))/ 1000) / 60);
	}

	public void setUndoLimit()
	{
		int j = UndoLimit;
		String str = new String(Integer.toString(j));

		String s = null;
		String[] ints = {"50", "100", "200", "300", "400", "500", "1000"};

		s = Utils.comboDialog("Undo/Redo levels (requires re-start)", "Enter number - [Currently " + str + "]", ints);

		if(s == null) {
			return; }
		else
		{
			UndoLimit  = Integer.parseInt(s);
		}
				p.setProperty("jpe.undolimit", new String(Integer.toString(UndoLimit)));
	}

	public int getUndoLimit()
	{
		return Integer.parseInt(System.getProperty("jpe.undolimit", "50"));
	}


  public void setTabSize()
  {
		int j = tabs;
		String str = new String(Integer.toString(j));

		String s = null;
		String[] ints = {"1", "2", "3", "4", "5", "6","7", "8", "9", "10", "11", "12"};

		s = Utils.comboDialog("Tab size", "Enter number - [Currently " + str + "]", ints);

		if(s == null) {
			return; }
		else
		{
			tabs  = Integer.parseInt(s);
		}

		 Editors[selectedTabIndex()].setTabSize(tabs);
		 updatePrefs();
		 p.setProperty("jpe.tabs", new String(Integer.toString(tabs)));
	}


  public int getTabSize()
	{
		return Integer.parseInt(System.getProperty("jpe.tabs", "2"));
	}

	//allows the user to specify the path to the JDK and errors if
	//the path is not a valid one

  public void setJavaHome()
	{
		String rt = root.getParent().toString();
		String path;
		String s = new String();

		if (jdk == null) {
			path = "undefined";
		}
		else path = jdk;

		String[] title = {"Enter full path of your JDK bin directory", "eg. " +
			rt + "JDK1.3"+fileSep+"bin", "Current path is " + path};

		JFileChooser jfc_jdk = new JFileChooser(dir);
		jfc_jdk.setFont(SYSTEM_FONT);

		jfc_jdk.isDirectorySelectionEnabled();
		jfc_jdk.setFileSelectionMode(1);
		jfc_jdk.setApproveButtonText("Set");
		jfc_jdk.setApproveButtonToolTipText("Set path to JDK bin");
		jfc_jdk.setDialogTitle("Enter full path of your JDK bin directory eg. " +
			rt + "JDK1.3"+fileSep+"bin");

		if (jfc_jdk.showOpenDialog(this) == JFileChooser.APPROVE_OPTION)
		{
			jdk = jfc_jdk.getSelectedFile().getPath();
			p.setProperty("jpe.jdkhome", jdk);
			isjdk = true;
			Utils.userMessage("Information", "Your SDK bin dir is " + jdk, 1);
		}
		else
		{
			if (jdk == null)
			{
				Utils.userMessage("Attention", "Be sure to specify SDK bin path before compiling!", 2);
				isjdk = false;
				jdk = "no";
				p.setProperty("jpe.jdkhome", jdk);
				return;
			}
		}
		this.repaint();
  }

	public void Quit()
	{
    if (Utils.okToQuit(dirty, readOnly))
		{
      writePrefs();
			Runtime.getRuntime().gc();
			dispose();
			System.exit(0);
		}
	}



	// this method resets all the text component settings to their defaults
	public boolean restoreDefaults()
	{

		textHighlightColor = new Color(0xccccff);
		p.setProperty("jpe.highlightcolour", new String(Integer.toString(textHighlightColor.getRGB())));

		caretColor = Color.blue;
		p.setProperty("jpe.caretcolour", new String(Integer.toString(caretColor.getRGB())));

		bracketColor = Color.red;
		p.setProperty("jpe.bracketcolour", new String(Integer.toString(bracketColor.getRGB())));

		highlightColor = new Color(0xe0e0e0);
		p.setProperty("jpe.highlightcolour", new String(Integer.toString(highlightColor.getRGB())));

		gutterFor = new Color(170, 170, 170);
		p.setProperty("jpe.gutterfore", new String(Integer.toString(gutterFor.getRGB())));

		gutterBak = Color.white;
		p.setProperty("jpe.gutterback", new String(Integer.toString(gutterBak.getRGB())));

		gutterHigh = new Color(71, 71, 71);
		p.setProperty("jpe.gutterhighlight", new String(Integer.toString(gutterHigh.getRGB())));

		gutwidth = 30;
		p.setProperty("jpe.gutterwidth", new String(Integer.toString(gutwidth)));

		gutint = 10;
		p.setProperty("jpe.gutterint", new String(Integer.toString(gutint)));

               jmiLine.setSelected(true);
                p.setProperty("jpe.linehighlight", "yes");

		jmiCaretBlink.setSelected(true);
		p.setProperty("jpe.caretblink", "yes");

		jmiGutter.setSelected(false);
		p.setProperty("jpe.gutter", "no");

		jmiBracket.setSelected(true);
		p.setProperty("jpe.brackethighlight", "yes");

               jmiInvalidLines.setSelected(false);
		p.setProperty("jpe.invalidlines", "no");

		jmiEolMarkers.setSelected(false);
		p.setProperty("jpe.eolmarker", "no");

		jmiBlockCaret.setSelected(false);
		p.setProperty("jpe.blockcaret", "no");

		font = new Font("Monospaced", Font.BOLD , 14);
		setCurrentFont(font);

		tabs = 2;
		p.setProperty("jpe.tabs", "2");

                p.setProperty("jpe.checkfilemod", "yes");

                p.setProperty("jpe.openlastdoc", "no");

                p.setProperty("jpe.lastdoc", "");
 
                p.setProperty("jpe.fullpath", "no");
 
                Editors[selectedTabIndex()].setTabSize(tabs);
		Editors[selectedTabIndex()].getGutter().setGutterWidth(gutwidth);
		Editors[selectedTabIndex()].getGutter().setHighlightInterval(gutint);
		Editors[selectedTabIndex()].getPainter().setBlockCaretEnabled(false);
		Editors[selectedTabIndex()].getPainter().setEOLMarkersPainted(false);
		Editors[selectedTabIndex()].getPainter().setInvalidLinesPainted(false);
		Editors[selectedTabIndex()].getPainter().setLineHighlightEnabled(true);
		Editors[selectedTabIndex()].getPainter().setBracketHighlightEnabled(true);
		Editors[selectedTabIndex()].setCaretBlinkEnabled(true);
		Editors[selectedTabIndex()].getGutter().setCollapsed(true);

		updatePrefs();

		return true;
	}

	//sets the divider size for the split window (jsp)
	private void setDivider()
	{
		int defaultdiv = 150;

		if (jtbProjWin.isSelected())
		{
			if(divsize < 10)
			{
				jsp.setDividerLocation(defaultdiv);
				p.setProperty("jpe.divsize", new String(Integer.toString(defaultdiv)));
			}
			else
				jsp.setDividerLocation(divsize);
				p.setProperty("jpe.divsize", new String(Integer.toString(divsize)));
		}
		if (!jtbProjWin.isSelected())
		{
			divsize = jsp.getDividerLocation();
			jsp.setDividerLocation(0);
			p.setProperty("jpe.divsize", new String(Integer.toString(divsize)));
		}
	}

	//displays a file chooser box and allows the user to select a dir
	//as there project manager directory
	private void setProjectDir()
	{
	  String rt;

	  rt = root.toString();

    String[] title = {"Enter full path of your project directory", "eg. "+ rt + "MyProjects"};

		String s = new String(); //JOptionPane.showInputDialog(title);

		JFileChooser jfc = new JFileChooser(dir);
		jfc.setFont(SYSTEM_FONT);

		jfc.isDirectorySelectionEnabled();
		jfc.setFileSelectionMode(1);

		if (jfc.showOpenDialog(this) == JFileChooser.APPROVE_OPTION)
		{
			s = jfc.getSelectedFile().getPath();
		}

		this.repaint();

		if(s == null)
		{
			return;
		}

		File f = new File(s);

		if((f.exists())&&(f.isDirectory()))
		{
			dir = s;
			isdir = true;
			p.setProperty("jpe.dir", dir);
			setProject();
		}
		//else
			//Utils.userMessage("Attention", s + " not found or is not a directory!", 2);
	}

	//writes all the preferences and document history to disk - called at shutdown
	private void writePrefs()
	{
		String s = new String();
		p.setProperty("jpe.divsize", new String(Integer.toString(jsp.getDividerLocation())));
		p.setProperty("jpe.divsize2", new String(Integer.toString(jsp3.getDividerLocation())));
    p.setProperty("jpe.width", new String(Integer.toString(this.getWidth())));
    p.setProperty("jpe.height", new String(Integer.toString(this.getHeight())));


                // make property directory first 
              File fprop= new File(SetEnv.INIFILE);
              if (!fprop.exists()) {
                String sname=fprop.getAbsolutePath();
                int separ=sname.lastIndexOf(File.separator);
                String dirprop=sname.substring(0,separ);
                File td = new File( dirprop );
                boolean succ1=td.mkdir();
                if (!succ1) {
                  System.out.println("Cannot make :" +  dirprop );
                  }
               } 



		if (fileNames[selectedTabIndex()] == null)
		{
			p.setProperty("jpe.lastdoc", "no");
		}
		else
		{
			p.setProperty("jpe.lastdoc", fileNames[selectedTabIndex()]);
		}

			try
			{
				FileOutputStream out = new FileOutputStream(SetEnv.INIFILE);
				p.store(out, "--- Program Generated file - Do not edit!: RMCedit ---");
				out.close();
			}

			catch  (IOException ex)
			{
			  System.out.println("Error writing properties " + ex.getMessage());
			  Utils.userMessage("Error", SYSTEM_ERROR, 1);
	      Utils.writeErrorLog("Error writing properties " + ex.getMessage());
	    }
	}


	//methods for setting the options in the text area - carat color highlight color etc..
	public void setSelectionColor()
	{
		textHighlightColor = jcolorChooser.showDialog(this,"Text Selection Color",Editors[selectedTabIndex()].getPainter().getSelectionColor());
		if (textHighlightColor != null) {
			Editors[selectedTabIndex()].getPainter().setSelectionColor(textHighlightColor);}

		this.repaint();
		p.setProperty("jpe.texthighlight", new String(Integer.toString(textHighlightColor.getRGB())));

	}

	public Color getSelectionColor()
	{
		return new Color(new Integer(System.getProperty("jpe.texthighlight", "-3355393")).intValue());
	}

  public void setLineHighlightColor()
	{
		highlightColor = jcolorChooser.showDialog(this,"Line Highlight Color",Editors[selectedTabIndex()].getPainter().getLineHighlightColor());
		if (highlightColor != null) {
			Editors[selectedTabIndex()].getPainter().setLineHighlightColor(highlightColor);}

		this.repaint();
		p.setProperty("jpe.highlightcolour", new String(Integer.toString(highlightColor.getRGB())));
	}

	public Color getLineHighLightColor()
	{
		return new Color(new Integer(System.getProperty("jpe.highlightcolour", "-3355393")).intValue());
	}

	public void setCaretColor()
	{
		caretColor = jcolorChooser.showDialog(this,"Caret Color",Editors[selectedTabIndex()].getPainter().getCaretColor());
		if (caretColor != null) {
			Editors[selectedTabIndex()].getPainter().setCaretColor(caretColor);}

		this.repaint();
		p.setProperty("jpe.caretcolour", new String(Integer.toString(caretColor.getRGB())));
	}

  public Color getCaretColor()
	{
		return new Color(new Integer(System.getProperty("jpe.caretcolour", "-16776961")).intValue());
	}

	public void setBracketColor()
	{
		bracketColor = jcolorChooser.showDialog(this,"Delimiter Check Color",Editors[selectedTabIndex()].getPainter().getBracketHighlightColor());
		if (bracketColor != null) {
			Editors[selectedTabIndex()].getPainter().setBracketHighlightColor(bracketColor);}

		this.repaint();

		p.setProperty("jpe.bracketcolour", new String(Integer.toString(bracketColor.getRGB())));
	}

	public Color getBracketColor()
	{
		return new Color(new Integer(System.getProperty("jpe.bracketcolour", "-65536")).intValue());
	}


	public void setGutterFor()
	{
		gutterFor = jcolorChooser.showDialog(this,"Gutter Font Color",Editors[selectedTabIndex()].getGutter().getForeground());
		if (gutterFor != null) {
			Editors[selectedTabIndex()].getGutter().setForeground(gutterFor);}

		this.repaint();
		p.setProperty("jpe.gutterfore", new String(Integer.toString(gutterFor.getRGB())));
	}

	public Color getGutterFor()
	{
		return new Color(new Integer(System.getProperty("jpe.gutterfore", "-5592406")).intValue());
	}

	public void setGutterBak()
	{
		gutterBak = jcolorChooser.showDialog(this,"Gutter Background Color",Editors[selectedTabIndex()].getGutter().getBackground());
		if (gutterBak != null) {
			Editors[selectedTabIndex()].getGutter().setBackground(gutterBak);}

		this.repaint();
		p.setProperty("jpe.gutterback", new String(Integer.toString(gutterBak.getRGB())));
	}

	public Color getGutterBak()
	{
		return new Color(new Integer(System.getProperty("jpe.gutterback", "-1")).intValue());
	}

	public void setGutterHigh()
	{
		gutterHigh = jcolorChooser.showDialog(this,"Line number Highlight Color",Editors[selectedTabIndex()].getGutter().getHighlightedForeground());
		if (gutterHigh != null) {
			Editors[selectedTabIndex()].getGutter().setHighlightedForeground(gutterHigh);}

		this.repaint();
		p.setProperty("jpe.gutterhighlight", new String(Integer.toString(gutterHigh.getRGB())));
	}

	public Color getGutterHigh()
	{
		return new Color(new Integer(System.getProperty("jpe.gutterhighlight", "-12105913")).intValue());
	}


  //method for use when a template file is loaded
	private void setjpeDocs()
	{
		fileNames[selectedTabIndex()] = null;
		currFileTypes[selectedTabIndex()] = null;
		dirty[selectedTabIndex()] = false;
		updateCaption();
		undoManager();
	}


	//loads the text area with a blank Java Application template
	public void App()
	{
		if (Utils.okToAbandon(dirty[selectedTabIndex()], readOnly[selectedTabIndex()], fileNames[selectedTabIndex()], jtp.getTitleAt(selectedTabIndex())))
		{
			Editors[selectedTabIndex()].setTokenMarker(new JavaTokenMarker());
			isjpeDoc = true;
			open(javaApp);
			setjpeDocs();
		}
	}

	//loads the text area with a blank Applet template
	public void Applet()
	{
		if (Utils.okToAbandon(dirty[selectedTabIndex()], readOnly[selectedTabIndex()], fileNames[selectedTabIndex()], jtp.getTitleAt(selectedTabIndex())))
		{
			Editors[selectedTabIndex()].setTokenMarker(new JavaTokenMarker());
			isjpeDoc = true;
			open(javaApplet);
			setjpeDocs();
		}
	}


	//gets the current file name
	public String getcurrFileName()
	{
		String s = fileNames[selectedTabIndex()];
		return s;
	}


	//inserts the given string at the specified carat position
	public void insert(String s)
	{
		int a = Editors[selectedTabIndex()].getCaretPosition();
		Editors[selectedTabIndex()].insert(s, a);
	}



//****************************************************************************************************
//****************************************** J A V A C ***********************************************
//****************************************************************************************************

 public void setConsole(String s)
	{
	  jsp3.setDividerLocation(this.getHeight() - 250);

	  jta.setText(s);
	}

	public void clearConsole()
	{
	  jta.setText("");
	}


	//sets the options parameter of the Java compiler
	public void setOptions(String Options)
	{
		if (Options != null)
		{
			if (Options.length() > 0)
			{
				this.Options = Options;
				p.setProperty("jpe.javac.options", Options);
			}
	  }
	  else
	  {
	  	Options = null;
	  	p.setProperty("jpe.javac.options", "no");
	  }
	}

	public void setClasspath(String classpath)
	{
		if (!classpath.equals(""))
		{
			if (classpath.length() > 0)
			{
				this.classpath = classpath;
				p.setProperty("jpe.javac.classpath", classpath);
			}
		}
		else
		{
			classpath = null;
			p.setProperty("jpe.javac.classpath", "no");
		}
	}

	public String getClasspath()
	{
		return classpath;
	}


	public String getJavacOptions()
	{
		return Options;
	}

	public String getJavaOptions()
	{
		return RunOptions;
	}


	public String getRunOptions()
	{
		String s = new File(fileNames[selectedTabIndex()]).getName().toString();
		String str = s.substring (0, 3);
		RunOptions = RunOptions + " " + str;
		return RunOptions;
	}


	//options of the Java interpreter
	public void setJavaRunOptions(String RunOptions)
	{
		if (!RunOptions.equals(""))
		{
			if (RunOptions.length() > 0)
			{
				this.RunOptions = RunOptions;
				p.setProperty("jpe.java.options", RunOptions);
		  }
		}
		else
		{
			RunOptions = null;
			p.setProperty("jpe.java.options", "no");
		}
	}


	//runs the java interpreter
	public void runJava()
	{
		if(isjdk)
		{
			String s = new File(fileNames[selectedTabIndex()]).getName().toString();
			String str = s.substring(0, s.length() - 5);

			//Utils.userMessage(s, str, 1);

			if(fileNames[selectedTabIndex()].endsWith(".java"))
			{
				jmiJava.setEnabled(false);
				jmiJavac.setEnabled(false);

				setConsole("Running " + str + ".class");

				RunOptions = RunOptions + " " + str;

				RunJava rjava = new RunJava(this, RunOptions, jdk);
				javaThread = new Thread(rjava);
				javaThread.start();
				//javacerror = false;

				this.repaint();
			}
			else
			{
				setConsole("ERROR: " + fileNames[selectedTabIndex()] + " has no corresponding .class file");
			}
	  }
	  else
		{
			Utils.userMessage("Error", "Ho SDK specified", 1);
			setJavaHome();
	  }
  }


  public void stopJavaThread()
	{
		try
		{
			jmiJava.setEnabled(true);
			jmiJavac.setEnabled(true);

			javaThread.interrupt();
			javaThread = null;

		}
		catch(RuntimeException re)
		{
			System.out.println("Error writing properties " + re.getMessage());
			Utils.userMessage("Error", SYSTEM_ERROR, 1);
			Utils.writeErrorLog("Error killing Java thread " + re.getMessage());
		}
		this.repaint();
	}


         public void stopMakeThread()
        {
                try
                {
                      //  jmiJava.setEnabled(true);
                      //  jmiJavac.setEnabled(true);
                        makeThread.interrupt();
                        makeThread = null;
                }
                catch(RuntimeException re)
                {
                        System.out.println("Error writing properties " + re.getMessage());
                        Utils.userMessage("Error", SYSTEM_ERROR, 1);
                        Utils.writeErrorLog("Error killing Make thread " + re.getMessage());
                }
                this.repaint();
        }


	//runs the  Java compiler
	public void Javac()
	{
		if(isjdk)
		{
			if(fileNames[selectedTabIndex()].endsWith(".java"))
			{
				if(jbtSave.isEnabled())
				{
					save();
				}

				jmiJava.setEnabled(false);
				jmiJavac.setEnabled(false);

				setConsole("Compiling " + fileNames[selectedTabIndex()]);

				Javac javac = new Javac(this, fileNames[selectedTabIndex()], classpath, Options, jdk);
				javacThread = new Thread(javac);
				javacThread.start();

				this.repaint();

			}
			else
			{
				setConsole("ERROR: " + fileNames[selectedTabIndex()] + " is not a Java file!");
			}
	  }
	  else
	  {
	    Utils.userMessage("Error", "Ho SDK specified", 1);
	    setJavaHome();
	  }
	}


	public void stopJavacThread()
	{
		try
		{
			jmiJava.setEnabled(true);
			jmiJavac.setEnabled(true);

			javacThread.interrupt();
			javacThread = null;

		}
	  catch(RuntimeException re)
	  {
			System.out.println("Error writing properties " + re.getMessage());
		  Utils.userMessage("Error", SYSTEM_ERROR, 1);
	    Utils.writeErrorLog("Error killing Javac thread " + re.getMessage());
		}

		this.repaint();

	}


	//runs the  Java compiler
	public String getJDK()
	{
    return jdk;
	}

	public void stopRun(boolean javacerror)
	{
		this.javacerror = javacerror;
	}


	//displays the Java Compiler options dialog box
	public void JavacOptions()
	{
		Utils.centerComponent(javacdlg);
		javacdlg.setVisible(true);
		javacdlg.setClassPath();
		javacdlg.setJavacOptions();
		javacdlg.setJavaOptions();
		this.repaint();
	}


//***********************************************************************************************************

//***********************************************************************************************************


	public String getFileName()
	{
    return fileNames[selectedTabIndex()];
	}


	//displays the help files by passing the help files path to the default browser
	private void Help()
	{
		String url = ("file:" + "docs" + fileSep + "help" + fileSep + "intro.html");
		Utils.openDefBrowser(url);
	}

	//displays the help files by passing the help files path to the default browser
	private void WebSite()
	{
		String url = ("http://www.jpedit.co.uk/");

		Utils.userMessage("Attention", "Please make sure you have an internet connection", 2);

		Utils.openDefBrowser(url);
	}

// run ROOT on active file
        private void makeROOT()
        {
        String activefile=fileNames[selectedTabIndex()];
        if (activefile != null ) {
       // System.out.println("Debug: run root "+activefile);
       // setConsole("Wait.. \n executing root" + activefile );
         String ss="exec(\""+"root -l "+activefile+"\");";
         BeanShellconsole.Execute( ss );
        }
        }



// run PYTHON on active file
        private void makePYTHON()
        {
        String activefile=fileNames[selectedTabIndex()];
        if (activefile != null ) {
         String ss="exec(\""+"python "+activefile+"\");";
         BeanShellconsole.Execute( ss );
        }
        }


// run make
	private void makeAllRMC()
	{
              setConsole("Wait.. \n Compiling make -C " + dir );


                 String ss="exec(\""+"make -C "+dir+"\");";
                 // execute command 
                 BeanShellconsole.Execute( ss );
               /* 

               RunMake makermc = new RunMake(this, dir);
                                makeThread = new Thread(makermc);
                                makeThread.start();
                                this.repaint();
              */
	}



	//displays the find dialog box
	public void SearchMain()
	{
		sdlg.getSelectedText();
		Utils.centerComponent(sdlg);
		sdlg.setVisible(true);
		sdlg.selectText();
		repaint();
  }


	public void FindNext()
	{
  	sdlg.FindNext();
  }



	/*public void setNext(boolean b)
	{
		if (b)
		 jmiSearchNext.setEnabled(true);
		else
		 jmiSearchNext.setEnabled(false);
  }*/

	//displays the search and replace dialog box

	public void ReplaceMain()
	{
	  dlg.getSelectedText();
    Utils.centerComponent(dlg);
		dlg.setVisible(true);
		this.repaint();
  }

  //displays the find dialog box
	public void SearchRepNext()
	{
    dlg.FindNext();
  }


	//gets the text contained in the document
	public String GetText()
	{
		String s = new String();
		try{
			s = Editors[selectedTabIndex()].getDocument().getText(0, Editors[selectedTabIndex()].getDocument().getLength());
		}
		catch (Exception ex)
		{
			 System.out.println("Error getting document text " + ex.getMessage());
			 Utils.userMessage("Error", SYSTEM_ERROR, 1);
	     Utils.writeErrorLog("Error getting document text" + ex.getMessage());
		}

		return s;
	}

	//returns selected text as a string
	public String getSelectedText()
	{
		return Editors[selectedTabIndex()].getSelectedText();
	}

	//misc methods for use with the text component
	//gets focus for the text area
	public void RequestFocus()
	{
	  Editors[selectedTabIndex()].requestFocusInWindow();
	 }

	//grabs focus for the text area
	public void GrabFocus()
	{
		Editors[selectedTabIndex()].grabFocus();
	}

	//gets focus for the application
	public void JpeRequestFocus()
	{
		this.requestFocusInWindow();
	}

	//selects text from a to b
	public void Select(int a, int b)
	{
		Editors[selectedTabIndex()].select(a, b);
	}

	public int getSelectionStart()
	{
		return Editors[selectedTabIndex()].getSelectionStart();
	}

	public int getSelectionEnd()
	{
		return Editors[selectedTabIndex()].getSelectionEnd();
	}

	//sets the caret position
	public void SetCaretPos(int a)
	{
		Editors[selectedTabIndex()].setCaretPosition(a);
	}

	//replaces the current selection
	public void ReplaceSelection(String t)
	{
		Editors[selectedTabIndex()].setSelectedText(t);
	}

	//replaces the current selection
	public void setLine()
	{
		//Editors[selectedTabIndex()].setCaretPosition(Editors[selectedTabIndex()].getCaretPosition() + 2);
	}

	//*************************************************************************************************
	//                                    Font utils
	//*************************************************************************************************


	public void FontChooser()
	{
		//this needs to go here!
              //	FontDialog fdlg = new FontDialog(this);

                Font f = FontChooser.showDialog(this,
                                    "Choose font",
                                    this.getFont());

                if (f != null) {
                //  this.setFont(f);
                    this.setCurrentFont(f);
                 }
 
//		Utils.centerComponent(fdlg);
 //		fdlg.show();
	}


	//sets the font
	public void setCurrentFont(Font f)
	{
		Font font = f;
		Editors[selectedTabIndex()].getPainter().setFont(font);

		p.setProperty("jpe.font", new String(font.getName()) + ":" + new String(Integer.toString(font.getStyle())) + ":" + new String(Integer.toString(font.getSize())));

		fontChanged = true;
		Editors[selectedTabIndex()].getGutter().setFont(new Font("Monospaced", Font.BOLD , 11));
		Editors[selectedTabIndex()].updateScrollBars();
		updatePrefs();
	}


	//gets the current font
	public Font getFont()
	{
		return Editors[selectedTabIndex()].getPainter().getFont();
	}

	//***********************************************************************************************


  //kills the open process if the file is not found
	public void killOpen(boolean killOpen)
	{
		this.killOpen = killOpen;
	}

	//checks the document being opened and sets the syntax highlighting according
	//to the file extension
	private void checkDocType(String f)
	{
		if((f.endsWith(".txt"))||(f.endsWith(".TXT"))||(f.endsWith(".ini"))||(f.endsWith(".INI"))
			||(f.endsWith(".log"))||(f.endsWith(".LOG")))
		{
			Editors[selectedTabIndex()].setTokenMarker(null);
			txt.setSelected(true);
			syntaxType[selectedTabIndex()] = "txt";
		}

		else if((f.endsWith(".java"))||(f.endsWith(".JAVA")))
		{
			Editors[selectedTabIndex()].setTokenMarker(new JavaTokenMarker());
			jav.setSelected(true);
			syntaxType[selectedTabIndex()] = "jav";
		}


		else if((f.endsWith(".js"))||(f.endsWith(".JS")))
		{
			Editors[selectedTabIndex()].setTokenMarker(new JavaScriptTokenMarker());
			js.setSelected(true);
			syntaxType[selectedTabIndex()] = "js";
		}

	  else if((f.endsWith(".bat"))||(f.endsWith(".BAT")))
		{
			Editors[selectedTabIndex()].setTokenMarker(new BatchFileTokenMarker());
			bat.setSelected(true);
			syntaxType[selectedTabIndex()] = "bat";
		}

    else if((f.endsWith(".xml"))||(f.endsWith(".XML")))
		{
			Editors[selectedTabIndex()].setTokenMarker(new XMLTokenMarker());
			xml.setSelected(true);
			syntaxType[selectedTabIndex()] = "xml";
		}
   else if((f.endsWith(".cxx"))||(f.endsWith(".cpp"))||(f.endsWith(".cc"))||(f.endsWith(".c"))||(f.endsWith(".C"))  )
                {
                        Editors[selectedTabIndex()].setTokenMarker(new CXXTokenMarker());
                        cxx.setSelected(true);
                        syntaxType[selectedTabIndex()] = "cxx";
                }

   else if((f.endsWith(".prog")) )
                {
                        Editors[selectedTabIndex()].setTokenMarker(new ProgressTokenMarker());
                        prog.setSelected(true);
                        syntaxType[selectedTabIndex()] = "prog";
                }


    else if((f.endsWith(".html"))||(f.endsWith(".htm")) )
                {
                        Editors[selectedTabIndex()].setTokenMarker(new HTMLTokenMarker());
                        xhtml.setSelected(true);
                        syntaxType[selectedTabIndex()] = "xhtml";
                }

    else if((f.endsWith(".bib")))
                {
                        Editors[selectedTabIndex()].setTokenMarker(new BiBTokenMarker());
                        bibtex.setSelected(true);
                        syntaxType[selectedTabIndex()] = "bibtex";
                }

   else if((f.endsWith(".php")) )
                {
                        Editors[selectedTabIndex()].setTokenMarker(new PHPTokenMarker());
                        php.setSelected(true);
                        syntaxType[selectedTabIndex()] = "php";
                }

    else if((f.endsWith(".Py")) )
                {
                        Editors[selectedTabIndex()].setTokenMarker(new PythonTokenMarker());
                        python.setSelected(true);
                        syntaxType[selectedTabIndex()] = "python";
                }
   else if((f.endsWith(".py")) )
                {
                        Editors[selectedTabIndex()].setTokenMarker(new PythonRootTokenMarker());
                        pythonRoot.setSelected(true);
                        syntaxType[selectedTabIndex()] = "pythonRoot";
                }

    else if((f.endsWith(".sh"))||(f.endsWith(".bashrc"))||(f.endsWith(".cshrc"))||(f.endsWith(".zshrc")) )
                {
                        Editors[selectedTabIndex()].setTokenMarker(new ShellScriptTokenMarker());
                        shell.setSelected(true);
                        syntaxType[selectedTabIndex()] = "shell";
                }

    else if((f.endsWith("Makefile"))||(f.endsWith("makefile"))||
            (f.startsWith("makefile"))||(f.startsWith("Makefile"))||(f.endsWith(".mc"))  ) 
                {
                        Editors[selectedTabIndex()].setTokenMarker(new  MakefileTokenMarker());
                        make.setSelected(true);
                        syntaxType[selectedTabIndex()] = "makefile";
                }
     else if((f.endsWith(".f"))||(f.endsWith(".F"))||(f.endsWith(".fpp")) )
                {
                        Editors[selectedTabIndex()].setTokenMarker(new FortranTokenMarker());
                        fortran.setSelected(true);
                        syntaxType[selectedTabIndex()] = "fortran";
                }
     else if((f.endsWith(".tex"))||(f.endsWith(".TEX")) )
                {
                        Editors[selectedTabIndex()].setTokenMarker(new TeXTokenMarker());
                        latex.setSelected(true);
                        syntaxType[selectedTabIndex()] = "latex";
                }
      else if((f.endsWith(".kumac"))||(f.endsWith(".KUMAC")) )
                {
                        Editors[selectedTabIndex()].setTokenMarker(new KumacTokenMarker());
                        kumac.setSelected(true);
                        syntaxType[selectedTabIndex()] = "kumac";
                }


		else
		{
			Editors[selectedTabIndex()].setTokenMarker(null);
			txt.setSelected(true);
			syntaxType[selectedTabIndex()] = "txt";
		}
	}

	// Open file (no parameters)
	public void open()
	{
		File f[] = new File[99];

		if (fileNames[selectedTabIndex()] == null || (fileNames[selectedTabIndex()] ==""))
		{
			jFileChooser.setCurrentDirectory(new File(dir));
		}
		else
		{
			jFileChooser.setCurrentDirectory(new File(fileNames[selectedTabIndex()]).getParentFile());
		}


		jFileChooser.setMultiSelectionEnabled(true);
		jFileChooser.setFont(SYSTEM_FONT);

		if (jFileChooser.showOpenDialog(this) == JFileChooser.APPROVE_OPTION)
		{
		  f = jFileChooser.getSelectedFiles();

		  if (f.length >=99 - tabCount())
		  {
			  Utils.userMessage("File limit reached", "File opening limit of 99 exceeded!", 1);
			  return;
		  }
		  else
		  {
			  for(int i = 0; i < f.length; i++)
			  {
				  open(f[i].getPath());
			  }
		  }

		}

		this.repaint();
	}


	//open file (string param)
	public void open(String f)
	{
		if (tabCount() <= 98)
		{
			if (!firstTime)
			{
				addTab(f);
			}

			checkDocType(f);

			Open openFile = new Open(this, f, readonlynotify);

			if(!killOpen)
			{
				fileNames[selectedTabIndex()] = f;
				currFileTypes[selectedTabIndex()] = new File(fileNames[selectedTabIndex()]);
				fileModified[selectedTabIndex()] = currFileTypes[selectedTabIndex()].lastModified();
				dirty[selectedTabIndex()] = false;

				readOnly[selectedTabIndex()] = Utils.isReadOnly(f);

				checkReadOnly();

				updateCaption();
				changeTabIcon();
				undoManager();

				if((!isjpeDoc) && (!firstRun))
				{
					saveRecents(fileNames[selectedTabIndex()]);
				}

				setTextCursor();
				isjpeDoc = false;

				Editors[selectedTabIndex()].setCaretPosition(a);
				Editors[selectedTabIndex()].grabFocus();


				firstTime = false;
				firstRun = false;
				killOpen = false;
			}

			else
			{
				killOpen = false;
				if (tabCount() > 1)
				{
					removeTab();
				}

        Editors[selectedTabIndex()].grabFocus();
	    }

	     Editors[selectedTabIndex()].grabFocus();
		}
		else
		{
			Utils.userMessage("Document limit reached", "Limit of 999 open documents reached", 2);
		}

  }



	//places text into the text area
	public void loadDoc(String s)
	{
		Editors[selectedTabIndex()].setText(s);
	}

	//places text into the text area
		public void setText(String s)
		{
			Editors[selectedTabIndex()].setText(s);
	}

	//places text into the text area
	public String getText()
	{
		return Editors[selectedTabIndex()].getText();
	}



	//method for creating a new document
	public void newDoc()
	{
    if(tabCount() <= 98)
    {
			addTab("Untitled");
			fileNames[selectedTabIndex()] = null;
			currFileTypes[selectedTabIndex()] = new File("");
			fileModified[selectedTabIndex()] = 0;
			syntaxType[selectedTabIndex()] = "cpp";
			undoManager();
			//undo.discardAllEdits();
	  }
	  else
	  {
			Utils.userMessage("Document limit reached", "Limit of 99 open documents reached", 2);
	  }
	}

	//method used to close files - also resets undo manager
	public void close(String all)
	{
		//unLockFile();

		if (all.equals("All"))
		{
			if (tabCount() == 1)
			{
				try
				{
					Editors[selectedTabIndex()].getDocument().remove(0, Editors[selectedTabIndex()].getDocument().getLength());
				}
				catch (Exception ex)
				{
					System.out.println("Error closing document " + ex.getMessage());
					Utils.userMessage("Error", SYSTEM_ERROR, 1);
					Utils.writeErrorLog("Error closing document " + ex.getMessage());
				}

				untitled = 1;
				dirty[selectedTabIndex()] = false;
				readOnly[selectedTabIndex()] = false;
				fileNames[selectedTabIndex()] = null;
				fileModified[selectedTabIndex()] = 0;
				updateCaption();
				changeTabIcon();
				setUndoRedo();
				undoManager();
				//undo.discardAllEdits();
				firstTime = true;
				Editors[selectedTabIndex()].setCaretPosition(a);
				Editors[selectedTabIndex()].grabFocus();
			}

		  else if (selectedTabIndex() == EditCount)
			{
				removeTab();
				//Editors[selectedTabIndex()].setCaretPosition(a);
				setUndoRedo();
				updateCursorPos();
			}

		  else
      {

			  for(int i = selectedTabIndex(); i < EditCount; i++)
		    {
			    Editors[i]          =  Editors[i + 1];
			    dirty[i]            =  dirty[i + 1];
			    readOnly[i]         =  readOnly[i + 1];
			    fileNames[i]        =  fileNames[i + 1];
			    fileModified[i]     =  fileModified[i + 1];
			    currFileTypes[i]    =  currFileTypes[i + 1];
			    undo[i]             =  undo[i + 1];
			    bm[i]               =  bm[i + 1];
			    cl[i]               =  cl[i + 1];
			    bmToolTip[i]        =  bmToolTip[i + 1];
			    clToolTip[i]        =  clToolTip[i + 1];
			    currentCursorPos[i] =  currentCursorPos[i + 1];
			  }

			  updateCaption();
			  changeTabIcon();
			  setUndoRedo();

			  //selectedTabIndex(tabCount());
        removeTab();
        //Editors[selectedTabIndex()].setCaretPosition(a);
		    updateCursorPos();

			}
		}
		else
		{
      if (Utils.okToAbandon(dirty[selectedTabIndex()], readOnly[selectedTabIndex()], fileNames[selectedTabIndex()], jtp.getTitleAt(selectedTabIndex())))
      {
		    if (tabCount() == 1)
        {
				  try
				  {
						Editors[selectedTabIndex()].getDocument().remove(0, Editors[selectedTabIndex()].getDocument().getLength());
				  }
			    catch (Exception ex)
			    {
			    	System.out.println("Error closing document " + ex.getMessage());
						Utils.userMessage("Error", SYSTEM_ERROR, 1);
				    Utils.writeErrorLog("Error closing document " + ex.getMessage());
			    }

					untitled = 1;
					dirty[selectedTabIndex()] = false;
					readOnly[selectedTabIndex()] = false;
					fileNames[selectedTabIndex()] = null;
					fileModified[selectedTabIndex()] = 0;
					updateCaption();
					changeTabIcon();
					setUndoRedo();
					undoManager();
					//undo.discardAllEdits();
					firstTime = true;
					Editors[selectedTabIndex()].setCaretPosition(a);
					Editors[selectedTabIndex()].grabFocus();
		    }

		    else if (selectedTabIndex() == EditCount)
			  {
		       removeTab();
		       setUndoRedo();
		       //Editors[selectedTabIndex()].setCaretPosition(a);
		       updateCursorPos();
			  }

		    else
        {
			    for(int i = selectedTabIndex(); i < EditCount; i++)
		      {
						Editors[i]          =  Editors[i + 1];
						dirty[i]            =  dirty[i + 1];
						readOnly[i]         =  readOnly[i + 1];
						fileNames[i]        =  fileNames[i + 1];
						fileModified[i]     =  fileModified[i + 1];
						currFileTypes[i]    =  currFileTypes[i + 1];
						undo[i]             =  undo[i + 1];
						bm[i]               =  bm[i + 1];
						cl[i]               =  cl[i + 1];
						bmToolTip[i]        =  bmToolTip[i + 1];
						clToolTip[i]        =  clToolTip[i + 1];
						currentCursorPos[i] =  currentCursorPos[i + 1];
					}

					updateCaption();
					changeTabIcon();
					setUndoRedo();


					//selectedTabIndex(tabCount());
					removeTab();
					//Editors[selectedTabIndex()].setCaretPosition(a);
					updateCursorPos();
			  }
	    }
		}
	}


  //sets the current file name
	public void setcurrFileName(String s)
	{
		fileNames[selectedTabIndex()] = s;
	}


	// Save file
	public boolean save()
	{
		boolean temp = checkfilemod;

		if(Utils.okToOverwrite(fileNames[selectedTabIndex()], currFileTypes[selectedTabIndex()]))
		{
			SaveFile savefile = new SaveFile(this, fileNames[selectedTabIndex()], Editors[selectedTabIndex()].getDocument());

			dirty[selectedTabIndex()] = false;
			readOnly[selectedTabIndex()] = false;
		  updateLineCount();
			saveRecents(fileNames[selectedTabIndex()]);
			currFileTypes[selectedTabIndex()] = new File(fileNames[selectedTabIndex()]);
			fileModified[selectedTabIndex()] = currFileTypes[selectedTabIndex()].lastModified();
			setTextCursor();
			updateCaption();
	    changeTabIcon();
	    setProject();
	    updateSyntaxType();
	    checkfilemod = false;
	    checkDocType(fileNames[selectedTabIndex()]);
	    checkfilemod = temp;
			Editors[selectedTabIndex()].grabFocus();
			//jtp.requestFocusInWindow();
			return true;
		}


    Editors[selectedTabIndex()].grabFocus();
		return false;

	}

	//save file as
	public boolean saveAsFile()
	{

                 File sff= new File(dir);
                jChooser.setCurrentDirectory(sff); 
		jChooser.setDialogTitle("Save " + jtp.getToolTipTextAt(selectedTabIndex()) + " As...");
		jChooser.setApproveButtonText("Save");
		jChooser.setSelectedFile(new File(jtp.getToolTipTextAt(selectedTabIndex())));
		jChooser.setFont(SYSTEM_FONT);

		if (JFileChooser.APPROVE_OPTION == jChooser.showSaveDialog(this)) {

			fileNames[selectedTabIndex()] = jChooser.getSelectedFile().getPath();

			this.repaint();
			Editors[selectedTabIndex()].grabFocus();
			return save();
		}
		else
		{
			this.repaint();
			Editors[selectedTabIndex()].grabFocus();
			return false;
		}
	}

	//allows files to be zipped to disk
	private void saveZipFile()
	{
		ZipAs zipas = new ZipAs(this, fileNames[selectedTabIndex()], Editors[selectedTabIndex()].getDocument());
	}


	//displays the about box
	public void About()
	{
		About dlg = new About();
	}

	//displays the info dialog box
	private void Info()
	{
		Info info = new Info(this);
	}


	//methods used by the document listener interface
  public void doc_changed(DocumentEvent e)
  {
		if (!fontChanged)
		{
			if (!dirty[selectedTabIndex()])
			{
				dirty[selectedTabIndex()] = true;
				changeTabIcon();

				fontChanged = false;
				firstTime = false;
			}
		}

		else fontChanged = true;
	}

	public void doc_insert(DocumentEvent e)
	{
		if (!dirty[selectedTabIndex()])
		{
			dirty[selectedTabIndex()] = true;
			changeTabIcon();
		}

		firstTime = false;
	}

	public void doc_remove(DocumentEvent e)
	{
		if (!dirty[selectedTabIndex()])
		{
			dirty[selectedTabIndex()] = true;
			changeTabIcon();
		}

		firstTime = false;
	}

	public mbJTextArea getEditor()
	{
		return Editors[selectedTabIndex()];
	}


	//This class listens for and reports caret movements.
	protected class CaretListenerLabel extends JLabel implements CaretListener
	{
		public CaretListenerLabel ()
		{
			super();
		}

		public void caretUpdate(CaretEvent e)
		{
			//updateLineCount();
			currentCursorPos[selectedTabIndex()] = Editors[selectedTabIndex()].getCaretPosition();

			int a    = Editors[selectedTabIndex()].getLineStartOffset(Editors[selectedTabIndex()].getLineOfOffset(Editors[selectedTabIndex()].getCaretPosition()));
			int a1   = Editors[selectedTabIndex()].getLineEndOffset(Editors[selectedTabIndex()].getLineOfOffset(Editors[selectedTabIndex()].getCaretPosition()));
			int b    = Editors[selectedTabIndex()].getLineOfOffset(Editors[selectedTabIndex()].getCaretPosition());
			int c    = Editors[selectedTabIndex()].getCaretPosition();
			int d    = Editors[selectedTabIndex()].getLineLength(b);
			String s = Editors[selectedTabIndex()].getLineText(Editors[selectedTabIndex()].getLineOfOffset(Editors[selectedTabIndex()].getCaretPosition()));

			int col   = c - a;
			int chars  = a1 - col;

      setCoStatus("Line: " + new String(Integer.toString(b + 1)) + " of " + new String(Integer.toString(Editors[selectedTabIndex()].getLineCount())) +  " |  Col: " + new String(Integer.toString(col)) + "  |  Char: " + new String(Integer.toString(c)));

		}
	}

  public int getCaretLine()
  {
		return Editors[selectedTabIndex()].getLineOfOffset(Editors[selectedTabIndex()].getCaretPosition());
	}


	public int getSelectionStartLine()
	{
		return Editors[selectedTabIndex()].getSelectionStartLine();
	}

	public int getSelectionEndLine()
	{
		return Editors[selectedTabIndex()].getSelectionEndLine();
	}


	public void setSelectedText(String s)
	{
		Editors[selectedTabIndex()].setSelectedText(s);
	}

	public int getCaretPosition()
	{
		return Editors[selectedTabIndex()].getCaretPosition();
	}



	private void undoManager()
	{
	  jbtUndo.setEnabled(false);
		jbtRedo.setEnabled(false);
		jmiUndo.setEnabled(false);
		jmiUndoAll.setEnabled(false);
		jmiRedo.setEnabled(false);
		jmiRedoAll.setEnabled(false);
		jmiPopUndo.setEnabled(false);
		jmiPopRedo.setEnabled(false);
		undo[selectedTabIndex()].discardAllEdits();
	}


	private void setUndoRedo()
	{
		if (undo[selectedTabIndex()].canUndo())
	    {
				jbtUndo.setEnabled(true);
				jmiUndo.setEnabled(true);
				jmiUndoAll.setEnabled(true);
				jmiPopUndo.setEnabled(true);

	    }
	    else
	    {
				jbtUndo.setEnabled(false);
				jmiUndo.setEnabled(false);
				jmiUndoAll.setEnabled(false);
				jmiPopUndo.setEnabled(false);
	    }


	    if (undo[selectedTabIndex()].canRedo())
	    {
				jbtRedo.setEnabled(true);
				jmiRedo.setEnabled(true);
				jmiRedoAll.setEnabled(true);
				jmiPopRedo.setEnabled(true);

	    }
	    else
	    {
				jbtRedo.setEnabled(false);
				jmiRedo.setEnabled(false);
				jmiRedoAll.setEnabled(false);
				jmiPopRedo.setEnabled(false);
	    }

	}

	public void UndoAll()
	{
		do
		{
			Undo();
		} while (undo[selectedTabIndex()].canUndo());

		jbtUndo.setEnabled(false);
		jmiUndo.setEnabled(false);
		jmiUndoAll.setEnabled(false);
		jmiPopUndo.setEnabled(false);
		//undo[selectedTabIndex()].discardAllEdits();
	}

	public void RedoAll()
	{
		do
		{
			Redo();
		} while (undo[selectedTabIndex()].canRedo());

		jbtRedo.setEnabled(false);
	  jmiRedoAll.setEnabled(false);
		jmiRedo.setEnabled(false);
		jmiPopRedo.setEnabled(false);
		//undo[selectedTabIndex()].discardAllEdits();
	}


  //un-does the last action
	public void Undo()
	{
		if (undo[selectedTabIndex()].canUndo())
		{
			undo[selectedTabIndex()].undo();
			jbtRedo.setEnabled(true);
			jmiRedo.setEnabled(true);
			jmiRedoAll.setEnabled(true);
			jmiPopRedo.setEnabled(true);

		}
		else
		{
			jbtUndo.setEnabled(false);
			jmiUndo.setEnabled(false);
			jmiUndoAll.setEnabled(false);
			jmiPopUndo.setEnabled(false);
			Utils.userMessage("Undo", "No more Undos", 1);
		}

		Editors[selectedTabIndex()].grabFocus();

	}

	//re-does the last action
	public void Redo()
	{
		if (undo[selectedTabIndex()].canRedo())
	    {
				undo[selectedTabIndex()].redo();
				jbtUndo.setEnabled(true);
				jmiUndo.setEnabled(true);
				jmiUndoAll.setEnabled(true);
				jmiPopUndo.setEnabled(true);

	    }
	    else
	    {
				jbtRedo.setEnabled(false);
				jmiRedo.setEnabled(false);
				jmiRedoAll.setEnabled(false);
				jmiPopRedo.setEnabled(false);
				Utils.userMessage("Undo", "No more Redos", 1);
	    }

		Editors[selectedTabIndex()].grabFocus();

	}


	//undoableEditHappened called when edit happened
	public void undoableEditHappened(UndoableEditEvent e)
	{
		//add the edits to the undo manager
		undo[selectedTabIndex()].addEdit(e.getEdit());
		jbtUndo.setEnabled(true);
		jmiUndo.setEnabled(true);
		jmiUndoAll.setEnabled(true);
		jmiPopUndo.setEnabled(true);
	}

	public void Paste()
	{
		Editors[selectedTabIndex()].paste();
	}

	public void selectAll()
	{
		Editors[selectedTabIndex()].selectAll();
	}


	public void checkFileModified()
  {
		File f = null;

	  try
	  {
			if (fileNames[selectedTabIndex()].equals("") || fileNames[selectedTabIndex()] == null)
			{
				return;
			}

			f = new File(fileNames[selectedTabIndex()]);
		}
		catch (Exception e)
		{
			return;
		}


		long lastmod;
		Time modTime, fileModTime;

		//Utils.userMessage("File Name", f.getName().toString(), 2);

		if (f.exists())
		{
			lastmod = f.lastModified();
			modTime = new Time(lastmod); // currents file mod time
			fileModTime = new Time(fileModified[selectedTabIndex()]); // stored last editor filemod time.

			//Utils.userMessage("File Modified", "FileMod: " + modTime.toString() + " Editor Mod: " + fileModTime.toString(), 2);

			if (!(modTime.equals(fileModTime)))
			{
				if(Utils.genericConfirm("This file has been modified outside of this application, Reload?", "File Modified"))
				{
					refreshCurrentDoc(f);
				}
				else
				{
					fileModified[selectedTabIndex()] = f.lastModified();
				}
			}
		}
	}


	public void refreshCurrentDoc(File f)
	{
		if (f.exists())
		{
			int a = Editors[selectedTabIndex()].getCaretPosition();
			//Utils.userMessage("Reloading", "Reloading", 2);
			firstTime = true;
			open(fileNames[selectedTabIndex()]);
			fileModified[selectedTabIndex()] = f.lastModified();
			firstTime = false;
		  Editors[selectedTabIndex()].setCaretPosition(a);
		}
	}


	public class file implements ActionListener
	{
		public void actionPerformed(ActionEvent evt)
		{
			fileMenu.doClick(1);
    }
	}

	public class edit implements ActionListener
	{
		public void actionPerformed(ActionEvent evt)
		{
			editMenu.doClick(1);
    }
	}

	public class view implements ActionListener
	{
		public void actionPerformed(ActionEvent evt)
		{
			viewMenu.doClick(1);
    }
	}

	public class search implements ActionListener
	{
		public void actionPerformed(ActionEvent evt)
		{
			searchMenu.doClick(1);
    }
	}

	public class prefs implements ActionListener
	{
		public void actionPerformed(ActionEvent evt)
		{
			prefsMenu.doClick(1);
    }
	}

	public class jdk implements ActionListener
	{
		public void actionPerformed(ActionEvent evt)
		{
			jdkMenu.doClick(1);
    }
	}

	public class tools implements ActionListener
	{
		public void actionPerformed(ActionEvent evt)
		{
			toolsMenu.doClick(1);
    }
	}

	public class proj implements ActionListener
	{
		public void actionPerformed(ActionEvent evt)
		{
			projectMenu.doClick(1);
    }
	}

	public class timerAction implements ActionListener
	{
		public void actionPerformed(ActionEvent evt)
		{

			if (jbtSave.isEnabled())
			{
				jbtSave.doClick(1);
			}
		}
	}

	public class modAction implements ActionListener
	{
		public void actionPerformed(ActionEvent evt)
		{

			//Utils.userMessage("In modAction", "In modAction", 2);
			if(checkfilemod)
			{
				//Utils.userMessage("checkmodfile", "checkmodfile = true", 2);
				checkFileModified();
			}
		}
	}




} //program end







