/* This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/



//WordCount.java - a class for counting the words, lines and characters in a document
//(C)2000-2001 Mark Beynon
//mark@jpedit.co.uk
//http://www.jpedit.co.uk

package com.utils;



import java.awt.*;
import javax.swing.*;
import java.io.*;
import javax.swing.text.*;

import com.jpe.*;



public class WordCount
{

	public WordCount(jpe win, Document doc2)
	{
		super();
		this.win = win;

		run(doc2);

	}

	public void run(Document doc2)
	{

		String text = new String();
	  try
		{
			text = doc2.getText(0,doc2.getLength());
		}
		catch (Exception e)
		{
			win.setStatus("Error counting words");
		}

    char[] chars = text.toCharArray();
		int characters = chars.length;
		int words;
		if(characters == 0)
			words = 0;
		else
			words = 1;
		int lines = 1;
		boolean word = false;
		for(int i = 0; i < chars.length; i++)
		{
			switch(chars[i])
			{
			case '\r': case '\n':
				lines++;
			case ' ': case '\t':
				if(word)
				{
					words++;
					word = false;
				}
				break;
			default:
				word = true;
				break;
			}
		}


		String dialogtitle = "Word Count";
		String[] dialogmessage = {"Words: "+words, "lines: "+ lines, "Characters: "+ characters};
		int dialogtype = JOptionPane.INFORMATION_MESSAGE;
		JOptionPane.showMessageDialog((jpe) null,
			dialogmessage, dialogtitle, dialogtype);

  }




	private jpe win;



}




